SystemOrganization addCategory: #RWMooseDiagram!
SystemOrganization addCategory: #'RWMooseDiagram-appearance'!
SystemOrganization addCategory: #'RWMooseDiagram-editor'!
SystemOrganization addCategory: #'RWMooseDiagram-frontend'!
SystemOrganization addCategory: #'RWMooseDiagram-test'!
SystemOrganization addCategory: #'RWMooseDiagram-testApplication'!

Morph subclass: #RWDiagramSimpleGui
	instanceVariableNames: 'myColor lastLayout'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'RWMooseDiagram-frontend'!

!RWDiagramSimpleGui class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
getInstance
	instance ifNil: [ instance := RWDiagramSimpleGui new ].
	^ instance! !

!RWDiagramSimpleGui class methodsFor: 'instance creation' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
open
	instance ifNotNil: [ instance delete ].
	instance := RWDiagramSimpleGui new.
	instance openInWorld! !

!RWDiagramSimpleGui class methodsFor: 'instance creation' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refresh
	instance := nil! !

!RWDiagramSimpleGui methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
drawOn: aCanvas
	"comment stating purpose of message"

	| line |
	line := 2.
	aCanvas fillRectangle: self bounds color: myColor.
	aCanvas drawString: 'Size' at: self position + (10 @ line).
	aCanvas drawString: RWDiagramEditor uniqueInstance currentLayout elementGroup elementList size asString at: self position + (45 @ line).
	aCanvas drawString: 'Layout' at: self position + (100 @ line).
	aCanvas drawString: RWDiagramEditor uniqueInstance currentLayoutName at: self position + (150 @ line).
	aCanvas drawString: 'Moose2Model Simple Gui' at: self position + (850 @ line).
	line := line + 20.
	aCanvas drawString: 'Path' at: self position + (100 @ line).
	aCanvas drawString: RWDiagram path at: self position + (150 @ line).
	aCanvas drawString: RWDiagram new actualVersion at: self position + (850 @ line).! !

!RWDiagramSimpleGui methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
	super initialize.
	myColor := Color lightGreen.
	lastLayout := 'Not yet set'.
	self extent: 1000 @ 43! !

!RWDiagramSimpleGui methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
redrawMe
	self hide.
	self show! !

Error subclass: #RWDiagramError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramError commentStamp: 'RainerWinkler 8/19/2016 22:22' prior: 0!
General errors.!

RWDiagramError subclass: #RWDiagramElementWrongTypeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

RWDiagramError subclass: #RWDiagramReplaceUndefined
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

TestCase subclass: #RWDiagramAbstractTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAbstractTest commentStamp: 'RainerWinkler 8/29/2019 08:31' prior: 0!
This is the main super class for tests in the old namespace. It sets and unsets the flag that automatic tests are active.!

RWDiagramAbstractTest subclass: #RWDiagramAbstractAttributesLayoutChangerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAbstractAttributesLayoutChangerTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testCurrentLayout
	| lc l |
	lc := RWDiagramAbstractAttributesLayoutChanger new.
	l := RWDiagramLayout new.
	l moose2ModelName: 'Test'.
	lc currentLayout2: l.
	self assert: lc currentLayout2 moose2ModelName equals: 'Test'! !

RWDiagramAbstractTest subclass: #RWDiagramAbstractCommentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAbstractCommentTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testText
	| c |
	c := RWDiagramLocalComment text: 'A comment'.
	self assert: c text equals: 'A comment'.
	c := RWDiagramLocalComment new.
	c text: 'A comment 2'.
	self assert: c text equals: 'A comment 2'.
	c text: 'A<br>B'.
	self assert: c text equals: 'A',String crlf, 'B'.
	c text: 'A-Linebreak-B'.
	self assert: c text equals: 'A',String crlf, 'B'! !

!RWDiagramAbstractCommentTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testTextXML
	| c |
	c := RWDiagramLocalComment text: 'A<br>B'.
	self assert: c textXML equals: 'A<br>B'! !

!RWDiagramAbstractCommentTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testUniqueKeyOfCommentedElement
	| c |
	c := RWDiagramAbstractComment new.
	c uniqueKeyOfCommentedElement: '1'.
	self assert: c uniqueKeyOfCommentedElement equals: '1'! !

!RWDiagramAbstractTest methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setUp
	super setUp.
	RWDiagram automaticTestIsRunning: true "Needed to prevent pop ups during tests"! !

!RWDiagramAbstractTest methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
tearDown
	super tearDown.
	RWDiagram automaticTestIsRunning: false! !

RWDiagramAbstractTest subclass: #RWDiagramAppearanceChangeDeterminerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAppearanceChangeDeterminerTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAppearanceChangeDeterminer
|act|
act := RWDiagramAppearanceChangeDeterminer new.
self assert: act class asString equals: 'RWDiagramAppearanceChangeDeterminer' ! !

RWDiagramAbstractTest subclass: #RWDiagramAppearanceChangeTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAppearanceChangeTypeTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAppearanceChangeType
|act|
act := RWDiagramAppearanceChangeType new.
self assert: act class asString equals: 'RWDiagramAppearanceChangeType' ! !

RWDiagramAbstractTest subclass: #RWDiagramAppearanceChangerGroupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAppearanceChangerGroupTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAppearentChangers
|acg ac|
acg := RWDiagramAppearanceChangerGroup new.
self assert: acg appearanceChangers size equals: 0.

ac := RWDiagramAppearanceChanger new.
acg addAppearentChanger: ac.
self assert: acg appearanceChangers size equals: 1.
! !

!RWDiagramAppearanceChangerGroupTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAppearentChangersNoDuplicate
"Prevent duplicate appearance changers"
|acg ac cd ac2|
acg := RWDiagramAppearanceChangerGroup new.
self assert: acg appearanceChangers size equals: 0.

ac := RWDiagramAppearanceChanger new.
cd := RWDiagramACDStandard new.
acg addAppearentChanger: ac.
self assert: acg appearanceChangers size equals: 1.

ac2 := RWDiagramAppearanceChanger new.
cd := RWDiagramACDStandard new.
acg addAppearentChanger: ac2.
self assert: acg appearanceChangers size equals: 1.
! !

!RWDiagramAppearanceChangerGroupTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testRemoveTemporary
	| acg ac |
	ac := RWDiagramAppearanceChanger new.
	ac changeType: RWDiagramACTHighlight new.
	acg := RWDiagramAppearanceChangerGroup new.
	acg addAppearentChanger: ac.
	acg removeTemporary.
	self assert: acg appearanceChangers size equals: 0! !

RWDiagramAbstractTest subclass: #RWDiagramAppearanceChangerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAppearanceChangerTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAppearanceChanger
|ac|
ac := RWDiagramAppearanceChanger new.
self assert: ac class asString equals: 'RWDiagramAppearanceChanger'! !

!RWDiagramAppearanceChangerTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testChangeDeterminer
|ac|
ac := RWDiagramAppearanceChanger new.
ac changeDeterminer: RWDiagramAppearanceChangeDeterminer new.
self assert: ac changeDeterminer class asString equals: 'RWDiagramAppearanceChangeDeterminer'! !

!RWDiagramAppearanceChangerTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testChangeType
|ac|
ac := RWDiagramAppearanceChanger new.
ac changeType: RWDiagramAppearanceChangeType new.
self assert: ac changeType class asString equals: 'RWDiagramAppearanceChangeType'! !

RWDiagramAbstractTest subclass: #RWDiagramAppearanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAppearanceTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testChange
	| a ac |
	a := RWDiagramAppearance new.
	ac := RWDiagramACTHighlight new.
	a change: ac.
	self assert: a highlight equals: true! !

RWDiagramAbstractTest subclass: #RWDiagramAttributeListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAppearance
	| a |
	a := RWDiagramAttributeList new.
	self assert: a appearance appearenceIsSpecified equals: false.
	a appearance: RWDiagramAppearance new.
	self assert: a appearance class asString equals: 'RWDiagramAppearance'! !

!RWDiagramAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAppearanceChangerGroup
	| a ac |
	a := RWDiagramAttributeList new.
	self
		assert: a appearanceChangerGroup appearanceChangers size
		equals: 0.
	ac := RWDiagramAppearanceChanger new.
	a appearanceChangerGroup addAppearentChanger: ac.
	self
		assert: a appearanceChangerGroup appearanceChangers size
		equals: 1! !

!RWDiagramAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAttributeIsSpecified
	| ga |
	ga := RWDiagramAttributeList new.
	self assert: ga attributeIsSpecified equals: true! !

!RWDiagramAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testComment
	| a co |
	a := RWDiagramAttributeList new.
	co := RWDiagramLocalComment text: 'A comment'.
	a comment: co.
	self assert: a comment equals: co! !

!RWDiagramAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testPosition
	| a |
	a := RWDiagramAttributeList new.
	a position: 10 @ 10.
	self assert: a position point equals: 10 @ 10! !

!RWDiagramAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testRemoveAppearanceChangerGroup
	| a ac |
	a := RWDiagramAttributeList new.
	self
		assert: a appearanceChangerGroup appearanceChangers size
		equals: 0.
	ac := RWDiagramAppearanceChanger new.
	a appearanceChangerGroup addAppearentChanger: ac.
	self
		assert: a appearanceChangerGroup appearanceChangers size
		equals: 1.
		
	a removeAppearanceChangerGroup.
			self assert: a appearanceChangerGroup appearanceChangers size
		equals: 0! !

!RWDiagramAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSuppresWithChildren
	| a |
	a := RWDiagramAttributeList new suppressWithChildren: true.
	self assert: a suppressWithChildren equals: true! !

!RWDiagramAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSuppressWithChildren
	| a |
	a := RWDiagramAttributeList new.
	self assert: a suppressWithChildren equals: false.
	a := RWDiagramAttributeList new suppressWithChildren: true.
	self assert: a suppressWithChildren equals: true! !

RWDiagramAbstractTest subclass: #RWDiagramGlobalAttributeListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramGlobalAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAddComment
	| ga |
	ga := RWDiagramGlobalAttributeList new.
	ga addComment: (RWDiagramGlobalComment text: 'Test').
	self assert: ga comments first text equals: 'Test'! !

!RWDiagramGlobalAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAttributeIsSpecified
	| ga |
	ga := RWDiagramGlobalAttributeList new.
	self assert: ga attributeIsSpecified equals: true! !

!RWDiagramGlobalAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testComments
	| ga |
	ga := RWDiagramGlobalAttributeList new.
	self assert: ga comments size equals: 0.
	ga addComment: (RWDiagramGlobalComment text: 'Test').
	self assert: ga comments first text equals: 'Test'! !

RWDiagramAbstractTest subclass: #RWDiagramGlobalCommentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramGlobalCommentTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testId
	| gc1 |
	gc1 := RWDiagramGlobalComment id: 'A'.
	self assert: gc1 id equals: 'A'! !

!RWDiagramGlobalCommentTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testInitialize
  | gc1 gc2 |
gc1 := RWDiagramGlobalComment text: 'A'.
gc2 := RWDiagramGlobalComment text: 'B'.
self assert: gc1 id = gc2 id equals: false
! !

RWDiagramAbstractTest subclass: #RWDiagramLCPreventOverlappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramLCPreventOverlappingTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testMaxChecks
| lcPO |
lcPO := RWDiagramLCPreventOverlapping new.
self assert: lcPO maxChecks equals: 0.
lcPO maxChecks: 5.
self assert: lcPO maxChecks equals: 5! !

!RWDiagramLCPreventOverlappingTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testRepeat
| lcPO |
lcPO := RWDiagramLCPreventOverlapping new.
self assert: lcPO repeat equals: 1.
lcPO repeat: 5.
self assert: lcPO repeat equals: 5! !

!RWDiagramLCPreventOverlappingTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSpace
| lcPO |
lcPO := RWDiagramLCPreventOverlapping new.
self assert: lcPO space equals: 0.
lcPO space: 5.
self assert: lcPO space equals: 5! !

!RWDiagramLCPreventOverlappingTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testpreventOverlappingsMessages
	| v e s lcPO movedElements |
	v := RTView new.
	"First element"
	e := RTElement new.
	s := RTBox new.
	s
		width: 100;
		height: 20.
	e addShape: s.
	e model: (RWDiagramElement famixElement: (FAMIXMethod new)).
	e model famixElement name: 'A'.
	e translateTo: 10 @ 10.
	v add: e.
	"Second element on same position"
	e := RTElement new.
	s := RTBox new.
	s
		width: 100;
		height: 10.
	e addShape: s.
	e model: (RWDiagramElement famixElement: (FAMIXAttribute new)).
	e model famixElement moose2ModelName: 'B'.
	e translateTo: 10 @ 20.
	v add: e.
	"Adapt position"
	lcPO := RWDiagramLCPreventOverlapping new.
	lcPO space: 3.
	lcPO maxChecks: 100.
	lcPO preventOverlappings: v messages: false.
	movedElements := v elements select: [ :each | (each position = (10 @ 10)) not and: (each position = (10 @ 20)) not ].
	self assert: movedElements size equals: 1.
	"Move higher by half of the first heigt (20/2), half of the second heigt (10/2) and by the required space (3)"
	movedElements
		do: [ :each | 
			each model famixElement moose2ModelName = 'B'
				ifTrue: [ self assert: each position equals: 10 @ 28 ]
				ifFalse: [ self assert: each position equals: 10 @ 38 ] ].
	"Do not move if the elements are in X-direction sufficiently separated"
	"First element"
	v := RTView new.
	e := RTElement new.
	s := RTBox new.
	s
		width: 100;
		height: 20.
	e addShape: s.
	e model: (RWDiagramElement famixElement: (FAMIXMethod new)).
	e model famixElement moose2ModelName: 'A'.
	e translateTo: 10 @ 10.
	v add: e.
	"Second element on same position"
	e := RTElement new.
	s := RTBox new.
	s
		width: 100;
		height: 10.
	e addShape: s.
	e model: (RWDiagramElement famixElement: (FAMIXAttribute new)).
	e model famixElement moose2ModelName: 'B'.
	e translateTo: 116 @ 20.
	v add: e.
	"Adapt position"
	lcPO := RWDiagramLCPreventOverlapping new.
	lcPO space: 3.
	lcPO maxChecks: 100.
	lcPO preventOverlappings: v messages: false.
	movedElements := v elements select: [ :each | (each position = (10 @ 10)) not and: (each position = (116 @ 20)) not ].
	self assert: movedElements size equals: 0! !

RWDiagramAbstractTest subclass: #RWDiagramMooseModelTest
	instanceVariableNames: 'model package1 package2 namespace class1 class2 inh method1 method2 method3 methodExt var1 var2 var3 access acc1 inv1 inv2 inv3 ref1 methodI0P2 methodI0P1 inv0P2 methodI0 inv0P1 methodI0M1 inv0 methodI0M2 inv0M1 methodA0 attributeA0 accA0 accI0 package1RWDE package2RWDE class1RWDE class2RWDE method1RWDE method2RWDE method3RWDE var1RWDE var2RWDE var3RWDE methodI0RWDE methodI0P2RWDE methodI0P1RWDE methodI0M1RWDE methodI0M2RWDE attributeA0RWDE classNopackage classNopackageRWDE'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramMooseModelTest commentStamp: 'RainerWinkler 7/27/2016 22:23' prior: 0!
I provide a complex Moose model that shall be used by other test classes for doing their tests!

RWDiagramMooseModelTest subclass: #RWDiagramACDStandardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramACDStandardTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testEqual
	| acd acd2 IdenticalModel IdenticalPackage1 IdenticalNamespace IdenticalClass1 IdenticalMmethod1 IdenticalMethod1RWDE|
	acd := RWDiagramACDStandard new.
	acd
		includeMe: true
		usedByLayers: 1
		usingLayers: 2
		ofElement: method1RWDE.
	acd2 := RWDiagramACDStandard new.
	acd2
		includeMe: true
		usedByLayers: 1
		usingLayers: 2
		ofElement: method1RWDE.
	self assert: acd = acd2 equals: true.
		
	IdenticalModel := MooseModel new.
	IdenticalPackage1 := FAMIXPackage new name: 'package1'; mooseModel: IdenticalModel.
	IdenticalNamespace := FAMIXNamespace new name: 'Smalltalk'; mooseModel: IdenticalModel.
	IdenticalClass1 := FAMIXClass new name: 'class1'; parentPackage: IdenticalPackage1; container: IdenticalNamespace; mooseModel: IdenticalModel.
	IdenticalMmethod1 := FAMIXMethod new name: 'method1'; parentType: IdenticalClass1; mooseModel: IdenticalModel; hasClassScope: true.
	IdenticalMethod1RWDE := RWDiagramElement famixElement: IdenticalMmethod1.		
		

	acd2 := RWDiagramACDStandard new.
	acd2
		includeMe: true
		usedByLayers: 1
		usingLayers: 2
		ofElement: IdenticalMethod1RWDE.		

	self assert: acd = acd2 equals: true.
	acd2 := 1.
	self assert: acd = acd2 equals: false.
	acd2 := RWDiagramACDStandard new.
	acd2
		includeMe: true
		usedByLayers: 0
		usingLayers: 2
		ofElement: method1RWDE.
	self assert: acd = acd2 equals: false.
	acd2 := RWDiagramACDStandard new.
	acd2
		includeMe: true
		usedByLayers: 1
		usingLayers: 2
		ofElement: method2RWDE.
	self assert: acd = acd2 equals: true. "As is written in the comment of the = method, it is not checked whether instances are equal"
	
	
	! !

!RWDiagramACDStandardTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testIncludeMe
	| acd |
	acd := RWDiagramACDStandard new.
	acd
		includeMe: true
		usedByLayers: 1
		usingLayers: 2
		ofElement: methodI0RWDE.
	self assert: acd includeMe equals: true! !

!RWDiagramACDStandardTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testIncludeMeUsedByLayersUsingLayersOfElement
	| acd collected |
	acd := RWDiagramACDStandard new.
	collected := acd
		includeMe: true
			usedByLayers: 0
			usingLayers: 0
			ofElement: methodI0RWDE;
		collectedElements.
	self assert: collected size equals: 1.
	acd := RWDiagramACDStandard new.
	collected := acd
		includeMe: false
			usedByLayers: 0
			usingLayers: 0
			ofElement: methodI0RWDE;
		collectedElements.
	self assert: collected size equals: 0.
	acd := RWDiagramACDStandard new.
	collected := acd
		includeMe: false
			usedByLayers: 2
			usingLayers: 2
			ofElement: methodI0RWDE;
		collectedElements.
	self assert: collected size equals: 7.
	acd := RWDiagramACDStandard new.
	collected := acd
		includeMe: false
			usedByLayers: 1
			usingLayers: 0
			ofElement: methodI0RWDE ;
		collectedElements.
	self assert: (collected includes: methodI0P2RWDE) equals: false.
	self assert: (collected includes: methodI0P1RWDE) equals: true.
	self assert: (collected includes: methodI0RWDE ) equals: false.
	self assert: (collected includes: methodI0M1RWDE) equals: false.
	self assert: (collected includes: methodI0M2RWDE) equals: false.
	acd := RWDiagramACDStandard new.
	collected := acd
		includeMe: true
			usedByLayers: 0
			usingLayers: 2
			ofElement: methodI0RWDE;
		collectedElements.
	self assert: (collected includes: methodI0P2RWDE) equals: false.
	self assert: (collected includes: methodI0P1RWDE) equals: false.
	self assert: (collected includes: methodI0RWDE) equals: true.
	self assert: (collected includes: methodI0M1RWDE) equals: true.
	self assert: (collected includes: methodI0M2RWDE) equals: true.
	acd := RWDiagramACDStandard new.
	collected := acd
		includeMe: true
			usedByLayers: 1
			usingLayers: 1
			ofElement: methodI0RWDE;
		collectedElements.
	self assert: (collected includes: methodI0P2RWDE) equals: false.
	self assert: (collected includes: methodI0P1RWDE) equals: true.
	self assert: (collected includes: methodI0RWDE) equals: true.
	self assert: (collected includes: methodI0M1RWDE) equals: true.
	self assert: (collected includes: methodI0M2RWDE) equals: false! !

!RWDiagramACDStandardTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testOfElement
	| acd |
	acd := RWDiagramACDStandard new.
	acd
		includeMe: true
			usedByLayers: 1
			usingLayers: 2
			ofElement: methodI0RWDE .
			self assert: acd ofElement equals: methodI0RWDE ! !

!RWDiagramACDStandardTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testUsedByElements
	| acd elements |
	acd := RWDiagramACDStandard new.
	elements := acd usedByElements: methodI0RWDE .
	self assert: (elements includes: methodI0P2RWDE ) equals: false.
	self assert: (elements includes: methodI0P1RWDE ) equals: true.
	self assert: (elements includes: methodI0RWDE ) equals: false.
	self assert: (elements includes: methodI0M1RWDE ) equals: false.
	self assert: (elements includes: attributeA0RWDE ) equals: true.
	elements := acd usedByElements: methodI0P2RWDE .
	self assert: elements size equals: 0! !

!RWDiagramACDStandardTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testUsedByLayers
	| acd |
	acd := RWDiagramACDStandard new.
	acd
		includeMe: true
			usedByLayers: 1
			usingLayers: 2
			ofElement: methodI0RWDE .
			self assert: acd usedByLayers equals: 1! !

!RWDiagramACDStandardTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testUsesElements
	| acd elements |
	acd := RWDiagramACDStandard new.
	elements := acd usesElements: methodI0RWDE .
	self assert: (elements includes: methodI0P1RWDE ) equals: false.
	self assert: (elements includes: methodI0RWDE ) equals: false.
	self assert: (elements includes: methodI0M1RWDE ) equals: true.
	self assert: (elements includes: methodI0M2RWDE ) equals: false.
	self assert: (elements includes: attributeA0RWDE ) equals: true.
	elements := acd usesElements: methodI0M2RWDE .
	self assert: elements size equals: 0! !

!RWDiagramACDStandardTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testUsingLayers
	| acd |
	acd := RWDiagramACDStandard new.
	acd
		includeMe: true
			usedByLayers: 1
			usingLayers: 2
			ofElement: methodI0RWDE.
			self assert: acd usingLayers equals: 2! !

RWDiagramMooseModelTest subclass: #RWDiagramAnonymizeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramAnonymizeTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testGetAnonymNameWithPrefix
	| expectedAnonymizedComment |
	RWDiagramAnonymize anonymize: true.
	expectedAnonymizedComment := 'Comment1'.
	self assert: (RWDiagramAnonymize getAnonymName: 'Global' withPrefix: 'Comment') equals: expectedAnonymizedComment.
	expectedAnonymizedComment := 'Comment<br>000000000002' copyReplaceAll: '<br>' with: String crlf.
	self assert: (RWDiagramAnonymize getAnonymName: 'Comment<br>SecondLine' withPrefix: 'Comment') equals: expectedAnonymizedComment.
	RWDiagramAnonymize anonymize: false! !

!RWDiagramAnonymizeTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testanonymize
	self assert: RWDiagramAnonymize anonymize equals: false.
	RWDiagramAnonymize anonymize: true.
	self assert: RWDiagramAnonymize anonymize equals: true.
	RWDiagramAnonymize anonymize: false.
	self assert: RWDiagramAnonymize anonymize equals: false! !

RWDiagramMooseModelTest subclass: #RWDiagramEditorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramEditorTest methodsFor: 'public' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testCommentsOfForLayout
	| b rwEditor comments element aRWDElement aRWDElements element2 aRWDElement2 elementM elementM2 |
	b := RTMondrian new.
	rwEditor := RWDiagramEditor new.
	"Comment classes"
	element := FAMIXClass new.
	element name: 'Class1'.
	aRWDElement := RWDiagramElement famixElement: element.
	rwEditor currentLayout comment: 'Test' to: aRWDElement.
	rwEditor addGlobalComments: (RWDiagramGlobalComment text: 'Global') to: aRWDElement.
	"Read with separate Moose Entity of same name"
	element2 := FAMIXClass new.
	element2 name: 'Class1'.
	aRWDElement2 := RWDiagramElement famixElement: element2.
	aRWDElements := OrderedCollection new.
	aRWDElements add: aRWDElement2.
	self assert: element mooseID = element2 mooseID equals: false.
	comments := rwEditor commentsOf: aRWDElements forLayout: rwEditor currentLayout.
	self assert: (comments select: [ :each | each text = 'Global' ]) size equals: 0.
	self assert: (comments select: [ :each | each text = 'Test' ]) size equals: 1.
	self assert: (comments select: [ :each | each text = 'Else' ]) size equals: 0.
	self assert: comments first uniqueKeyOfCommentedElement equals: aRWDElement2 uniqueKey.
	"Comment methods"
		element := FAMIXClass new.
	element name: 'Class1'.
	elementM := FAMIXMethod new name: 'method1'; parentType: element.
	
	aRWDElement := RWDiagramElement famixElement: elementM.
	rwEditor currentLayout comment: 'Test' to: aRWDElement.
	rwEditor addGlobalComments: (RWDiagramGlobalComment text: 'Global') to: aRWDElement.
	"Read with separate Moose Entity of same name"
	element2 := FAMIXClass new.
	element2 name: 'Class1'.

	elementM2 := FAMIXMethod new name: 'method1'; parentType: element2.	
	aRWDElement2 := RWDiagramElement famixElement: elementM2.
	aRWDElements := OrderedCollection new.
	aRWDElements add: aRWDElement2.
	self assert: elementM mooseID = elementM2 mooseID equals: false.
	comments := rwEditor commentsOf: aRWDElements forLayout: rwEditor currentLayout.
	self assert: (comments select: [ :each | each text = 'Global' ]) size equals: 0.
	self assert: (comments select: [ :each | each text = 'Test' ]) size equals: 1.
	self assert: (comments select: [ :each | each text = 'Else' ]) size equals: 0.
	self assert: comments first uniqueKeyOfCommentedElement equals: aRWDElement2 uniqueKey! !

!RWDiagramEditorTest methodsFor: 'environment' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testCurrentLayout
|editor|
editor := RWDiagramEditor new.
editor currentLayoutName: 'test'.
self assert: editor currentLayout class asString equals: 'RWDiagramLayout'.! !

!RWDiagramEditorTest methodsFor: 'public' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testCurrentLayoutName
|editor|
editor := RWDiagramEditor new.
editor currentLayoutName: 'test'.
self assert: editor currentLayoutName equals: 'test'.! !

!RWDiagramEditorTest methodsFor: 'public' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testGlobalCommentsOf
	| b rwEditor comments  element aRWDElement aRWDElements |
	b := RTMondrian new.
	rwEditor := RWDiagramEditor new.
	element := FAMIXClass new.
	element name: 'Class1'.
	aRWDElement := RWDiagramElement famixElement: element.
	aRWDElements := OrderedCollection new.
	aRWDElements add: aRWDElement.
	rwEditor currentLayout comment: 'Test' to: aRWDElement.
	rwEditor addGlobalComments: (RWDiagramGlobalComment text: 'Global') to: aRWDElement.
	comments := rwEditor globalCommentsOf: aRWDElements.
	self assert: (comments select:[:each|each text = 'Global' ] )size equals: 1.
	self assert: (comments select:[:each|each text = 'Test' ] )size equals: 0.
	self assert: (comments select:[:each|each text = 'Else' ] )size equals: 0.
	self assert: comments first uniqueKeyOfCommentedElement equals: aRWDElement uniqueKey! !

!RWDiagramEditorTest methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testInitialize
	| editor |
	editor := RWDiagramEditor new.
	editor initialize.
	self assert: editor currentLayoutName equals: 'First'.
	self assert: editor settings isReading equals: true! !

!RWDiagramEditorTest methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testIsDiagramElement
	self assert: (RWDiagramEditor isDiagramElement: FAMIXPackage new) equals: true.
	self assert: (RWDiagramEditor isDiagramElement: RWDiagramNoPackage new) equals: true.
	self assert: (RWDiagramEditor isDiagramElement: RWDiagramLocalComment new) equals: false.
	self assert: (RWDiagramEditor isDiagramElement: RWDiagramGlobalComment new) equals: false! !

!RWDiagramEditorTest methodsFor: 'environment' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testLayoutForRTView
|editor view1 view2 view3 |
editor := RWDiagramEditor new.
editor currentLayoutName: 'A'.
view1 := RTView new.
editor currentLayout processedRTView: view1.
editor currentLayoutName: 'B'.
view2 := RTView new.
editor currentLayout processedRTView: view2.
self assert: view1 == view2 equals: false.
self assert: (editor layoutForRTView: view1 message: false) moose2ModelName equals: 'A'.
self assert: (editor layoutForRTView: view2 message: false) moose2ModelName equals: 'B'.

self assert: (editor layoutForRTView: view2 message: false) isDefined equals: true.
view3 := RTView new.
self assert: (editor layoutForRTView: view3 message: false) isDefined equals: false! !

!RWDiagramEditorTest methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSettings
	| editor |
	editor := RWDiagramEditor new.
	self assert: editor settings class asString equals: 'RWDiagramSettings'! !

!RWDiagramEditorTest methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testWriteGlobalToStream
	| editor gc aStream aExpectedStream aRWDiagramElementMethod1 |
	"This test shall fail"
"	editor := RWDiagramEditor new.
	gc := RWDiagramGlobalComment text: '2016-08-22T21:14:08.555084+02:00470177'.
	gc text: 'Line 1<br>Line 2'.
	aRWDiagramElementMethod1 := RWDiagramElement famixElement: method1.
	editor addGlobalComments: gc to: aRWDiagramElementMethod1.
	gc := RWDiagramGlobalComment text: '2016-08-23T21:14:08.555084+02:00470177'.
	gc text: 'B Line 1<br>Line 2'.
	editor addGlobalComments: gc to: aRWDiagramElementMethod1.	
	aStream := ReadWriteStream on: String new.
	editor writeGlobalToStream: aStream.
	aExpectedStream := ReadWriteStream on: String new.
	aExpectedStream
		nextPutAll: '<?xml version="1.0"?>';
		crlf;
		nextPutAll: '<!!--Global Comments-->';
		crlf;
		nextPutAll: '<elements>';
		crlf;
		nextPutAll: '    <element>';
		crlf;
		nextPutAll: '        <type>FAMIXMethod</type>';
		crlf;
		nextPutAll: '        <class>class1</class>';
		crlf;
		nextPutAll: '        <method>method1</method>';
		crlf;
		nextPutAll: '        <comment>';		
		crlf;
		nextPutAll: '            <id>2016-08-22T21:14:08.555084+02:00470177</id>';								
		crlf;
		nextPutAll: '            <text><!![CDATA[Line 1<br>Line 2]]>';
		crlf;
		nextPutAll: '            </text>';
		crlf;
		nextPutAll: '        </comment>';	
		crlf;
		nextPutAll: '        <comment>';		
		crlf;
		nextPutAll: '            <id>2016-08-23T21:14:08.555084+02:00470177</id>';								
		crlf;
		nextPutAll: '            <text><!![CDATA[B Line 1<br>Line 2]]>';
		crlf;
		nextPutAll: '            </text>';
		crlf;
		nextPutAll: '        </comment>';									
		crlf;
		nextPutAll: '    </element>';
		crlf;
		nextPutAll: '</elements>'.
	self assert: aStream equals: aExpectedStream	"! !

RWDiagramMooseModelTest subclass: #RWDiagramElementGroupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramElementGroupTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAdd
	| eg el |
	eg := RWDiagramElementGroup new.
	el := RWDiagramElement famixElement: class1.
	eg add: el.
	self assert: eg elementList size equals: 1! !

!RWDiagramElementGroupTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testApplyToAttributeAndReplaceElement
	| eg fe fe2  el el2 |
	eg := RWDiagramElementGroup new.
	fe := FAMIXClass new.
	fe name: 'Dummy'.
	el := RWDiagramElement famixElement: fe.
	self assert: (eg apply: [ :e | e ] toAttribute: el replace: true "Check" ) attributeList class asString equals: 'RWDiagramUndeterminedAttributeList'.
	eg apply: [ :e | RWDiagramAttributeList new ]  toAttribute: el replace: true "Check" .
	self assert: (eg apply: [ :e | e ] toAttribute: el replace: true "Check") attributeList class asString equals: 'RWDiagramAttributeList'.
	fe2 := FAMIXClass new.
	fe2 name: 'Dummy'.
	el2 := RWDiagramElement famixElement: fe2.
	"A dummy operation replaces the element with the element used for the search"
	eg apply: [ :e | e ] toAttribute: el2 replace: true "Check".
	self assert: (eg elementList at: el2 uniqueKey) equals: el2! !

!RWDiagramElementGroupTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testDAllClasses
	| eg el |
	eg := RWDiagramElementGroup new.
	el := RWDiagramElement famixElement: class1.
	eg add: el.
	el := RWDiagramElement famixElement: class2.
	eg add: el.
	self assert: eg dAllClasses size equals: 2.
	"After a refresh without replacing the FAMIXElement again, the element is not shown"
	eg elementList do: [ :e | e refresh ].
	self assert: eg dAllClasses size equals: 0! !

!RWDiagramElementGroupTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testDAllClassesOfPackage
	| eg el ep noPackage np |
	eg := RWDiagramElementGroup new.
	el := RWDiagramElement famixElement: class1.
	eg add: el.
	el := RWDiagramElement famixElement: class2.
	eg add: el.
	ep := RWDiagramElement famixElement: package1.
	self assert: (eg dAllClassesOfPackage: ep) size equals: 1.
	"After a refresh without replacing the FAMIXElement again, the element is not shown"
	eg elementList do: [ :e | e refresh ].
	self assert: (eg dAllClassesOfPackage: ep) size equals: 0.
	noPackage := RWDiagramNoPackage new.
	np := noPackage asRWDiagramElement.
	eg add: classNopackageRWDE. 
	self assert: (eg dAllClassesOfPackage: np) size equals: 1.! !

!RWDiagramElementGroupTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testDAllMethods
	| eg el |
	eg := RWDiagramElementGroup new.
	el := RWDiagramElement famixElement: class1.
	eg add: el.
	el := RWDiagramElement famixElement: class2.
	eg add: el.
	self assert: eg dAllMethods size equals: 10.
	"After a refresh without replacing the FAMIXElement again, the element is not shown"
	eg elementList do: [ :e | e refresh ].
	self assert: eg dAllMethods size equals: 0! !

!RWDiagramElementGroupTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testDAllModelPackages
	| eg el |
	eg := RWDiagramElementGroup new.
	el := RWDiagramElement famixElement: class1.
	eg add: el.
	self assert: eg elementList size equals: 1.
	self assert: eg dAllModelPackages size equals: 1.
	"After a refresh without replacing the FAMIXElement again, the element is not shown"
	eg elementList do: [ :e | e refresh ].
	self assert: eg dAllModelPackages size equals: 0.
    " Handle methods correctly"
    eg := RWDiagramElementGroup new.
    el := RWDiagramElement famixElement: method1.
    eg add: el.
    self assert: eg elementList size equals: 1.
    self assert: eg dAllModelPackages size equals: 0.
! !

!RWDiagramElementGroupTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testElementList
	| eg |
	eg := RWDiagramElementGroup new.
	eg apply: [ :e | e ] toAttribute: (RWDiagramElement famixElement: class1) replace: true "Check".
	self assert: eg elementList size equals: 1! !

!RWDiagramElementGroupTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSetConnections
	| eg |
	RWDiagramElement refresh.
	eg := RWDiagramElementGroup new.
	eg add: class1RWDE.
	eg add: class2RWDE.
	eg setConnections.
	eg elementList
		do: [ :el | 
			el famixElement moose2ModelName = 'class1'
				ifTrue: [ self assert: el connectedTo size equals: 1 ].
			el famixElement moose2ModelName = 'class2'
				ifTrue: [ self assert: el connectedTo size equals: 0 ] .
			el famixElement moose2ModelName = 'method1'
				ifTrue: [ self assert: el connectedTo size equals: 0 ] .
			el famixElement moose2ModelName = 'method2'
				ifTrue: [ self assert: el connectedTo size equals: 0 ]  ]! !

RWDiagramMooseModelTest subclass: #RWDiagramElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramElementTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAccessedTo
	| e e2 |
	e := RWDiagramElement new.
	e famixElement: class1.
	self assert: e accessedTo size equals: 0.
	e2 := RWDiagramElement new.
	e2 famixElement: class2.
	e accessedTo: e2.
	self assert: e accessedTo size equals: 1.
	e accessedTo: e2.
	self assert: e accessedTo size equals: 1.
	e accessedTo do: [ :e3 | self assert: e3 famixElement moose2ModelName equals: 'class2' ].
	e refreshAccessedTo.
	self assert: e accessedTo size equals: 0! !

!RWDiagramElementTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testConnectedFrom
	| e e2 |
	e := RWDiagramElement new.
	e famixElement: class1.
	self assert: e connectedFrom size equals: 0.
	e2 := RWDiagramElement new.
	e2 famixElement: class2.
	e connectedFrom: e2.
	self assert: e connectedFrom size equals: 1.
	e connectedFrom: e2.
	self assert: e connectedFrom size equals: 1.
	e connectedFrom do: [ :e3 | self assert: e3 famixElement moose2ModelName equals: 'class2' ].
	e refreshConnectedTo.
	self assert: e connectedFrom size equals: 0! !

!RWDiagramElementTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testConnectedTo
	| e e2 |
	e := RWDiagramElement new.
	e famixElement: class1.
	self assert: e connectedTo size equals: 0.
	e2 := RWDiagramElement new.
	e2 famixElement: class2.
	e connectedTo: e2.
	self assert: e connectedTo size equals: 1.
	e connectedTo: e2.
	self assert: e connectedTo size equals: 1.
	e connectedTo do: [ :e3 | self assert: e3 famixElement moose2ModelName equals: 'class2' ].
	e refreshConnectedTo.
	self assert: e connectedTo size equals: 0! !

!RWDiagramElementTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testElementHandledWithParents
|element|
element := RWDiagramElement new.
element famixElement: FAMIXMethod new.
self assert: element elementHandledWithParents equals: true.
element famixElement: FAMIXAttribute new.
self assert: element elementHandledWithParents equals: true.
element famixElement: FAMIXClass new.
self assert: element elementHandledWithParents equals: false.! !

!RWDiagramElementTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testFamixElement
  |e|
e := RWDiagramElement new.
e famixElement: FAMIXClass new.
self assert: e famixElement class asString equals: 'FAMIXClass'! !

!RWDiagramElementTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testRefresh
  |e|
e := RWDiagramElement new.
e famixElement: FAMIXClass new.
e refresh.
self assert: e famixElement equals: nil! !

!RWDiagramElementTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testUniqueKey
  |e|
e := RWDiagramElement famixElement: class1.
self assert: 'FAMIXClass>class1' equals: e uniqueKey.
e := RWDiagramElement famixElement: package1.
self assert: 'FAMIXPackage>package1' equals: e uniqueKey.
e := RWDiagramElement famixElement: methodI0.
"The keys are now always converted to lowercase"
self assert: 'FAMIXMethod>class1>methodi0>cl' equals: e uniqueKey.! !

!RWDiagramElementTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testattributeList
  |e|
e := RWDiagramElement new.
e attributeList: RWDiagramAttributeList new.
self assert: e attributeList class asString equals: 'RWDiagramAttributeList'! !

RWDiagramMooseModelTest subclass: #RWDiagramLCPositionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramLCPositionsTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testReadPositions
	| layout aRTElement view rpos count editor localComments aRWDElements |
	editor := RWDiagramEditor new.
	layout := editor currentLayout.
	view := RTView new.
	aRTElement := RTElement new.
	aRTElement addShape: RTBox new.
	aRTElement model: class1RWDE.
	view add: aRTElement.
	layout
		remember: [ :attributeList | attributeList position: (15 / 2) @ (179 / 2) ]
		fromRTElement: aRTElement.
	aRTElement := RTElement new.
	aRTElement addShape: RTBox new.
	aRTElement model: method1RWDE.
	view add: aRTElement.
	layout
		remember: [ :attributeList | attributeList position: (3 / 2) @ (5 / 2) ]
		fromRTElement: aRTElement.
	layout suppressWithChildren: true to: aRTElement model.
	layout comment: 'A comment<br>second line' to: aRTElement model.
	layout replaceMooseEntities: true.
	(layout readAttributesFromFAMIXElement: aRTElement model ) comment position: 11 @ 12.	

		aRWDElements := OrderedCollection new.
	aRWDElements add: method1RWDE.
	localComments := editor commentsOf: aRWDElements forLayout: layout.
	aRTElement := RTElement new.
	aRTElement addShape: RTBox new.
	aRTElement model: 	localComments first.
	view add: aRTElement.
	rpos := RWDiagramLCPositions new.
	rpos currentLayout2: layout.
	rpos readPositions: view.

	count := 0.
	view elements
		do: [ :e | 
			e model moose2ModelName = 'a RWDiagramLocalComment' ifTrue: [ count := count + 1.
					self assert: e model position equals: (11@12) ]
				ifFalse:[
			e model famixElement moose2ModelName = 'class1'
				ifTrue: [ count := count + 1.
					self assert: e position equals: (15 / 2) @ (179 / 2) ].
			e model famixElement moose2ModelName = 'method1'
				ifTrue: [ count := count + 1.
					self assert: e position equals: (3 / 2) @ (5 / 2) ] ]
			].
	self assert: count equals: 3! !

RWDiagramMooseModelTest subclass: #RWDiagramLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramLayoutTest methodsFor: 'diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAddAppearanceChangeTypeTo
	| l aAppearanceChangeType attributeList |
	l := RWDiagramLayout new.
	l replaceMooseEntities: true.
	l moose2ModelName: 'test'.
	aAppearanceChangeType := RWDiagramAppearanceChangeType new.
	l addAppearanceChangeType: aAppearanceChangeType to: methodI0RWDE.
	l replaceMooseEntities: true.
	attributeList := l readAttributesFromFAMIXElement: methodI0RWDE.
	self
		assert: attributeList appearance class asString
		equals: 'RWDiagramAppearance'.
	l replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAddAppearanceChangerTo
	| l aAppearanceChanger attributeList |
	l := RWDiagramLayout new.
	l replaceMooseEntities: true.
	l moose2ModelName: 'test'.
	aAppearanceChanger := RWDiagramAppearanceChanger new.
	l addAppearanceChanger: aAppearanceChanger to: class1RWDE.
	l replaceMooseEntities: true.
	attributeList := l readAttributesFromFAMIXElement: class1RWDE.
	self assert: attributeList appearanceChangerGroup appearanceChangers size equals: 1.
	l replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testClassBoxSuppressed
	| l |
	l := RWDiagramLayout new.
	self assert: l classBoxSuppressed equals: false.
	l classBoxSuppressed: true.
	self assert: l classBoxSuppressed equals: true.
	l classBoxSuppressed: false.
	self assert: l classBoxSuppressed equals: false! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testCleanCDATA
| l raw |
l := RWDiagramLayout new.
raw := 'Test', String lf, String space.
self assert: (l cleanCDATA: raw) equals: 'Test'! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testColorFAMIXComponentView
	| l aRTView aRTElement aFAMIXClass aFAMIXMethod |
	l := RWDiagramLayout new.
	aRTView := RTView new.
	aRTElement := RTElement new.
	aRTElement color: Color green.
	aFAMIXClass := FAMIXClass new.
	aFAMIXClass name: 'Class1'.
	aFAMIXMethod := FAMIXMethod new.
	aFAMIXMethod name: 'Method1'.
	aFAMIXMethod parentType: aFAMIXClass.
	aRTElement model: (RWDiagramElement famixElement: aFAMIXMethod).
	aRTView add: aRTElement.
	l color: Color blue FAMIXComponent: aFAMIXMethod  view: aRTView.
	self assert: aRTElement color equals: Color blue! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testCommentColor
|layout|
layout := RWDiagramLayout new.
self assert: layout commentColor equals: layout defaultCommentColor.
layout commentColor: Color yellow.
self assert: layout commentColor equals: Color yellow.! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testCommentPositionTo
	| layout aTRShape aRTElement attributeList |
	layout := RWDiagramLayout new.
	layout replaceMooseEntities: true.
	layout moose2ModelName: 'test'.
	aTRShape := TRShape new.
	aRTElement := RTElement new.
	layout comment: 'A comment' to: class1RWDE.
	layout replaceMooseEntities: true.
	(layout readAttributesFromFAMIXElement: class1RWDE) comment position: 10 @ 20.
	layout replaceMooseEntities: true.
	attributeList := layout readAttributesFromFAMIXElement: class1RWDE.
	self assert: attributeList comment position equals: 10 @ 20.
	layout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testCommentaddTo
	| layout aTRShape aRTElement attributeList |
	layout := RWDiagramLayout new.
	layout replaceMooseEntities: true.
	layout moose2ModelName: 'test'.
	aTRShape := TRShape new.
	aRTElement := RTElement new.
	layout comment: 'A comment' to: class1RWDE.
	layout replaceMooseEntities: true.
	attributeList := layout readAttributesFromFAMIXElement: class1RWDE.
	self assert: attributeList comment text equals: 'A comment'.
	layout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testCommentto
	| layout aTRShape aRTElement attributeList |
	layout := RWDiagramLayout new.
	layout replaceMooseEntities: true.
	layout moose2ModelName: 'test'.
	aTRShape := TRShape new.
	aRTElement := RTElement new.
	layout comment: 'A comment<br>second line' to: class1RWDE.
	layout  replaceMooseEntities: true.
	attributeList := layout readAttributesFromFAMIXElement: class1RWDE.
	self assert: attributeList comment text equals: 'A comment', String crlf, 'second line'.
	layout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testDisplayDependencies
	| l |
	l := RWDiagramLayout new.
	self assert: l displayDependencies equals: true.
	l displayDependencies: true.
	self assert: l displayDependencies equals: true.
	l displayDependencies: false.
	self assert: l displayDependencies equals: false! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testElementGroup
|layout|
layout := RWDiagramLayout new.
self assert: layout elementGroup class asString equals: 'RWDiagramElementGroup'.! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testEvaluateAppearance
	| l aAC aAC1 |
	l := RWDiagramLayout new.
	l replaceMooseEntities: true.
	aAC := RWDiagramAppearanceChanger
		changeDeterminer:
			(RWDiagramACDStandard new
				includeMe: true
					usedByLayers: 1
					usingLayers: 1
					ofElement: methodI0RWDE ;
				yourself)
		changeType: RWDiagramACTHighlight new.
	l addAppearanceChanger: aAC to: methodI0RWDE.
	l evaluateAppearance.
	l replaceMooseEntities: true.
	self assert: (l readAttributesFromFAMIXElement: methodI0RWDE) appearance highlight equals: true.
	aAC1 := RWDiagramAppearanceChanger
		changeDeterminer:
			(RWDiagramACDStandard new
				includeMe: true
					usedByLayers: 1
					usingLayers: 1
					ofElement: methodI0RWDE;
				yourself)
		changeType: RWDiagramACTSuppressOthers new.	
	l addAppearanceChanger: aAC1 to: methodI0RWDE.
	l evaluateAppearance.
	self assert: l suppressOthersActive equals: true.
	l replaceMooseEntities: true.
	self assert: (l readAttributesFromFAMIXElement: methodI0RWDE) appearance othersAreSuppressed equals: true.	
	l replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined.
	"No error if appearance is calculated on refreshed layout. There no element in the elementlist has a not nil FAMIXElement"	
	l refresh.
	l evaluateAppearance ! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testIsModelElementsuppressedWithChildren
	| editor layout |
	editor := RWDiagramEditor new.
	layout := editor currentLayout.
	layout moose2ModelName: 'test'.
	self assert: (layout isModelElementsuppressedWithChildren: class1RWDE ) equals: false.
	editor suppressWithChildren: true to: class1RWDE.
	self assert: (layout isModelElementsuppressedWithChildren: class1RWDE ) equals: true! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testMooseID
	| layout |
	layout := RWDiagramLayout new.
	self assert: layout mooseID equals: nil.
	layout mooseID: 1.
	self assert: layout mooseID equals: 1! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testName
|layout|
layout := RWDiagramLayout new moose2ModelName: 'T1'.
self assert: layout moose2ModelName equals: 'T1'.! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testPackageBoxSuppressed
	| l |
	l := RWDiagramLayout new.
	self assert: l packageBoxSuppressed equals: false.
	l packageBoxSuppressed: true.
	self assert: l packageBoxSuppressed equals: true.
	l packageBoxSuppressed: false.
	self assert: l packageBoxSuppressed equals: false! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testProcessedRTView
	| aRTView l |
	aRTView := RTView new.
	l := RWDiagramLayout new.
	l processedRTView: aRTView.
	self assert: l processedRTView equals: aRTView! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testReadAttributesFromFAMIXModel
	| layout aTRShape aRTElement |
	layout := RWDiagramLayout new.
	layout replaceMooseEntities: true.
	layout moose2ModelName: 'test'.
	aTRShape := TRShape new.
	aRTElement := RTElement new.
	aRTElement model: class1RWDE .
	aTRShape element: aRTElement.
	layout
		remember: [ :attributeList | attributeList position: 10 @ 10 ]
		fromRTElement: aRTElement.
	layout  replaceMooseEntities: true.
	self
		assert: (layout readAttributesFromFAMIXElement: aTRShape element model) position point
		equals: 10 @ 10.
	layout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testReadFileVersion
	| layout |
	layout := RWDiagramLayout new moose2ModelName: 'T1'.
	self assert: layout readFileVersion equals: ''.
	layout readFileVersion: 'v0.3.0'.
	self assert: layout readFileVersion equals: 'v0.3.0'! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testReadFromStreamMessage
	| layout aRTElement aStream tempElement |
	layout := RWDiagramLayout new.
	layout replaceMooseEntities: false.
	layout moose2ModelName: 'test1'.
	aStream := ReadWriteStream on: String new.
	aStream
		nextPutAll: '<?xml version="1.0"?>';
		crlf;
		nextPutAll: '<!!--Moose Diagram Editor-->';
		crlf;
		nextPutAll: '<elements>';
		crlf;
		nextPutAll: '    <version>v0.3.0</version>';
		crlf;
		nextPutAll: '    <scope>package</scope>';
		crlf;
		nextPutAll: '    <suppressed>packageBox</suppressed>';
		crlf;
		nextPutAll: '<element>';
		crlf;
		nextPutAll: '    <type>FAMIXClass</type>';
		crlf;
		nextPutAll: '    <class>class1</class>';
		crlf;
		nextPutAll: '    <x>10</x>';
		crlf;
		nextPutAll: '    <y>20</y>';
		crlf;
		nextPutAll: '    <supressWithChildren>false</supressWithChildren>';
		crlf;
		nextPutAll: '</element>';
		crlf;
		nextPutAll: '<element>';
		crlf;
		nextPutAll: '    <type>FAMIXMethod</type>';
		crlf;
		nextPutAll: '    <class>class1</class>';
		crlf;
		nextPutAll: '    <method>methodI0</method>';
		crlf;
		nextPutAll: '    <hasClassScope>true</hasClassScope>';
		crlf;
		nextPutAll: '    <x>110</x>';
		crlf;
		nextPutAll: '    <y>120</y>';
		crlf;
		nextPutAll: '    <supressWithChildren>true</supressWithChildren>';
		crlf;
		nextPutAll: '    <comment><!![CDATA[A comment<br>second line]]>';
		crlf;
		nextPutAll: '    </comment>';
		crlf;
		nextPutAll: '    <commentx>11</commentx>';
		crlf;
		nextPutAll: '    <commenty>23</commenty>';
		crlf;
		nextPutAll: '    <ACTSuppressOthers>';
		crlf;
		nextPutAll: '        <type>ACDStandard</type>';
		crlf;
		nextPutAll: '        <includeMe>true</includeMe>';
		crlf;
		nextPutAll: '        <usedByLayers>2</usedByLayers>';
		crlf;
		nextPutAll: '        <usingLayers>1</usingLayers>';
		crlf;
		nextPutAll: '    </ACTSuppressOthers>';
		crlf;
		nextPutAll: '    <ACTSuppressOthers>';
		crlf;
		nextPutAll: '        <type>ACDStandard</type>';
		crlf;
		nextPutAll: '        <includeMe>false</includeMe>';
		crlf;
		nextPutAll: '        <usedByLayers>3</usedByLayers>';
		crlf;
		nextPutAll: '        <usingLayers>1</usingLayers>';
		crlf;
		nextPutAll: '    </ACTSuppressOthers>';
		crlf;
		nextPutAll: '</element>';
		crlf;
		nextPutAll: '<element>';
		crlf;
		nextPutAll: '    <type>FAMIXPackage</type>';
		crlf;
		nextPutAll: '    <package>package1</package>';
		crlf;
		nextPutAll: '    <x>111</x>';
		crlf;
		nextPutAll: '    <y>121</y>';
		crlf;
		nextPutAll: '</element>';
		crlf;
		nextPutAll: '</elements>'.
	aStream reset.
	aRTElement := RTElement new.
	aRTElement model: class1RWDE.
	layout suppressWithChildren: true to: class1RWDE.
	layout readFromStream: aStream readStream message: false.
	self assert: layout readFileVersion equals: 'v0.3.0'.
	self assert: layout scope equals: layout packageScope.
	self assert: layout packageBoxSuppressed equals: true.
	layout replaceMooseEntities: true.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) position point equals: 10 @ 20.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) suppressWithChildren equals: false.
	aRTElement := RTElement new.
	aRTElement model: methodI0RWDE.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) position point equals: 110 @ 120.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) suppressWithChildren equals: true.
	self
		assert: (layout readAttributesFromFAMIXElement: aRTElement model) comment text
		equals: 'A comment' , Character cr asString , Character lf asString , 'second line'.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) comment position equals: 11 @ 23.
	self
		assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers first changeType class asString
		equals: 'RWDiagramACTSuppressOthers'.
	self
		assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers first changeDeterminer class asString
		equals: 'RWDiagramACDStandard'.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers first changeDeterminer includeMe equals: true.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers first changeDeterminer usedByLayers equals: 2.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers first changeDeterminer usingLayers equals: 1.
	self
		assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers second changeType class asString
		equals: 'RWDiagramACTSuppressOthers'.
	self
		assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers second changeDeterminer class asString
		equals: 'RWDiagramACDStandard'.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers second changeDeterminer includeMe equals: false.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers second changeDeterminer usedByLayers equals: 3.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) appearanceChangerGroup appearanceChangers second changeDeterminer usingLayers equals: 1.
	layout evaluateAppearance.
	self assert: layout suppressOthersActive equals: true.
	layout replaceMooseEntities: true.
	tempElement := layout readAttributesFromFAMIXElement: methodI0M1RWDE.
	self assert: (layout readAttributesFromFAMIXElement: methodI0M1RWDE) appearance othersAreSuppressed equals: true.
	self assert: (layout readAttributesFromFAMIXElement: methodI0M2RWDE) appearance othersAreSuppressed equals: false.
	aRTElement := RTElement new.
	aRTElement model: package2RWDE.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) attributeIsSpecified equals: false.
	aRTElement model: package1RWDE.
	self assert: (layout readAttributesFromFAMIXElement: aRTElement model) position point equals: 111 @ 121.
	layout elementGroup elementList
		do: [ :each | 
			each famixElement class asString = 'FAMIXMethod'
				ifTrue: [ self assert: each famixElement moose2ModelName equals: each famixElement signature ] ].
	layout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testRefresh
	| layout el |
	layout := RWDiagramLayout new.
	el := RWDiagramElement famixElement: class1.
	layout elementGroup add: el.
	layout refresh.
	layout elementGroup elementList do: [ :e | self assert: e famixElement equals: nil ]! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testRememberFromRTElement
	| layout aTRShape aRTElement aString |
	layout := RWDiagramLayout new.
	layout replaceMooseEntities: true.
	layout moose2ModelName: 'test'.
	aTRShape := TRShape new.
	aRTElement := RTElement new.

	aRTElement model: class1RWDE .
	aTRShape element: aRTElement.
	layout remember: [ :attributeList | attributeList position: 10 @ 10 ] fromRTElement: aRTElement.
	layout  replaceMooseEntities: true.
	self
		assert: (layout readAttributesFromFAMIXElement: aTRShape element model) position point
		equals: 10 @ 10.
	aString := 'Text'.
	aRTElement model: aString.
	layout remember: [ :attributeList | attributeList position: 20 @ 20 ] fromRTElement: aRTElement.
	self
		assert: (layout readAttributesFromFAMIXElement: aRTElement model) attributeIsSpecified
		equals: false.
	layout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testRemoveAppearanceChangersFrom
	
	| layout aTRShape aRTElement aAppearanceChanger attributeList |
	layout := RWDiagramLayout new.
	layout replaceMooseEntities: true.
	layout moose2ModelName: 'test'.
	aTRShape := TRShape new.
	aRTElement := RTElement new.

	aAppearanceChanger := RWDiagramAppearanceChanger new.

	layout addAppearanceChanger: aAppearanceChanger to: class1RWDE.
	layout  replaceMooseEntities: true.
	attributeList := layout readAttributesFromFAMIXElement: class1RWDE .
	self assert: attributeList appearanceChangerGroup appearanceChangers size equals: 1.
		
	layout removeAppearanceChangersFrom: class1RWDE .
	layout replaceMooseEntities: true.
	attributeList := layout readAttributesFromFAMIXElement: class1RWDE .
	self assert: attributeList appearanceChangerGroup appearanceChangers size equals: 0.
	layout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testReplaceMooseEntities
|layout|
layout := RWDiagramLayout new.
self assert: layout replaceMooseEntities equals: RWDiagramLayout replaceMooseEntitiesUndefined.
layout replaceMooseEntities: true.
 self assert: layout replaceMooseEntities equals: true.
layout replaceMooseEntities: false.
 self assert: layout replaceMooseEntities equals: false.
layout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined.
self assert: layout replaceMooseEntities equals: RWDiagramLayout replaceMooseEntitiesUndefined
! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testScope
	| layout |
	<RWDiaEdit_68>
	layout := RWDiagramLayout new.
	self assert: layout scope equals: layout methodScope.
	layout scope: layout packageScope.
	self assert: layout scope equals: layout packageScope.
	layout scope: layout classScope.
	self assert: layout scope equals: layout classScope! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSnapToGrid
	| layout s |
	layout := RWDiagramLayout new.
	s := layout snapToGrid! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSuppressOthersActive
  |l|
l := RWDiagramLayout new.
self assert: l suppressOthersActive equals: false.
l suppressOthersActive: true.
self assert: l suppressOthersActive equals: true! !

!RWDiagramLayoutTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSuppressWithChildrento
	| layout aTRShape aRTElement attributeList |
	layout := RWDiagramLayout new.
	layout replaceMooseEntities: true.
	layout moose2ModelName: 'test'.
	aTRShape := TRShape new.
	aRTElement := RTElement new.
	layout suppressWithChildren: true to: class1RWDE.
	layout replaceMooseEntities: true.
	attributeList := layout readAttributesFromFAMIXElement: class1RWDE.
	self assert: attributeList suppressWithChildren equals: true.
	layout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayoutTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testWriteToStream
	| layout aRTElement aStream aExpectedStream aExpectedClass1Stream aExpectedMethod1Stream aStartStream aEndStream aExpectedStream1 aExpectedStream2 |
	layout := RWDiagramLayout new.
	layout moose2ModelName: 'test1'.
	aRTElement := RTElement new.
	aRTElement model: class1RWDE.
	layout remember: [ :attributeList | attributeList position: (15 / 2) @ (179 / 2) ] fromRTElement: aRTElement.
	aRTElement := RTElement new.
	aRTElement model: method1RWDE.
	layout remember: [ :attributeList | attributeList position: (3 / 2) @ (5 / 2) ] fromRTElement: aRTElement.
	layout suppressWithChildren: true to: aRTElement model.
	layout comment: 'A comment' , Character cr asString , Character lf asString , 'second line' to: aRTElement model.
	layout replaceMooseEntities: true.
	layout packageBoxSuppressed: true.
	(layout readAttributesFromFAMIXElement: aRTElement model) comment position: 11 @ 12.
	layout
		addAppearanceChanger:
			(RWDiagramAppearanceChanger
				changeDeterminer:
					(RWDiagramACDStandard new
						includeMe: true
						usedByLayers: 2
						usingLayers: 1
						ofElement: aRTElement model)
				changeType: RWDiagramACTSuppressOthers new)
		to: aRTElement model.
	layout
		addAppearanceChanger:
			(RWDiagramAppearanceChanger
				changeDeterminer:
					(RWDiagramACDStandard new
						includeMe: false
						usedByLayers: 3
						usingLayers: 2
						ofElement: aRTElement model)
				changeType: RWDiagramACTSuppressOthers new)
		to: aRTElement model.
	"Do not remember texts"
	aRTElement model: ByteString new.
	layout remember: [ :attributeList | attributeList position: (3 / 2) @ (5 / 2) ] fromRTElement: aRTElement.
	aRTElement model: nil.
	layout remember: [ :attributeList | attributeList position: (3 / 2) @ (5 / 2) ] fromRTElement: aRTElement.
	aStream := ReadWriteStream on: String new.
	layout writeToStream: aStream.
	aExpectedClass1Stream := ReadWriteStream on: String new.
	aExpectedClass1Stream
		nextPutAll: '    <element>';
		crlf;
		nextPutAll: '        <type>FAMIXClass</type>';
		crlf;
		nextPutAll: '        <class>class1</class>';
		crlf;
		nextPutAll: '        <x>7.5</x>';
		crlf;
		nextPutAll: '        <y>89.5</y>';
		crlf;
		nextPutAll: '    </element>';
		crlf.
	aExpectedMethod1Stream := ReadWriteStream on: String new.
	aExpectedMethod1Stream
		nextPutAll: '    <element>';
		crlf;
		nextPutAll: '        <type>FAMIXMethod</type>';
		crlf;
		nextPutAll: '        <class>class1</class>';
		crlf;
		nextPutAll: '        <method>method1</method>';
		crlf;
		nextPutAll: '        <hasClassScope>true</hasClassScope>';
		crlf;
		nextPutAll: '        <x>1.5</x>';
		crlf;
		nextPutAll: '        <y>2.5</y>';
		crlf;
		nextPutAll: '        <supressWithChildren>true</supressWithChildren>';
		crlf;
		nextPutAll: '        <comment><!![CDATA[A comment<br>second line]]>';
		crlf;
		nextPutAll: '        </comment>';
		crlf;
		nextPutAll: '        <commentx>11.0</commentx>';
		crlf;
		nextPutAll: '        <commenty>12.0</commenty>';
		crlf;
		nextPutAll: '        <ACTSuppressOthers>';
		crlf;
		nextPutAll: '            <type>ACDStandard</type>';
		crlf;
		nextPutAll: '            <includeMe>true</includeMe>';
		crlf;
		nextPutAll: '            <usedByLayers>2</usedByLayers>';
		crlf;
		nextPutAll: '            <usingLayers>1</usingLayers>';
		crlf;
		nextPutAll: '        </ACTSuppressOthers>';
		crlf;
		nextPutAll: '        <ACTSuppressOthers>';
		crlf;
		nextPutAll: '            <type>ACDStandard</type>';
		crlf;
		nextPutAll: '            <includeMe>false</includeMe>';
		crlf;
		nextPutAll: '            <usedByLayers>3</usedByLayers>';
		crlf;
		nextPutAll: '            <usingLayers>2</usingLayers>';
		crlf;
		nextPutAll: '        </ACTSuppressOthers>';
		crlf;
		nextPutAll: '    </element>';
		crlf.
	aStartStream := ReadWriteStream on: String new.
	aStartStream
		nextPutAll: '<?xml version="1.0"?>';
		crlf;
		nextPutAll: '<!!--Moose2Model Layout data, visit moose2model.org on how to use this file-->';
		crlf;
		nextPutAll: '<elements>';
		crlf;
		nextPutAll: '    <version>' , layout actualVersion , '</version>';
		crlf;
		nextPutAll: '    <suppressed>packageBox</suppressed>';
		crlf;
		nextPutAll: '    <scope>method</scope>';
		crlf.
	aEndStream := ReadWriteStream on: String new.
	aEndStream nextPutAll: '</elements>'.
	aExpectedStream1 := ReadWriteStream on: String new.
	aExpectedStream2 := ReadWriteStream on: String new.
	aExpectedStream1
		nextPutAll: aStartStream contents;
		nextPutAll: aExpectedClass1Stream contents;
		nextPutAll: aExpectedMethod1Stream contents;
		nextPutAll: aEndStream contents.
	aExpectedStream2
		nextPutAll: aStartStream contents;
		nextPutAll: aExpectedMethod1Stream contents;
		nextPutAll: aExpectedClass1Stream contents;
		nextPutAll: aEndStream contents.
	aStream contents = aExpectedStream1 contents | (aStream contents = aExpectedStream2 contents)
		ifFalse: [ self assert: aStream equals: aExpectedStream ]! !

RWDiagramMooseModelTest subclass: #RWDiagramMooseEntityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramMooseEntityTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAsRWDiagramElement
	| editor layout elementGroup |
	editor := RWDiagramEditor new.
	self assert: (method1 asRWDiagramElement: editor) class = RWDiagramElement equals: true.
	self assert: editor globalElementGroup elementList size equals: 1.
	layout := RWDiagramLayout new.
	self assert: (method1 asRWDiagramElement: layout) class = RWDiagramElement equals: true.
	self assert: layout elementGroup elementList size equals: 1.	
	elementGroup := RWDiagramElementGroup new.
	self assert: (method1 asRWDiagramElement: elementGroup) class = RWDiagramElement equals: true.
	self assert: elementGroup elementList size equals: 1! !

!RWDiagramMooseModelTest methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setUp
	super setUp.
	"!! Do not format this methods, because it is easier to read with manual formatting !!"

	model := MooseModel new.
	package1 := FAMIXPackage new name: 'package1'; mooseModel: model.
	package1RWDE := RWDiagramElement famixElement: package1.
	package2 := FAMIXPackage new name: 'package2'; mooseModel: model.
	package2RWDE := RWDiagramElement famixElement: package2.
	namespace := FAMIXNamespace new name: 'Smalltalk'; mooseModel: model.
	class1 := FAMIXClass new name: 'class1'; parentPackage: package1; container: namespace; mooseModel: model.
	class1RWDE := RWDiagramElement famixElement: class1.
	class2 := FAMIXClass new name: 'class2'; parentPackage: package2; mooseModel: model.
	class2RWDE := RWDiagramElement famixElement: class2.
	classNopackage := FAMIXClass new name: 'classNopackage'; mooseModel: model.
	classNopackageRWDE := RWDiagramElement famixElement: classNopackage.
	inh := FAMIXInheritance new subclass: class1; superclass: class2; mooseModel: model.
	method1 := FAMIXMethod new name: 'method1'; parentType: class1; mooseModel: model; hasClassScope: true.
	method1RWDE := RWDiagramElement famixElement: method1.
	method2 := FAMIXMethod new name: 'method2'; parentType: class2; mooseModel: model.
	method2RWDE := RWDiagramElement famixElement: method2.
	method3 := FAMIXMethod new name: 'method3'; parentType: class2; mooseModel: model.
	method3RWDE := RWDiagramElement famixElement: method3.
	methodExt := FAMIXMethod new name: 'methodExt'; parentType: class2; parentPackage: package1; mooseModel: model.
	var1 := FAMIXAttribute new name: 'var1'; parentType: class2; declaredType: class1; mooseModel: model.
	var1RWDE := RWDiagramElement famixElement: var1.
	var2 := FAMIXAttribute new name: 'var2'; parentType: class2; mooseModel: model.
	var2RWDE := RWDiagramElement famixElement: var2.
	var3 := FAMIXLocalVariable new name: 'var3'; parentBehaviouralEntity: method2; declaredType: class1; mooseModel: model.
	var3RWDE := RWDiagramElement famixElement: var3.
	access := FAMIXAccess new accessor: method1; variable: var2; mooseModel: model.
	acc1 := FAMIXAccess new accessor: method2; variable: var1; mooseModel: model.
	inv1 := FAMIXInvocation new sender: method1; addCandidate: method2; receiver: var2; mooseModel: model.
	"inv2 := FAMIXInvocation new sender: method2; addCandidate: method2; receiver: var2; mooseModel: model."
	inv3 := FAMIXInvocation new sender: method3; addCandidate: method2; receiver: var2; mooseModel: model.
	ref1 := FAMIXReference new source: method1; target: class2; mooseModel: model.
	"Test invocations"
	methodI0P2 := FAMIXMethod new name: 'methodI0P2'; parentType: class1; mooseModel: model.
	methodI0P2RWDE := RWDiagramElement famixElement: methodI0P2.
	methodI0P1 := FAMIXMethod new name: 'methodI0P1'; parentType: class1; mooseModel: model.
	methodI0P1RWDE := RWDiagramElement famixElement: methodI0P1.
	inv0P2 := FAMIXInvocation new sender: methodI0P2; addCandidate: methodI0P1; mooseModel: model.
	methodI0 := FAMIXMethod new name: 'methodI0'; parentType: class1; mooseModel: model; hasClassScope: true.
	methodI0RWDE := RWDiagramElement famixElement: methodI0.
	inv0P1 := FAMIXInvocation new sender: methodI0P1; addCandidate: methodI0; mooseModel: model.
	methodI0M1 := FAMIXMethod new name: 'methodI0M1'; parentType: class1; mooseModel: model.
	methodI0M1RWDE := RWDiagramElement famixElement: methodI0M1.
	inv0 := FAMIXInvocation new sender: methodI0; addCandidate: methodI0M1; mooseModel: model.
	methodI0M2 := FAMIXMethod new name: 'methodI0M2'; parentType: class1; mooseModel: model.
	methodI0M2RWDE := RWDiagramElement famixElement: methodI0M2.
	inv0M1 := FAMIXInvocation new sender: methodI0M1; addCandidate: methodI0M2; mooseModel: model.
	"Test access to attributes"
	methodA0 := FAMIXMethod new name: 'methodA0'; parentType: class1; mooseModel: model.
	attributeA0 := FAMIXAttribute new name: 'attributeA0'; parentType: class1; mooseModel: model.
	attributeA0RWDE := RWDiagramElement famixElement: attributeA0.
	accI0 := FAMIXAccess new accessor: methodI0; variable: attributeA0; mooseModel: model.
	accA0 := FAMIXAccess new accessor: methodA0; variable: attributeA0; mooseModel: model.
	
	"So that printing methods works correctly"
   model allMethods do: [ :m | m signature: m name ]! !

!RWDiagramMooseModelTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSetUp
	"Copied from setUp of class MooseQueryTest"

	self assert: methodI0 class asString equals: 'FAMIXMethod'.

	model allMethods do: [ :m | self assert: m name equals: m signature ]! !

RWDiagramMooseModelTest subclass: #RWDiagramNoPackageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramNoPackageTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAdd
	| noPackage |
	noPackage := RWDiagramNoPackage new.
	noPackage add: class1RWDE.
	self assert: noPackage classes size equals: 1.
	self assert: noPackage classes first class equals: FAMIXClass! !

!RWDiagramNoPackageTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAsRWDiagramElement
	| noPackage |
	noPackage := RWDiagramNoPackage new.
	self assert: noPackage asRWDiagramElement class equals: RWDiagramElement! !

!RWDiagramNoPackageTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testMooseID
	| noPackage |
	noPackage := RWDiagramNoPackage new.
	self assert: noPackage mooseID equals: 0! !

RWDiagramMooseModelTest subclass: #RWDiagramSnapToGridTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramSnapToGridTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testActive
	"comment stating purpose of message"

	| s |
	s := RWDiagramSnapToGrid new.
	self assert: s active equals: false.
	s active: true.
	self assert: s active equals: true.
	s active: false.
	self assert: s active equals: false! !

!RWDiagramSnapToGridTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testElementSnap
	"comment stating purpose of message"

	| s |
	s := RWDiagramSnapToGrid new.
	s active: true.
	self assert: (s element: method1 snap: 1 @ 1) equals: 0 @ 0.
	s := RWDiagramSnapToGrid new.
	s active: true.
	self assert: (s element: var1 snap: 1 @ 1) equals: 0 @ 0.
	s := RWDiagramSnapToGrid new.
	s active: true.
	self assert: (s element: class1 snap: 1 @ 1) equals: 1 @ 1.
	s := RWDiagramSnapToGrid new.
	s active: true.
	self assert: (s element: package1 snap: 1 @ 1) equals: 1 @ 1! !

!RWDiagramSnapToGridTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testGridX
	"comment stating purpose of message"

	| s  |
	s := RWDiagramSnapToGrid new.
	s gridX: 5.
	self assert: s gridX equals: 5.
! !

!RWDiagramSnapToGridTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testGridY
	"comment stating purpose of message"

	| s |
	s := RWDiagramSnapToGrid new.
	s gridY: 5.
	self assert: s gridY equals: 5! !

!RWDiagramSnapToGridTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testInitialize
	"comment stating purpose of message"

	| s  |
	s := RWDiagramSnapToGrid new.
	self assert: s startX equals: 0.
	self assert: s startY equals: 0.
	self assert: s gridX equals: 10.
	self assert: s gridY equals: 10.
! !

!RWDiagramSnapToGridTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSnap
	"comment stating purpose of message"

	| s |
	s := RWDiagramSnapToGrid new.
	s startX: 1.
	s startY: 2.
	s gridX: 20.
	s gridY: 30.
	s active: false.
	self assert: (s snap: 25 @ 35) equals: 25 @ 35.
	s active: true.
	self assert: (s snap: 25 @ 35) equals: 21 @ 32.
	"The logic to reposition elements that would be at the same position is currently not activated"
	"self assert: (s snap: 25 @ 35) equals: 22 @ 33."
	s reset.
	self assert: (s snap: 25 @ 35) equals: 21 @ 32.! !

!RWDiagramSnapToGridTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testStartX
	"comment stating purpose of message"

	| s  |
	s := RWDiagramSnapToGrid new.
	s startX: 5.
	self assert: s startX equals: 5.
! !

!RWDiagramSnapToGridTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testStartY
	"comment stating purpose of message"

	| s  |
	s := RWDiagramSnapToGrid new.
	s startY: 5.
	self assert: s startY equals: 5.
! !

RWDiagramMooseModelTest subclass: #RWDiagramTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testMethodUsageWithEditorWithLayoutWithMondrianTest
	| classes diagram aRWDElementGroup view |
	classes := FAMIXClassGroup
		withAll:
			{class1.
			class2}.
	"Copy now part of FAMIXClassGroup>>viewRWDiagramDependency"
	diagram := RWDiagram new.
	aRWDElementGroup := RWDiagramElementGroup new.
	classes
		do: [ :each | 
			| anFElement |
			anFElement := RWDiagramElement famixElement: each.
			aRWDElementGroup add: anFElement ].
	view := diagram
		methodUsage: aRWDElementGroup
		withEditor: RWDiagramEditor new withLayout: nil withMondrian: nil ofMooseModel: MooseModel new test: true.! !

!RWDiagramTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testMethodUsageWithEditorWithMondrianTest
	| classes diagram aRWDElementGroup view |
	classes := FAMIXClassGroup
		withAll:
			{class1.
			class2}.
	"Copy now part of FAMIXClassGroup>>viewRWDiagramDependency"
	diagram := RWDiagram new.
	aRWDElementGroup := RWDiagramElementGroup new.
	classes
		do: [ :each | 
			| anFElement |
			anFElement := RWDiagramElement famixElement: each.
			aRWDElementGroup add: anFElement ].
	view := diagram
		methodUsage: aRWDElementGroup
		withEditor: RWDiagramEditor new withLayout: nil withMondrian: nil ofMooseModel: MooseModel new test: true.! !

RWDiagramAbstractTest subclass: #RWDiagramPositionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramPositionTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testPoint
	| ap |
	ap := RWDiagramPosition new.
	ap point: 10 @ 10.
	self assert: ap positionIsDetermined equals: true.
	self assert: ap point equals: 10 @ 10! !

RWDiagramAbstractTest subclass: #RWDiagramPositionableCommentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramPositionableCommentTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testPosition
	| co |
	co := RWDiagramPositionableComment new.
	self assert: co positionSet equals: false.
	self assert: co position equals: nil.
	co position: 10 @ 10.
	self assert: co position equals: 10 @ 10.
	self assert: co positionSet equals: true! !

RWDiagramAbstractTest subclass: #RWDiagramSettingsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramSettingsTest methodsFor: 'tests' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testDisplayFormatters
	| settings |
	settings := RWDiagramSettings new.
	self assert: settings displayFormatter equals: false.
	settings displayFormatter: true.
	self assert: settings displayFormatter equals: true! !

!RWDiagramSettingsTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testIsReading
|settings|
settings := RWDiagramSettings new.
settings isReading: true.
self assert: settings isReading equals: true! !

!RWDiagramSettingsTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testIsReadingPosition
|settings|
settings := RWDiagramSettings new.
settings isReadingPosition: true.
self assert: settings isReadingPosition equals: true! !

!RWDiagramSettingsTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testLCPOMaxChecks
|settings|
settings := RWDiagramSettings new.
self assert: settings lCPOMaxChecks equals: 100000.
settings lCPOMaxChecks: 5.
self assert: settings lCPOMaxChecks equals: 5! !

!RWDiagramSettingsTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testLCPORepeat
|settings|
settings := RWDiagramSettings new.
self assert: settings lCPORepeat equals: 100.
settings lCPORepeat: 15.
self assert: settings lCPORepeat equals: 15! !

!RWDiagramSettingsTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testLCPOSpace
|settings|
settings := RWDiagramSettings new.
self assert: settings lCPOSpace equals: 1.
settings lCPORepeat: 5.
self assert: settings lCPORepeat equals: 5! !

!RWDiagramSettingsTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testOffsetY
|settings|
settings := RWDiagramSettings new.
self assert: settings offsetY equals: 0.
settings offsetY: 100.
self assert: settings offsetY equals: 100! !

!RWDiagramSettingsTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testPreventOverlapping
|settings|
settings := RWDiagramSettings new.
self assert: settings preventOverlapping equals: false.
settings preventOverlapping: true.
self assert: settings preventOverlapping equals: true! !

RWDiagramAbstractTest subclass: #RWDiagramUndeterminedAttributeListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramUndeterminedAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAppearance
	| ga |
	ga := RWDiagramUndeterminedAttributeList new.
	self assert: ga appearance class equals: RWDiagramUndeterminedAppearance ! !

!RWDiagramUndeterminedAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testAttributeIsSpecified
	| ga |
	ga := RWDiagramUndeterminedAttributeList new.
	self assert: ga attributeIsSpecified equals: false! !

!RWDiagramUndeterminedAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testComment
	| ga al co |
	ga := RWDiagramUndeterminedAttributeList new.
	co := RWDiagramLocalComment text: 'A comment'.
	al := ga comment: co.
	self assert: al class equals: RWDiagramAttributeList.
	self assert: al comment equals: co! !

!RWDiagramUndeterminedAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testPosition
	| ga al |
	ga := RWDiagramUndeterminedAttributeList new.
	al := ga position: 10 @ 10.
	self assert: al class equals: RWDiagramAttributeList.
	self assert: al position point equals: 10 @ 10! !

!RWDiagramUndeterminedAttributeListTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testSuppressWithChildren
	| ga al |
	ga := RWDiagramUndeterminedAttributeList new.
	self assert: ga suppressWithChildren equals: false.
	al := ga suppressWithChildren: false.
	self assert: al class equals: RWDiagramAttributeList.
	self assert: al suppressWithChildren equals: false.
	al := ga suppressWithChildren: true.
	self assert: al suppressWithChildren equals: true
	
	
	! !

RWDiagramAbstractTest subclass: #RWDiagramUndeterminedPositionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-test'!

!RWDiagramUndeterminedPositionTest methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
testPositionIsDetermined
|ap|
ap := RWDiagramUndeterminedPosition new yourself.
self assert: ap positionIsDetermined equals: false! !

PackageManifest subclass: #ManifestRWMooseDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram'!

!ManifestRWMooseDiagram commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifestRWMooseDiagram class methodsFor: 'meta-data' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
description ^ 'Used to test Moose2Model on Smalltalk applications'! !

!ManifestRWMooseDiagram class methodsFor: 'code-critics' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
ruleRBOnlyReadOrWrittenTemporaryRuleV1FalsePositive
	^ #(#(#(#RGClassDefinition #(#RWDiagramEditor)) #'2016-06-26T08:09:43.773671+02:00') )! !

Object subclass: #Moose2ModelTestClass1
	instanceVariableNames: 'attribute1 attribute2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-testApplication'!

!Moose2ModelTestClass1 commentStamp: 'RainerWinkler 8/3/2017 22:09' prior: 0!
First test class!

!Moose2ModelTestClass1 class methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
method1
	"comment stating purpose of message"

	| |
	self method3! !

!Moose2ModelTestClass1 methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
method1
	"comment stating purpose of message"

	| |
	self method2! !

!Moose2ModelTestClass1 methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
method2
	"comment stating purpose of message"

	| |
	^attribute1! !

!Moose2ModelTestClass1 methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
method3
	"comment stating purpose of message"

	| |
	^attribute2! !

Object subclass: #RWDiagram
	instanceVariableNames: ''
	classVariableNames: 'automaticTestIsRunning path'
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagram commentStamp: 'RainerWinkler 9/7/2016 18:17' prior: 0!
I have the logic for drawing diagrams (Currently using Mondrian)

I have as class methods also a lot of shortcuts:

Manage reading and modifying positions and other features in applications that use diagrams based on RTMondrian.

--------------------------------------------------------------------------------------------------------------------
Layout:
--------------------------------------------------------------------------------------------------------------------

- Data can be read and stored to different views:
RWDiagram currentLayoutName: 'MyView'.

- To get the name of the current layout call:

RWDiagram currentLayoutName

- To set the current Layout to the one that corresponds to a diagram:
Option 1: Select the tab Raw on the inspected RTMondrian. Then perform:
RWDiagram setCurrentLayout: self view.

Option 2: Open an inspector on the view of the inspected RTMondrian. Then perform:
RWDiagram setCurrentLayout: self

- To get the Layout that corresponds to a diagram (see setCurrentLayout for details of syntax) call:
RWDiagram layoutForRTView: self view.

--------------------------------------------------------------------------------------------------------------------
Store positions:
--------------------------------------------------------------------------------------------------------------------

- To store positions call:
The positions are stored to the layout that has the same processed RTView

Option 1: Select the tab Raw on the inspected RTMondrian. Then perform:
RWDiagram rememberRTView: self view.

Option 2: Open an inspector on the view of the inspected RTMondrian. Then perform:
RWDiagram rememberRTView: self

--------------------------------------------------------------------------------------------------------------------
Adapt new diagram:
--------------------------------------------------------------------------------------------------------------------

Only diagrams that support this editor are adapted. This is currently for a class group. "RW Method Usages in Packages" in the category visualize.
You should display the diagram on "all classes" and not on "all model classes" , only then also interfaces and ... are displayed.

- To create a new diagram using the stored layout attributes use:
RWDiagram read.
- To create a new diagram using the stored position use:
RWDiagram readPositions.

- To inactivate the logic call: 
RWDiagram inActive.
RWDiagram inActivePositions.

- To display whether the logic is active print:
RWDiagram isReading
RWDiagram isReadingPosition

- To suppress box and names for packages and classes
(technically the boxes are still there and can be dragged)
RWDiagram packageBoxSuppressed: true.
RWDiagram classBoxSuppressed: true.
revert by setting to false.

--------------------------------------------------------------------------------------------------------------------
Prevent Overlapping:
--------------------------------------------------------------------------------------------------------------------
- Specify whether overlapping of Methods, Attributes and Comments is to be suppressed
RWDiagram preventOverlapping 
RWDiagram allowOverlapping

- Specify the number of iterations while preventing overlapping:
RWDiagram lCPORepeat: 10
- Display the current number of iterations:
RWDiagram lCPORepeat

- Set a space between elements:
RWDiagram lCPOSpace: 5
- Display the actual setting for the space:
RWDiagram lCPOSpace
--------------------------------------------------------------------------------------------------------------------
Commenting:
--------------------------------------------------------------------------------------------------------------------

- To comment an Element
RWDiagram comment: 'A comment' to: self
or with multiple lines:
RWDiagram comment: 'A comment<br>Second line' to: self

- To change the color for the comment in the current layout (for instance transparent):
RWDiagram commentColor: Color transparent.

--------------------------------------------------------------------------------------------------------------------
File access:
--------------------------------------------------------------------------------------------------------------------

- To save data to a file call:
RWDiagram writeToFile: 'ModelFormattingData.xml'.
The system saves the data of the current view.

- To save data for a view to the layout it belongs in a path (Perform on the raw tab of the inspector of the view):
RWDiagram write: self view  toPath: aPath

- To read data from a file call:
RWDiagram readFromFile: 'ModelFormattingData.xml'.
The data is loaded to the current view. Existing data is not deleted but overwritten.

--------------------------------------------------------------------------------------------------------------------
Actions on processed view:
--------------------------------------------------------------------------------------------------------------------

- Actions on a displayed diagram are by default performed on the processed view. 
This can be set explecitely for a RTMondrian:
RWDiagram processedRTView: self view.
or is done when a diagram is created using this logic.

- To color a Component of the processed view explicitely:
Navigate to the FAMIX element (for instance in the Moose Panel) and execute:
RWDiagram color: Color myColor FAMIXComponent: self.
replace myColor with a valid color (green, yellow, ...)

--------------------------------------------------------------------------------------------------------------------
Appearance (temporary and on processed view):
--------------------------------------------------------------------------------------------------------------------
Click on a element in the diagram and perform the following in the editor:

- To change the appearance of an element and his neighbours (is not  stored):

RWDiagram highlightIncludingMe: true usedByLayers: 2 usingLayers: 2  to: self

- To remove all temporary appearance changers from the current layout:
RWDiagram removeTemporary

--------------------------------------------------------------------------------------------------------------------
Appearance (permanent/stored to file):
--------------------------------------------------------------------------------------------------------------------
- To exclude everthing not selected with using and used layers:
Open the element in an inspector and call (replace true with false to undo):
RWDiagram suppressOthersUsedByLayers: usedByLayers usingLayers: usingLayers to: self

- To exclude a package, class, ... together with all sub elements from a diagram (stored to file):
Open the element in an inspector and call (replace true with false to undo):
RWDiagram suppressWithChildren: true to: self.

--------------------------------------------------------------------------------------------------------------------
Appearance (general):
--------------------------------------------------------------------------------------------------------------------

- To remove the appearance changers:
RWDiagram removeAppearanceChangersFrom: self

--------------------------------------------------------------------------------------------------------------------
Listings:
--------------------------------------------------------------------------------------------------------------------
- To list all available Layouts
RWDiagram listLayouts

- To show the setting of the current Layout
RWDiagram list


!

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
allowOverlapping
	| e |
	<RWDiaEdit_51>
	e := RWDiagramEditor uniqueInstance.
	e settings preventOverlapping: false! !

!RWDiagram class methodsFor: 'as yet unclassified' stamp: 'RainerWinkler 9/13/2019 16:28'!
automaticTestIsRunning
	automaticTestIsRunning ifNil: [ automaticTestIsRunning := false ].
	^ automaticTestIsRunning! !

!RWDiagram class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
automaticTestIsRunning: aFlag
	automaticTestIsRunning := aFlag! !

!RWDiagram class methodsFor: 'processedView' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
color: aColor FAMIXComponent: aFAMIXComponent
	<RWDiaEdit_2>
	"change the color of an element in the diagram temporary"
	| l |
	l := RWDiagramEditor uniqueInstance currentLayout .
	l color: aColor FAMIXComponent: aFAMIXComponent view: l processedRTView! !

!RWDiagram class methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
comment: aString to: aModelElement
	| e |
	<RWDiaEdit_9>
	<RWDiaEdit_10>
	<RWDiaEdit_63>
	"Add a comment to a Model Element
	Overwrites an existing comment"
	e := RWDiagramEditor uniqueInstance.
	self comment: aString to: aModelElement ofLayout: e currentLayout! !

!RWDiagram class methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
comment: aString to: aModelElement ofLayout: aRWDiagramLayout
	| aRWDiagramElement |
	"Add a comment to a Model Element
	Overwrites an existing comment"
	aRWDiagramElement := self convertToRWDiagramElement: aModelElement.
	aRWDiagramLayout comment: aString to: aRWDiagramElement! !

!RWDiagram class methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
commentColor: aColor
	| e |
	<RWDiaEdit_11>
	"Set the general color of comments (Use the color transparent to have no color)"
	e := RWDiagramEditor uniqueInstance.
	e currentLayout commentColor: aColor! !

!RWDiagram class methodsFor: 'appearancePermanent' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
convertToRWDiagramElement: aModelElement
	| aRWDiagramElement |
	aModelElement class = RWDiagramElement
		ifTrue: [ aRWDiagramElement := aModelElement ]
		ifFalse: [ aRWDiagramElement := RWDiagramElement famixElement: aModelElement ].
	^ aRWDiagramElement! !

!RWDiagram class methodsFor: 'layout' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
currentLayoutName
	| e |
	<RWDiaEdit_4>
	"Return the name of the current layout"
	e := RWDiagramEditor uniqueInstance.
	self inform: e currentLayoutName.
	^ e currentLayoutName! !

!RWDiagram class methodsFor: 'layout' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
currentLayoutName: aString
	<RWDiaEdit_3>
	| e |
	e := RWDiagramEditor uniqueInstance.
	"Specify the Layout to be processed"
	e currentLayoutName: aString.
	self inform: 'New layout: ' , aString , ' do not forget to call the method readFromPath'! !

!RWDiagram class methodsFor: 'sourceAnchor' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
getLinkTo: aModelElement
	| e |

	"Copies the link to a Model Element
	into the clipboard"
	e := RWDiagramEditor uniqueInstance.
	self getLinkTo: aModelElement ofLayout: e currentLayout! !

!RWDiagram class methodsFor: 'sourceAnchor' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
getLinkTo: aModelElement ofLayout: aRWDiagramLayout
	| e aRWDiagramElement |

	"Copies the link to a Model Element
	into the clipboard"
	aRWDiagramElement := self convertToRWDiagramElement: aModelElement.
	e := RWDiagramEditor uniqueInstance.
	e currentLayout getLinkTo: aRWDiagramElement! !

!RWDiagram class methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
globalComment: aString to: aMooseEntityOrRWDiagramElement
	| e |

	"Add a global comment to a Model Element"
	e := RWDiagramEditor uniqueInstance.
	e addGlobalComments: (RWDiagramGlobalComment text: 'Global') to: aMooseEntityOrRWDiagramElement! !

!RWDiagram class methodsFor: 'appearanceTermporary' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
highlightIncludingMe: includeMe usedByLayers: usedByLayers usingLayers: usingLayers to: aModelElement
	<RWDiaEdit_17>
	"Specify which elements shall be highlighted"
	self highlightIncludingMe: includeMe usedByLayers: usedByLayers usingLayers: usingLayers to: aModelElement ofLayout: RWDiagramEditor uniqueInstance currentLayout.
! !

!RWDiagram class methodsFor: 'appearanceTermporary' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
highlightIncludingMe: includeMe usedByLayers: usedByLayers usingLayers: usingLayers to: aModelElement ofLayout: aRWDiagramLayout
	| aRWDiagramElement |
	<RWDiaEdit_17>
	"Specify which elements shall be highlighted"
	
	(aModelElement class inheritsFrom: MooseEntity) ifTrue:[aRWDiagramElement := aModelElement asRWDiagramElement: aRWDiagramLayout]ifFalse:[aRWDiagramElement := aModelElement].
	aRWDiagramLayout
		addAppearanceChanger:
			(RWDiagramAppearanceChanger
				changeDeterminer:
					(RWDiagramACDStandard new
						includeMe: includeMe
						usedByLayers: usedByLayers
						usingLayers: usingLayers
						ofElement: aRWDiagramElement)
				changeType: RWDiagramACTHighlight new)
		to: aRWDiagramElement.
	"Now change the elements of the current layout"
	aRWDiagramLayout
		resetAppearance;
		evaluateAppearance;
		actualizeTemporaryAppearacenceInView: aRWDiagramLayout processedRTView! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
inActive
	| e |
	<RWDiaEdit_7>
	"Inactivate the reading of layout attributes while drawing a new diagram"
	e := RWDiagramEditor uniqueInstance.
	e settings isReading: false! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
inActiveLayers
	| e |
	e := RWDiagramEditor uniqueInstance.
	e settings isReadingLayers: false! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
inActivePositions
	| e |
	<RWDiaEdit_26>
	"Inactivate the reading of positions while drawing a new diagram"
	e := RWDiagramEditor uniqueInstance.
	e settings isReadingPosition: false! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isReading
	| e |
	<RWDiaEdit_8>
	"Display whether layout attributes will be read when a new diagram is drawn"
	e := RWDiagramEditor uniqueInstance.
	self inform: e settings isReading asString.
	^ e settings isReading! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isReadingLayers
	| e |
	e := RWDiagramEditor uniqueInstance.
	self inform: e settings isReadingLayers asString.
	^ e settings isReadingLayers! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isReadingPosition
	| e |
	<RWDiaEdit_27>
	"Display whether positions will be read when a new diagram is drawn"
	e := RWDiagramEditor uniqueInstance.
	self inform: e settings isReadingPosition asString.
	^ e settings isReadingPosition! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPOMaxChecks
	| e |
	<RWDiaEdit_60>
	"Display the number of iterations for preventing overlapping"
	e := RWDiagramEditor uniqueInstance.
	self inform: e settings lCPOMaxChecks asString.
	^ e settings lCPOMaxChecks! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPOMaxChecks: anInteger
	| e |
	<RWDiaEdit_59>
	"Change the number of iterations for preventing overlapping"
	e := RWDiagramEditor uniqueInstance.
	e settings lCPOMaxChecks: anInteger! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPORepeat
	| e |
	<RWDiaEdit_53>
	"Display the number of iterations for preventing overlapping"
	e := RWDiagramEditor uniqueInstance.
	self inform: e settings lCPORepeat asString.
	^ e settings lCPORepeat! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPORepeat: anInteger
	| e |
	<RWDiaEdit_52>
	"Change the number of iterations for preventing overlapping"
	e := RWDiagramEditor uniqueInstance.
	e settings lCPORepeat: anInteger! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPOSpace
	| e |
	<RWDiaEdit_55>
	"Display the number of iterations for preventing overlapping"
	e := RWDiagramEditor uniqueInstance.
	self inform: e settings lCPOSpace asString.
	^ e settings lCPOSpace ! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPOSpace: anInteger
	| e |
	<RWDiaEdit_54>
	"Change the number of iterations for preventing overlapping"
	e := RWDiagramEditor uniqueInstance.
	e settings lCPOSpace: anInteger! !

!RWDiagram class methodsFor: 'layout' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
layoutForRTView: aRTView
	<RWDiaEdit_44>
	| e ln |
	e := RWDiagramEditor uniqueInstance.
	ln := (e layoutForRTView: aRTView) name.
	self inform: ln.
	^ ln! !

!RWDiagram class methodsFor: 'listings' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
listLayouts
<RWDiaEdit_22>
	| e |
	"List all stored Layouts"
	e := RWDiagramEditor uniqueInstance.
	e listLayouts! !

!RWDiagram class methodsFor: 'name lookup' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!RWDiagram class methodsFor: 'sourceAnchor' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
openLinkTo: aModelElement
	| e |

	"Copies the link to a Model Element
	into the clipboard"
	e := RWDiagramEditor uniqueInstance.
	self openLinkTo: aModelElement ofLayout: e currentLayout! !

!RWDiagram class methodsFor: 'sourceAnchor' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
openLinkTo: aModelElement ofLayout: aRWDiagramLayout
	| aRWDiagramElement |

	"Copies the link to a Model Element
	into the clipboard"
	aRWDiagramElement := self convertToRWDiagramElement: aModelElement.
	aRWDiagramLayout openLinkTo: aRWDiagramElement! !

!RWDiagram class methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
path
	path ifNil: [ path := '' ].
	path = ''
		ifTrue: [ ^ FileSystem disk workingDirectoryPath asFileReference fullName ]
		ifFalse: [ ^ path ]! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
preventOverlapping
	| e |
	<RWDiaEdit_51>
	e := RWDiagramEditor uniqueInstance.
	e settings preventOverlapping: true! !

!RWDiagram class methodsFor: 'processedView' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
processedRTView
<RWDiaEdit_16>
	| l |
	"Returns the informations on the processed view"
	l := RWDiagramEditor uniqueInstance currentLayout .
	^ l processedRTView! !

!RWDiagram class methodsFor: 'processedView' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
processedRTView: aRTView
<RWDiaEdit_15>
	| l |
	"Set the processed View manually"
	l := RWDiagramEditor uniqueInstance currentLayout .
	l processedRTView: aRTView! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
read
	| e |
	<RWDiaEdit_6>
	"Activate reading of layout attributes for a new diagram"
	e := RWDiagramEditor uniqueInstance.
	e settings isReading: true! !

!RWDiagram class methodsFor: 'FileAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readFromFile: aFilename expliciteStream: aStream
	| e |
	<RWDiaEdit_13>
	<RWDiaEdit_31>
	<RWDiaEdit_43>
	"Supports automatic tests"
	"Read layout informations from file to the processed layout"
	e := RWDiagramEditor uniqueInstance.
	e setLayOutFromFilename: aFilename.
	e readFromFile: aFilename expliciteStream: aStream! !

!RWDiagram class methodsFor: 'FileAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readFromPath: aPath expliciteStream: aStream
	<RWDiaEdit_13>
	<RWDiaEdit_43>
	| e filename localPath delimiter |
	"Supports automatic tests"
	"28.8.2019, the local variable path shadowed the global variable path. It is renamed, because otherwise codechanges where not possible"
	"Read a file named like the current Layout from a given path"
	e := RWDiagramEditor uniqueInstance.
	delimiter := DiskStore currentFileSystem delimiter.
	aPath last = delimiter
		ifTrue: [ localPath := aPath ]
		ifFalse: [ localPath := aPath , delimiter asString ].
	
	filename := localPath , self currentLayoutName , '.xml'.
	e readFromFile: filename expliciteStream: aStream! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readLayers: aOffsetY
	<RWDiaEdit_48>
	| e |
	e := RWDiagramEditor uniqueInstance.
	e settings isReadingLayers: true.
	e settings offsetY: aOffsetY! !

!RWDiagram class methodsFor: 'layout' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readLayout: aString
	| e |
	"Only used from playground"
	path
		ifNil: [ self inform: 'Specify a global path using RWDiagram setPath: myPath' ]
		ifNotNil: [ e := RWDiagramEditor uniqueInstance.
			"Specify the Layout to be processed"
			e currentLayoutName: aString.
			e currentLayout refresh.
			self readFromPath: path expliciteStream: nil.
			self inform: 'Layout: ' , aString , ' was read from path ' , path ]! !

!RWDiagram class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readLayout: aString ofMooseModel: aMooseModel expliciteStream: aStream
	| e |
	"Supports automatic tests"
	e := RWDiagramEditor uniqueInstance.
	"Specify the Layout to be processed"
	e currentLayoutName: aString.
	e currentLayout refresh.
	e currentLayout mooseID = aMooseModel mooseID
		ifFalse: [ e refreshLayout: e currentLayout.
			e currentLayout mooseID: aMooseModel mooseID ].
	self readFromPath: RWDiagram path expliciteStream: aStream.
	self inform: 'Layout: ' , aString , ' was read from path ' , RWDiagram path! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readPositions
	| e |
	<RWDiaEdit_25>
	"Activate reading of positions for a new diagram"
	e := RWDiagramEditor uniqueInstance.
	e settings isReadingPosition: true! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refresh
	<RWDiaEdit_62>
	"Inactivate the reading of positions while drawing a new diagram"
	RWDiagramEditor refresh.
	RWDiagramElement refresh. "To clear the internal list with hash values"
	
	RWDiagramSimpleGui getInstance redrawMe! !

!RWDiagram class methodsFor: 'adaptNewDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
rememberLastUsedDiagram
	| e |
	e := RWDiagramEditor uniqueInstance.
	RWDiagram rememberWrite: ( e lastUsedView view )! !

!RWDiagram class methodsFor: 'storePositions' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
rememberRTView: aRTView
	<RWDiaEdit_5>
	<RWDiaEdit_35>
	<RWDiaEdit_40>
	| e l previousLayoutName |
	e := RWDiagramEditor uniqueInstance.
	"Store the positions of the displayed view to the processed Layout"
	"Set current layout if it is different"
	previousLayoutName := e currentLayoutName.
	l := e layoutForRTView: aRTView message: true.
	l isDefined
		ifTrue: [ e rememberRTView: aRTView to: l.
			previousLayoutName = l name
				ifTrue: [ self inform: 'Positions remembered to layout: ' , l name ]
				ifFalse: [ e currentLayoutName: l name.
					self
						inform:
							'Positions remembered to layout: ' , l name , ' Layout is changed, old: ' , previousLayoutName , ' new: '
								, l name ] ]
		ifFalse: [ UIManager default alert: 'No positions are stored' ]! !

!RWDiagram class methodsFor: 'FileAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
rememberWrite: aRTView
  " Write to the global path"
	RWDiagram rememberRTView: aRTView.
	RWDiagram write: aRTView toPath: RWDiagram path! !

!RWDiagram class methodsFor: 'FileAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
rememberWrite: aRTView toPath: aPath
	RWDiagram rememberRTView: aRTView.
	RWDiagram write: aRTView toPath: aPath! !

!RWDiagram class methodsFor: 'appearanceGeneral' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
removeAppearanceChangersFrom: aModelElement
<RWDiaEdit_19>
<RWDiaEdit_64>
	| e |
	"Remove all Appearance changes to element (Temporary and permanent)"
	e := RWDiagramEditor uniqueInstance.
	self removeAppearanceChangersFrom: aModelElement ofLayout: e currentLayout! !

!RWDiagram class methodsFor: 'appearanceGeneral' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
removeAppearanceChangersFrom: aModelElement ofLayout: aRWDiagramLayout
<RWDiaEdit_19>
<RWDiaEdit_64>
	"Remove all Appearance changes to element (Temporary and permanent)"
	aRWDiagramLayout removeAppearanceChangersFrom: aModelElement! !

!RWDiagram class methodsFor: 'appearanceTermporary' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
removeTemporary
	<RWDiaEdit_1>
	| l |
	"Delete all temporary appearances"
	l := RWDiagramEditor uniqueInstance currentLayout.
	self removeTemporaryOfLayout: l! !

!RWDiagram class methodsFor: 'appearanceTermporary' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
removeTemporaryOfLayout: aRWDiagramLayout
	<RWDiaEdit_1>
	"Delete all temporary appearances"
   aRWDiagramLayout removeTemporary.

	"Now change the elements of the current layout"
	aRWDiagramLayout
		resetAppearance;
		evaluateAppearance;
		actualizeTemporaryAppearacenceInView: aRWDiagramLayout processedRTView! !

!RWDiagram class methodsFor: 'scope' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setClassScope
	<RWDiaEdit_67>
	| e |
	e := RWDiagramEditor uniqueInstance.
	e currentLayout scope: e currentLayout classScope! !

!RWDiagram class methodsFor: 'layout' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setCurrentLayout: aRTView
	| e |
	<RWDiaEdit_39>
	"Specify the Layout to be processed"
	e := RWDiagramEditor uniqueInstance.
	e setCurrentLayout: aRTView message: true! !

!RWDiagram class methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setMethodScope
	<RWDiaEdit_69>
	| e |
	e := RWDiagramEditor uniqueInstance.
	e currentLayout scope: e currentLayout methodScope! !

!RWDiagram class methodsFor: 'scope' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setMultiLineStyle

	| e |
	e := RWDiagramEditor uniqueInstance.
	e currentLayout lineStyle: e currentLayout multiLineStyle! !

!RWDiagram class methodsFor: 'scope' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setPackageScope
	| e |
	<RWDiaEdit_66>

	e := RWDiagramEditor uniqueInstance.
	e currentLayout scope: e currentLayout packageScope! !

!RWDiagram class methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setPath: aPath
	"Set globally used path for this models that are processed in this image"

	path := aPath.
	RWDiagramSimpleGui getInstance redrawMe! !

!RWDiagram class methodsFor: 'scope' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setStraightLineStyle
	<RWDiaEdit_67>
	| e |
	e := RWDiagramEditor uniqueInstance.
	e currentLayout lineStyle: e currentLayout straightLineStyle! !

!RWDiagram class methodsFor: 'appearancePermanent' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressOthersUsedByLayers: usedByLayers usingLayers: usingLayers to: aModelElement
	<RWDiaEdit_24>
	self suppressOthersUsedByLayers: usedByLayers usingLayers: usingLayers to: aModelElement ofLayout: RWDiagramEditor uniqueInstance currentLayout.
! !

!RWDiagram class methodsFor: 'appearancePermanent' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressOthersUsedByLayers: usedByLayers usingLayers: usingLayers to: aModelElement ofLayout: aRWDiagramLayout
	<RWDiaEdit_24>
	| aRWDiagramElement |
	aRWDiagramElement := self convertToRWDiagramElement: aModelElement.
	"Specify which elements shall not be suppressed"
	aRWDiagramLayout
		addAppearanceChanger:
			(RWDiagramAppearanceChanger
				changeDeterminer:
					(RWDiagramACDStandard new
						includeMe: true
						usedByLayers: usedByLayers
						usingLayers: usingLayers
						ofElement: aRWDiagramElement)
				changeType: RWDiagramACTSuppressOthers new)
		to: aRWDiagramElement! !

!RWDiagram class methodsFor: 'appearancePermanent' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressWithChildren: aBoolean to: aModelElement
<RWDiaEdit_18>
"To exclude a package, class, ... together with all sub elements from a diagram (stored to file)"
	| e |
	e := RWDiagramEditor uniqueInstance.
self suppressWithChildren: aBoolean to: aModelElement ofLayout: e currentLayout! !

!RWDiagram class methodsFor: 'appearancePermanent' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressWithChildren: aBoolean to: aModelElement ofLayout: aRWDiagramLayout
<RWDiaEdit_18>
"To exclude a package, class, ... together with all sub elements from a diagram (stored to file)"
	| e aRWDiagramElement |
	e := RWDiagramEditor uniqueInstance.
    (aModelElement class inheritsFrom: MooseEntity) ifTrue:[aRWDiagramElement := aModelElement asRWDiagramElement: e]ifFalse:[aRWDiagramElement := aModelElement].	
	e suppressWithChildren: aBoolean to: aRWDiagramElement ofLayout: aRWDiagramLayout! !

!RWDiagram class methodsFor: 'FileAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
write: aRTView toPath: aPath
	<RWDiaEdit_41>
	<RWDiaEdit_42>
	| e filename delimiter info oldName l |
	"Store to a file named like layout that belongs to the RTView in a path"
	delimiter := DiskStore currentFileSystem delimiter.
	aPath last = delimiter
		ifTrue: [ path := aPath ]
		ifFalse: [ path := aPath, delimiter asString ].
	e := RWDiagramEditor uniqueInstance.
	l := e layoutForRTView: aRTView message: true.
	l isDefined
		ifTrue: [ filename := path , l moose2ModelName , '.xml'.
			e writeToFile: filename.
			info := 'layout ' , l moose2ModelName , ' saved to ' , filename.
			oldName := e currentLayout moose2ModelName.
			oldName = l moose2ModelName
				ifFalse: [ e currentLayoutName: l moose2ModelName.
					info := info , ' old Layout: ' , oldName , ' changed to: ' , l moose2ModelName ].
			self inform: info ]
		ifFalse: [ UIManager default alert: 'No Layout assigned to this view. Perform save for the processed View of a Layout. You may use the most recently written diagram for this.' ]! !

!RWDiagram class methodsFor: 'FileAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
writeToFile: aFilename
	"Write data of current Layout to file"

	<RWDiaEdit_12>
	<RWDiaEdit_46>
	| e fn |
	e := RWDiagramEditor uniqueInstance.
	fn := (FileSystem disk pathFromString: aFilename) basenameWithoutExtension.
	e currentLayoutName = fn
	   ifTrue: [ e write: e currentLayout toFile: aFilename ]
		ifFalse: [ (self
				confirm: 'Filename ' , fn , ' is different from current Layout ' , e currentLayoutName , 'Do you still want to save?')
				ifTrue: [ e write: e currentLayout toFile: aFilename ]
				ifFalse: [ self inform: 'Nothing is saved' ] ]! !

!RWDiagram methodsFor: 'constants' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
aByteString
	^ #ByteString! !

!RWDiagram methodsFor: 'constants' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
aFAMIXAttribute
	^ #FAMIXAttribute! !

!RWDiagram methodsFor: 'constants' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
aFAMIXClass
	^ #FAMIXClass! !

!RWDiagram methodsFor: 'constants' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
aFAMIXMethod
	^ #FAMIXMethod! !

!RWDiagram methodsFor: 'constants' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
aFAMIXPackage
	^ #FAMIXPackage! !

!RWDiagram methodsFor: 'constants' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
aUndefinedObject
	^ #UndefinedObject! !

!RWDiagram methodsFor: 'version' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
actualVersion
	^ 'v1.3.2'! !

!RWDiagram methodsFor: 'MethodUsage-private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
addContextMenuAttributesMethodsToMondrian: aRTMondrian ofLayout: aRWDiagramLayout
	| aRTMenuActivable |
	"Test connection 4"
	aRTMenuActivable := aRTMondrian interaction menu.	"Context menu attributes and methods"
	aRTMenuActivable
		item: 'Add with neighbours'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram
				suppressOthersUsedByLayers: 1
				usingLayers: 1
				to: e model
				ofLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Remove Appearance Changers'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram removeAppearanceChangersFrom: e model ofLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Hightlight with neighbours'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram
				highlightIncludingMe: true
				usedByLayers: 1
				usingLayers: 1
				to: e model
				ofLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Hightlight used by'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram
				highlightIncludingMe: false
				usedByLayers: 1
				usingLayers: 0
				to: e model
				ofLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Hightlight'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram
				highlightIncludingMe: true
				usedByLayers: 0
				usingLayers: 0
				to: e model
				ofLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Hightlight using'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram
				highlightIncludingMe: false
				usedByLayers: 0
				usingLayers: 1
				to: e model
				ofLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Remove all highlighting'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram removeTemporaryOfLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Comment'
		action: [ :e | 
			| c |
			self setLayoutCurrent: aRWDiagramLayout.
			c := UIManager default textEntry: 'Specify a new comment (use <br> to specify a line break)' title: '' entryText: e model attributeList comment text.
			c ifNotNil: [ RWDiagram comment: c to: e model ofLayout: aRWDiagramLayout ] ].
	aRTMenuActivable
		item: 'Suppress'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			(RWDiagram automaticTestIsRunning ifFalse:[
			   UIManager default question: 'Do you want to suppress element ' , e model moose2ModelName , ' ?']
		      ifTrue:[true])
				ifTrue: [ RWDiagram suppressWithChildren: true to: e model ofLayout: aRWDiagramLayout ] ].
	aRTMenuActivable
		item: 'Redo suppress'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram suppressWithChildren: false to: e model ofLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Inspect coding element'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			e model inspect ].
	aRTMenuActivable
		item: 'Inspect diagram element'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			e inspect ].
	aRTMenuActivable
		item: 'Copy link to coding to Clipboard'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram getLinkTo: e model ofLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Open URL to coding'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram openLinkTo: e model ofLayout: aRWDiagramLayout ]
! !

!RWDiagram methodsFor: 'MethodUsage-private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
addContextMenuClassesPackagesToMondrian: aRTMondrian ofLayout: aRWDiagramLayout
	| aRTMenuActivable |
	aRTMenuActivable := aRTMondrian interaction menu.	"Context menu attributes and methods"
	aRTMenuActivable
		item: 'Comment'
		action: [ :e | 
			| c |
			self setLayoutCurrent: aRWDiagramLayout.
			c := UIManager default textEntry: 'Specify a new comment (use <br> to specify a line break)' title: '' entryText: e model attributeList comment text.
			c ifNotNil: [ RWDiagram comment: c to: e model ofLayout: aRWDiagramLayout ] ].
	aRTMenuActivable
		item: 'Suppress with all contained classes, methods and attributes'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			(RWDiagram automaticTestIsRunning ifFalse:[
			UIManager default question: 'Do you want to suppress element ' , e model moose2ModelName , 'with all contained elements'
			]
		      ifTrue:[true]
			)
				ifTrue: [ RWDiagram suppressWithChildren: true to: e model ofLayout: aRWDiagramLayout ] ].
	aRTMenuActivable
		item: 'Redo suppress with all contained classes, methods and attributes'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram suppressWithChildren: false to: e model ofLayout: aRWDiagramLayout ].
   aRTMenuActivable
		item: 'Inspect coding element'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			e model inspect ].
	aRTMenuActivable
		item: 'Inspect diagram element'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			e inspect ].
	aRTMenuActivable
		item: 'Copy link to coding to Clipboard'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram getLinkTo: e model ofLayout: aRWDiagramLayout ].
	aRTMenuActivable
		item: 'Open URL to coding'
		action: [ :e | 
			self setLayoutCurrent: aRWDiagramLayout.
			RWDiagram openLinkTo: e model ofLayout: aRWDiagramLayout ]! !

!RWDiagram methodsFor: 'MethodUsage-calledFromMoose' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
addMenuTo: aRWDiagramElementGroup withEditor: rwEditor withLayout: rwLayout withMondrian: b ofMooseModel: aMooseModel test: isTest
	b view
		@
			(RTMenuActivable
				new;
				item: 'Layout: ' , rwLayout moose2ModelName
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					self inform: rwLayout moose2ModelName ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Model: ' , aMooseModel moose2ModelName
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					self inform: aMooseModel moose2ModelName ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Redraw in same window'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwEditor settings displayFormatter: false.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Redraw in same window with formatting info'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwEditor settings displayFormatter: true.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Remember to file'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwEditor rememberRTView: b view to: rwLayout.
					RWDiagram write: b view toPath: RWDiagram path	"RWDiagram rememberWrite: e" ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Remember'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwEditor rememberRTView: b view to: rwLayout	"RWDiagram rememberRTView: e" ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Lines straight'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwEditor rememberRTView: b view to: rwLayout.
					rwLayout lineStyle: rwLayout straightLineStyle.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Lines multiline'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwEditor rememberRTView: b view to: rwLayout.
					rwLayout lineStyle: rwLayout multiLineStyle.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Lines multiline (horizontal)'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwEditor rememberRTView: b view to: rwLayout.
					rwLayout lineStyle: rwLayout multiLineStyle2.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Set mode to display methods, attributes, classes and packages (Default)'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwLayout scope: rwLayout methodScope.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Set mode to display classes and packages'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwLayout classBoxSuppressed: false.
					rwLayout scope: rwLayout classScope.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Set mode to display only packages'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwLayout packageBoxSuppressed: false.
					rwLayout scope: rwLayout packageScope.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Snap to grid'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwEditor rememberRTView: b view to: rwLayout.
					rwLayout snapToGrid gridX: 5.
					rwLayout snapToGrid gridY: 5.
					rwLayout snapToGrid active: true.
					self readToRTView: b view withEditor: RWDiagramEditor uniqueInstance withLayout: rwLayout.
					rwLayout snapToGrid active: false.
					e signalUpdate ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Remove all highlighting'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					RWDiagram removeTemporaryOfLayout: rwLayout ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'List elements of Layout to Transcript'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwLayout listWithComments: true ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'List elements of Layout to Transcript without comments'
					action: [ :e | 
					self setLayoutCurrent: rwLayout.
					rwLayout listWithComments: false ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Toogle Package display'
					action: [ :e | 
					rwLayout packageBoxSuppressed: rwLayout packageBoxSuppressed not.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Toogle Class display'
					action: [ :e | 
					rwLayout classBoxSuppressed: rwLayout classBoxSuppressed not.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ]).
	b view
		@
			(RTMenuActivable
				new;
				item: 'Toogle arrows (Point to using component)'
					action: [ :e | 
					rwLayout displayDependencies: rwLayout displayDependencies not.
					self
						redraw: aRWDiagramElementGroup
						view: e
						withEditor: rwEditor
						withLayout: rwLayout
						mondrian: b
						ofMooseModel: aMooseModel
						test: isTest ])! !

!RWDiagram methodsFor: 'MethodUsage-private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributesWithEditor: rwEditor class: clsRWDiagramElement layout: rwLayout mondrian: b
	<duplicate_attr_color>
	| displayedAttributes |
	displayedAttributes := clsRWDiagramElement dAttributes collect: [ :each | each asRWDiagramElement: rwLayout ].
	rwEditor settings isReading
		ifTrue: [ displayedAttributes := displayedAttributes reject: [ :c | rwLayout isModelElementNotShownWithChildren: c ] ].
	b shape ellipse
		if: [ :m | rwLayout highlight: m ] fillColor: rwLayout colorSchema attributeHighLightedColor;
		if: [ :m | (rwLayout highlight: m) not ] fillColor: rwLayout colorSchema attributeColor;
		width: 20;
		height: 20;
		withText: #dName;
		fontSize: 6;
		withTextColor: Color black.
	self addContextMenuAttributesMethodsToMondrian: b ofLayout: rwLayout.
	b nodes: displayedAttributes.
	b layout grid.
	self
		drawComments: b
		modelElements: displayedAttributes
		editor: rwEditor
		entity: self aFAMIXAttribute
		ofLayout: rwLayout.
	^ b layout grid! !

!RWDiagram methodsFor: 'MethodUsage-private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
drawComments: b modelElements: aMooseElements editor: rwEditor entity: aFAMIXEntity ofLayout: aRWDiagramLayout
	| comments globalComments relevantComments relevantGlobalComments allComments |
	relevantComments := Bag new.
	relevantGlobalComments := Bag new.

	comments := rwEditor commentsOf: aMooseElements forLayout: aRWDiagramLayout.	" Draw comments for packages"
	comments
		do: [ :c | 
			aMooseElements
				do: [ :e | 
					e class = RWDiagramElement
						ifTrue: [ c uniqueKeyOfCommentedElement = e uniqueKey
								ifTrue: [ relevantComments add: c ] ]ifFalse:[] ] ].
	globalComments := rwEditor globalCommentsOf: aMooseElements.	" Draw comments for packages"
	globalComments
		do: [ :c | 
			aMooseElements
				do: [ :e | 
					e class = RWDiagramElement
						ifTrue: [ c uniqueKeyOfCommentedElement = e uniqueKey
								ifTrue: [ relevantGlobalComments add: c ] ] ] ].
	b shape
		rectangle;
		width: 60;
		height: 20;
		withText: #text;
		fontSize: aRWDiagramLayout colorSchema commentFontSize;
		withTextColor: Color black;
		fillColor: aRWDiagramLayout commentColor;
		noBorder.
	b nodes: relevantComments.
	b shape
		rectangle;
		width: 60;
		height: 20;
		withText: #text;
		withTextColor: Color black;
		fillColor: rwEditor defaultGlobalCommentColor;
		noBorder.
	b nodes: relevantGlobalComments.
	"Connect elements to comments"
	b shape
		line
		color: Color orange trans;
		withShorterDistanceAttachPoint.
	allComments := relevantComments union: relevantGlobalComments.
	allComments
		do: [ :c | 
			(c class inheritsFrom: RWDiagramAbstractComment)
				ifTrue: [ b view elements
						do: [ :e | 
							e model class = RWDiagramElement
								ifTrue: [ (e model famixElement class inheritsFrom: MooseEntity)
										ifTrue: [ c uniqueKeyOfCommentedElement = e model uniqueKey
												ifTrue: [ b edges connectFrom: c to: e model ] ] ] ] ] ].
	^ allComments! !

!RWDiagram methodsFor: 'MethodUsage-calledFromMoose' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
handleInvisibleElementsForMondrian: b layout: rwLayout
	b view elements
		do: [ :e | 
			e model class asString = #RWDiagramElement
				ifTrue: [ rwLayout packageBoxSuppressed
						ifTrue: [ e model famixElement class asString = #FAMIXPackage
								ifTrue: [ e announcer initialize ] ].
					e model famixElement class asString = #FAMIXClass
						ifTrue: [ rwLayout classBoxSuppressed
								ifTrue: [ e announcer initialize ].
							(e model famixElement modifiers includesAnyOf: #(#DBTable))
								ifTrue: [ e announcer initialize ] ] ] ]! !

!RWDiagram methodsFor: 'constants' stamp: 'RainerWinkler 8/31/2019 13:24'!
isFAMIXAttribute: aFamixElement
	^ #( #FAMIXAttribute #FamixStAttribute ) includes: aFamixElement class asString! !

!RWDiagram methodsFor: 'as yet unclassified' stamp: 'RainerWinkler 8/31/2019 13:28'!
isFAMIXClass: aFAMIXClass 
	^#( #FAMIXClass #FamixStClass ) includes: aFAMIXClass class asString! !

!RWDiagram methodsFor: 'as yet unclassified' stamp: 'RainerWinkler 8/31/2019 13:30'!
isFAMIXMethod: aFAMIXMethod 
	^#( #FAMIXMethod #FamixStMethod ) includes: aFAMIXMethod class asString! !

!RWDiagram methodsFor: 'as yet unclassified' stamp: 'RainerWinkler 8/31/2019 13:31'!
isFAMIXPackage: aFAMIXPackage 
	^#( #FAMIXPackage #FamixStPackage ) includes: aFAMIXPackage class asString! !

!RWDiagram methodsFor: 'MethodUsage-calledFromMoose' stamp: 'RainerWinkler 9/1/2019 10:50'!
methodUsage: aRWDiagramElementGroup withEditor: rwEditor withLayout: aRWDiagramLayout withMondrian: aRTMondrian ofMooseModel: aMooseModel test: isTest
	" Thanks to Alexandre Bergel for the first version with Accesses to attributes
  Grouping into packages by Rainer Winkler "

	"Version from 20.05.2016
Handles the modifies DBTable to color database tables differently
	Version 23.05.2016 solve issue with missed lines
	Version 18.07.2016 major changes. No node for attribute and method anymore (reduces problems while reshaping the diagram)
	Version 29.12.2017
	Support rebuilding in same Window. If aRTMondrian is nil, a new Mondrian is build otherwise an existing is rebuild.
"

	<RWDiaEdit_65>
	<RWDiaEdit_70>
	<duplicate_database_attr_color>
	<menuItem: 'RW Method Usages in Packages d' category: 'Visualize'>
	| b isRebuild lb rwLayout allPackages displayedClasses allClassesForPackage dataBaseTables displayedAttributes allMethods |
	"Connect elements to comments"
	"b edges objects: comments; connectToAll: #mooseID."
	"b edges elements: b view elements; source: (aFAMIXGroup flatCollect: [:e | e mooseID ]) connectFrom: #mooseID to: #mooseID."
	"Now assign the arrows after all nodes are calculated"
	aRTMondrian
		ifNil: [ isRebuild := false ]
		ifNotNil: [ isRebuild := true ].
	aRWDiagramLayout
		ifNil: [ rwLayout := rwEditor currentLayout ]
		ifNotNil: [ rwLayout := aRWDiagramLayout ].
	rwLayout mooseID
		ifNil:
			[ "In a layout is new, the Moose ID is initial" rwLayout mooseID: aMooseModel mooseID ].
	rwLayout mooseID = aMooseModel mooseID
		ifFalse: [ rwEditor refreshLayout: rwLayout.
			rwLayout mooseID: aMooseModel mooseID ].
	isTest
		ifFalse: [ isRebuild
				ifFalse: [ aMooseModel sourceLanguage ifNotNil: [ aMooseModel sourceLanguage name = 'Smalltalk'
						ifTrue: [ (('Pharo7.*' match: SmalltalkImage current version)
								or: ('Pharo8.*' match: SmalltalkImage current version))
								ifTrue: [ "Inform that Smalltalk is not supported"self popUpSmalltalkNotSupported ifFalse: [ "Leave processing" ^ nil ] ] ] ] ] ].
	isTest
		ifFalse: [ rwLayout scope = rwLayout methodScope
				ifTrue: [ rwLayout elementGroup elementList size = 0
						ifTrue: [ "Warn that runtime can be long" self popUpAllElementsDisplayed
								ifFalse: [ "Leave processing" ^ nil ] ]
						ifFalse: [ [ rwLayout elementGroup elementList
								detect: [ :each | each attributeList attributeIsSpecified ] ]
								on: NotFound
								do: [ "Warn that runtime can be long" self popUpAllElementsDisplayed
										ifFalse: [ "Leave processing" ^ nil ] ] ] ] ].
	rwLayout refresh.
	rwLayout replaceElementsFromFAMIXGroup: aRWDiagramElementGroup.
	rwLayout resetAppearance.
	rwLayout evaluateAppearance.
	allPackages := aRWDiagramElementGroup dAllModelPackages.
	rwEditor settings isReading
		ifTrue: [ allPackages := allPackages
				reject: [ :p | rwLayout isModelElementNotShownWithChildren: p ] ].
	isRebuild
		ifFalse: [ b := RTMondrian new ]
		ifTrue: [ b := aRTMondrian ].
	isRebuild
		ifFalse:
			[ "Do not add more than a single time to prevent problems with too much zooming per step"
			"RWDiagram rememberRTView: e"
			b view @ RTZoomableView.
			self
				addMenuTo: aRWDiagramElementGroup
				withEditor: rwEditor
				withLayout: rwLayout
				withMondrian: b
				ofMooseModel: aMooseModel
				test: isTest ].
	rwLayout packageBoxSuppressed
		ifFalse: [ b shape rectangle
				withTextAbove: #dName;
				withTextColor: Color black;
				fillColor: Color transparent;
				borderColor: Color black ]
		ifTrue: [ b shape rectangle noBorder fillColor: Color transparent ].
	self addContextMenuClassesPackagesToMondrian: b ofLayout: rwLayout.
	rwLayout scope = rwLayout packageScope
		ifTrue: [ b nodes: allPackages ]
		ifFalse: [ b
				nodes: allPackages
				forEach: [ :pack | 
					"The following is problematic. dAllClasses should return correct RWDiagramElements, but pack famixElement ... asRWDiagramElement returns new RWDiagramElements that have no relation to the found connections."
					"allClassesForPackage := (pack famixElement classes collect: [ :each | each asRWDiagramElement: rwLayout ]) intersection: aRWDiagramElementGroup dAllClasses."
					allClassesForPackage := aRWDiagramElementGroup
						dAllClassesOfPackage: pack.
					rwLayout classBoxSuppressed
						ifFalse: [ b shape box noBorder
								withTextBelow: #dName;
								withTextColor: Color black;
								fillColor: rwLayout colorSchema classColor ]
						ifTrue: [ b shape box
								noBorder;
								fillColor: Color transparent ].
					self
						addContextMenuClassesPackagesToMondrian: b
						ofLayout: rwLayout.
					rwLayout scope = rwLayout methodScope
						ifTrue: [ displayedClasses := allClassesForPackage
								select: [ :each | 
									(each dModifiers includesAnyOf: #(#DBTable)) = false
										or: each dModifiers isEmpty ] ]
						ifFalse: [ displayedClasses := allClassesForPackage ].
					rwEditor settings isReading
						ifTrue: [ displayedClasses := displayedClasses
								reject: [ :c | rwLayout isModelElementNotShownWithChildren: c ] ].
					rwLayout scope = rwLayout classScope
						ifTrue: [ b nodes: displayedClasses forEach: [  ].
							b layout grid ]
						ifFalse: [ b
								nodes: displayedClasses
								forEach: [ :cls | 
									self
										attributesWithEditor: rwEditor
										class: cls
										layout: rwLayout
										mondrian: b.
									self
										methodsWithEditor: rwEditor
										class: cls
										layout: rwLayout
										mondrian: b ] ].
					" Draw comments for classes"
					self
						drawComments: b
						modelElements: displayedClasses
						editor: rwEditor
						entity: self aFAMIXClass
						ofLayout: rwLayout.



					"For the database tables"
					rwLayout scope = rwLayout methodScope
						ifTrue: [ b shape
								box;
								fillColor: Color transparent;
								borderColor: Color transparent.
							dataBaseTables := allClassesForPackage
								select: [ :each | each dModifiers includes: 'DBTable' ].
							rwEditor settings isReading
								ifTrue: [ dataBaseTables := dataBaseTables
										reject: [ :c | rwLayout isModelElementNotShownWithChildren: c ] ].
							b
								nodes: dataBaseTables
								forEach: [ :cls | 
									"This is duplicate coding:"
									displayedAttributes := cls dAttributes
										collect: [ :each | each asRWDiagramElement: rwLayout ].
									rwEditor settings isReading
										ifTrue: [ displayedAttributes := displayedAttributes
												reject: [ :c | rwLayout isModelElementNotShownWithChildren: c ] ].
									b shape box
										noBorder;
										fillColor: Color transparent.
									b
										node: cls
										forIt: [ b shape ellipse
												if: [ :m | rwLayout highlight: m ]
													fillColor: rwLayout colorSchema dataBaseAsAttributeHighLighteColor;
												if: [ :m | (rwLayout highlight: m) not ]
													fillColor: rwLayout colorSchema dataBaseAsAttributeColor;
												width: 20;
												height: 20;
												withText: #dName;
												fontSize: 6;
												withTextColor: Color black.
											self
												addContextMenuAttributesMethodsToMondrian: b
												ofLayout: rwLayout.
											b nodes: displayedAttributes.
											b layout grid.
											self
												drawComments: b
												modelElements: displayedAttributes
												editor: rwEditor
												entity: self aFAMIXAttribute
												ofLayout: rwLayout.
											b layout grid ].
									b layout verticalLine ].
							b layout grid ].
					b layout grid	"So that classes are arranged as grid" ] ].
	" Draw comments for packages"
	self
		drawComments: b
		modelElements: allPackages
		editor: rwEditor
		entity: self aFAMIXPackage
		ofLayout: rwLayout.
	b layout grid.
	aRWDiagramElementGroup setConnections.
	aRWDiagramElementGroup setAccesses.
	(rwLayout scope = rwLayout packageScope
		or: [ rwLayout scope = rwLayout classScope ])
		ifTrue: [ "Draw arrows for packages and classes"
			rwLayout lineStyle = rwLayout straightLineStyle
				ifTrue: [ b shape arrowedLine
						color: rwLayout colorSchema methodLineColor;
						withShorterDistanceAttachPoint.
					b shape head color: rwLayout colorSchema methodLineColor ].
			rwLayout lineStyle = rwLayout multiLineStyle
				ifTrue: [ b shape: RTStyledMultiLine new.
					b shape arrowHead
						color: rwLayout colorSchema methodLineColor;
						withShorterDistanceAttachPoint;
						orthoVertical.
					b shape head color: rwLayout colorSchema methodLineColor ].
			rwLayout lineStyle = rwLayout multiLineStyle2
				ifTrue: [ b shape: RTStyledMultiLine new.
					b shape arrowHead
						color: rwLayout colorSchema methodLineColor;
						withShorterDistanceAttachPoint;
						orthoHorizontal.
					b shape head color: rwLayout colorSchema methodLineColor ].
			rwLayout scope = rwLayout packageScope
				ifTrue: [ rwLayout displayDependencies
						ifTrue: [ b edges
								objects: aRWDiagramElementGroup dAllModelPackages;
								connectToAll: [ :m | m connectedTo ] ]
						ifFalse: [ b edges
								objects: aRWDiagramElementGroup dAllModelPackages;
								connectToAll: [ :m | m connectedFrom ] ] ]
				ifFalse: [ rwLayout displayDependencies
						ifTrue: [ b edges
								objects: aRWDiagramElementGroup dAllClasses;
								connectToAll: [ :m | m connectedTo ] ]
						ifFalse: [ b edges
								objects: aRWDiagramElementGroup dAllClasses;
								connectToAll: [ :m | m connectedFrom ] ] ].
			"Draw access line for packages and classes"
			rwLayout lineStyle = rwLayout straightLineStyle
				ifTrue: [ b shape line
						color: rwLayout colorSchema attributeLineColor;
						withShorterDistanceAttachPoint ].
			rwLayout lineStyle = rwLayout multiLineStyle
				ifTrue: [ b shape: RTStyledMultiLine new.
					b shape arrowHead
						color: rwLayout colorSchema attributeLineColor;
						withShorterDistanceAttachPoint;
						orthoVertical ].
			rwLayout lineStyle = rwLayout multiLineStyle2
				ifTrue: [ b shape: RTStyledMultiLine new.
					b shape arrowHead
						color: rwLayout colorSchema attributeLineColor;
						withShorterDistanceAttachPoint;
						orthoHorizontal ].
			rwLayout scope = rwLayout packageScope
				ifTrue: [ b edges
						objects: aRWDiagramElementGroup dAllModelPackages;
						connectToAll: [ :m | m accessedTo ] ]
				ifFalse: [ b edges
						objects: aRWDiagramElementGroup dAllClasses;
						connectToAll: [ :m | m accessedTo ] ] ].
	"Draw arrows and lines"
	allMethods := aRWDiagramElementGroup dAllMethods.
	rwEditor settings isReading
		ifTrue: [ allMethods := allMethods
				reject: [ :m | rwLayout isModelElementNotShownWithChildren: m ] ].
	allPackages
		do: [ :pack | 
			rwLayout lineStyle = rwLayout straightLineStyle
				ifTrue: [ b shape arrowedLine
						color: rwLayout colorSchema methodLineColor;
						withShorterDistanceAttachPoint.
					b shape head color: rwLayout colorSchema methodLineColor ].
			rwLayout lineStyle = rwLayout multiLineStyle
				ifTrue: [ b shape: RTStyledMultiLine new.
					b shape arrowHead
						color: rwLayout colorSchema methodLineColor;
						withShorterDistanceAttachPoint;
						orthoVertical.
					b shape head color: rwLayout colorSchema methodLineColor ].
			rwLayout lineStyle = rwLayout multiLineStyle2
				ifTrue: [ b shape: RTStyledMultiLine new.
					b shape arrowHead
						color: rwLayout colorSchema methodLineColor;
						withShorterDistanceAttachPoint;
						orthoHorizontal.
					b shape head color: rwLayout colorSchema methodLineColor ].
			rwLayout displayDependencies
				ifTrue: [ b edges
						objects: allMethods;
						connectToAll: [ :m | 
							(m famixElement queryAllOutgoingInvocations atScope: FAMIXMethod)
								collect: [ :m2 | m2 asRWDiagramElement: rwLayout ] ] ]
				ifFalse: [ b edges
						objects: allMethods;
						connectToAll: [ :m | 
							(m famixElement queryAllIncomingInvocations atScope: FAMIXMethod)
								collect: [ :m2 | m2 asRWDiagramElement: rwLayout ] ] ].	" "
			rwLayout lineStyle = rwLayout straightLineStyle
				ifTrue: [ b shape line
						color: rwLayout colorSchema attributeLineColor;
						withShorterDistanceAttachPoint ].
			rwLayout lineStyle = rwLayout multiLineStyle
				ifTrue: [ b shape: RTStyledMultiLine new.
					b shape
						color: rwLayout colorSchema attributeLineColor;
						withShorterDistanceAttachPoint;
						orthoVertical ].
			rwLayout lineStyle = rwLayout multiLineStyle2
				ifTrue: [ b shape: RTStyledMultiLine new.
					b shape
						color: rwLayout colorSchema attributeLineColor;
						withShorterDistanceAttachPoint;
						orthoHorizontal ].
			b edges
				elements: b view elements;
				"Use if allAccesses returns something: 
source: aFAMIXGroup allAccesses connectFrom: #from to: #variable."
					"Use if allAccesses is not working:"
					source:
					(RWDiagramElement new
						asRWDiagramElements: (pack famixElement classes flatCollect: [ :c | c incomingAccesses ]))
					connectFrom: #dFrom
					to: #dVariable ].	"Draw arrows"
	b build.
	self handleInvisibleElementsForMondrian: b layout: rwLayout.
	lb := RTLegendBuilder new.
	lb view: b view.
	rwEditor settings displayFormatter
		ifFalse: [ lb addText: 'Dependency graph' ]
		ifTrue: [ lb
				addText:
					'Dependency graph - Elements with permanent appearance changers are highlighted' ].
	lb addText: 'Layout: ' , rwLayout moose2ModelName.
	lb
		addColor: rwLayout colorSchema classColor
		text: 'Class (Grouping level 1)'.
	"lb addColor: rwLayout colorSchema dataBaseTableColor text: 'Database table'."
	lb
		addColor: rwLayout colorSchema methodColor
		text: 'Box: Active system component'.
	lb
		addColor: rwLayout colorSchema attributeColor
		text: 'Circle: Passive system component'.
	lb
		addColor: rwLayout colorSchema dataBaseAsAttributeColor
		text: 'Circle: DataBase Table'.
	lb
		addLineColor: rwLayout colorSchema attributeLineColor
		text: 'Access to "Data" resp. attribute'.
	rwLayout displayDependencies
		ifTrue: [ lb
				addLineColor: rwLayout colorSchema methodLineColor
				text: 'Arrow points to used component' ]
		ifFalse: [ lb
				addLineColor: rwLayout colorSchema methodLineColor
				text: 'Reverse arrow, points to using component' ].
	lb build.
	RWDiagramAnonymize anonymize: false.
	^ b! !

!RWDiagram methodsFor: 'MethodUsage-private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
methodsWithEditor: rwEditor class: clsRWDiagramElement layout: rwLayout mondrian: b
	<duplicate_meth_color>
	| displayedMethods |
	"Context menu attributes and methods"
	b shape rectangle
		if: [ :m | rwLayout highlight: m ]
			fillColor: rwLayout colorSchema methodHighLightedColor;
		if: [ :m | (rwLayout highlight: m) not ]
			fillColor: rwLayout colorSchema methodColor;
		width: 20;
		height: 20;
		withText: #dName;
		fontSize: 6;
		withTextColor: Color black.
	displayedMethods := clsRWDiagramElement dMethods
		collect: [ :each | each asRWDiagramElement: rwLayout ].
	rwEditor settings isReading
		ifTrue: [ displayedMethods := displayedMethods
				reject: [ :c | rwLayout isModelElementNotShownWithChildren: c ] ].
	self addContextMenuAttributesMethodsToMondrian: b ofLayout: rwLayout.
	b nodes: displayedMethods.
	b layout grid.
	self
		drawComments: b
		modelElements: displayedMethods
		editor: rwEditor
		entity: self aFAMIXMethod
		ofLayout: rwLayout.
	^ b layout grid! !

!RWDiagram methodsFor: 'naming' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self asString! !

!RWDiagram methodsFor: 'MethodUsage-calledFromMoose' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
popUpAllElementsDisplayed
	RWDiagram automaticTestIsRunning
		ifTrue: [ "Do not ask user during Unit Test" ^ true ]
		ifFalse: [ ^ UIManager default
				question: 'All elements are displayed, runtime can be long. Do you want to proceed?'
				title: 'Moose2Model' ]! !

!RWDiagram methodsFor: 'MethodUsage-calledFromMoose' stamp: 'RainerWinkler 9/1/2019 10:24'!
popUpSmalltalkNotSupported
	RWDiagram automaticTestIsRunning
		ifTrue: [ "Do not ask user during Unit Test" ^ true ]
		ifFalse: [ ^ UIManager default
				question:
					'Displaying Smalltalk Image is not supported in Pharo 7 or higher. Use Moose on Pharo 5 or 6. Do you want to proceed?'
				title: 'Moose2Model' ]! !

!RWDiagram methodsFor: 'MethodUsage-calledFromMoose' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readToRTView: b withEditor: rwEditor withLayout: aRWDiagramLayout
	" This is the main entry point to adapt the displayed elements"

	rwEditor settings isReading
		ifTrue: [ rwEditor readToRTView: b view layout: aRWDiagramLayout messages: true ]! !

!RWDiagram methodsFor: 'MethodUsage-calledFromMoose' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
redraw: aRWDiagramElementGroup view: e withEditor: rwEditor withLayout: aRWDiagramLayout mondrian: b ofMooseModel: aMooseModel test: isTest
	e clean.
	self
		methodUsage: aRWDiagramElementGroup
		withEditor: rwEditor
		withLayout: aRWDiagramLayout
		withMondrian: b
		ofMooseModel: aMooseModel 
		test: isTest.
	self readToRTView: b view withEditor: RWDiagramEditor uniqueInstance withLayout: aRWDiagramLayout.
	^ e signalUpdate! !

!RWDiagram methodsFor: 'MethodUsage-private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setLayoutCurrent: aRWDiagramLayout
	RWDiagramEditor uniqueInstance
		currentLayoutName: aRWDiagramLayout moose2ModelName! !

RWDiagram subclass: #RWDiagramAbstractAppearance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramAbstractAppearance commentStamp: 'RainerWinkler 8/8/2017 22:42' prior: 0!
Redefine me to define appearances.
!

!RWDiagramAbstractAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
appearenceIsSpecified
  self subclassResponsibility! !

!RWDiagramAbstractAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
highlight
  self subclassResponsibility! !

!RWDiagramAbstractAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
othersAreSuppressed
  self subclassResponsibility! !

RWDiagramAbstractAppearance subclass: #RWDiagramAppearance
	instanceVariableNames: 'changeTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramAppearance commentStamp: 'RainerWinkler 8/8/2017 22:42' prior: 0!
I know whether my appearance is changed. And how my elements should be drawn in the diagram.
!

!RWDiagramAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
appearenceIsSpecified

	^ true! !

!RWDiagramAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
change: aRWDiagramAppearanceChangeDeterminer
	changeTypes ifNil: [ changeTypes := OrderedCollection new ].
	changeTypes add: aRWDiagramAppearanceChangeDeterminer! !

!RWDiagramAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
highlight
	changeTypes
		do: [ :each | 
			each highlight
				ifTrue: [ ^ true ] ].
	^ false! !

!RWDiagramAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
minimalLayer
	| tempLayer |
	tempLayer := nil.
	changeTypes
		do: [ :each | 
			each suppressOthers
				ifTrue: [ tempLayer ifNil: [ tempLayer := each refersToLayer ] ifNotNil: [  ] ] ].
	^ tempLayer! !

!RWDiagramAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
othersAreSuppressed
	changeTypes
		do: [ :each | 
			each suppressOthers
				ifTrue: [ ^ true ] ].
	^ false! !

RWDiagramAbstractAppearance subclass: #RWDiagramUndeterminedAppearance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramUndeterminedAppearance commentStamp: 'RainerWinkler 8/8/2017 22:42' prior: 0!
My appearance is not defined.
!

!RWDiagramUndeterminedAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
appearenceIsSpecified
	^ false! !

!RWDiagramUndeterminedAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
highlight
	^false! !

!RWDiagramUndeterminedAppearance methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
othersAreSuppressed
	^false! !

RWDiagram subclass: #RWDiagramAbstractAttributeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramAbstractAttributeList commentStamp: 'RainerWinkler 8/8/2017 22:16' prior: 0!
I define common methods for all Attribute Lists. 
!

!RWDiagramAbstractAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributeIsSpecified
  self subclassResponsibility! !

RWDiagramAbstractAttributeList subclass: #RWDiagramAttributeList
	instanceVariableNames: 'suppresWithChildren elementPosition appearance appearanceChangerGroup comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramAttributeList commentStamp: 'RainerWinkler 8/19/2016 21:42' prior: 0!
A list with attributes of an element like position, color, filters ...

I have all attributes that are available for a layout. I get attributes that may be stored globally by inheritance.!

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
appearance
    appearance ifNil: [ appearance := RWDiagramUndeterminedAppearance new ].
	^ appearance! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
appearance: aRWDiagramAppearance 
	appearance := aRWDiagramAppearance! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
appearanceChangerGroup
	appearanceChangerGroup ifNil: [ appearanceChangerGroup := RWDiagramAppearanceChangerGroup new ].
	^appearanceChangerGroup! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributeIsSpecified
	^ true! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
comment
	comment ifNil: [ ^ RWDiagramNoComment new ].
	^ comment! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
comment: aRWDiagramComment 
	comment := aRWDiagramComment! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
position
  "Returns an instance of RWDiagramPosition"
  "If no position is determined, returns RWDiagramUndeterminedPosition"
	elementPosition ifNil: [ elementPosition := RWDiagramUndeterminedPosition new ].
	^ elementPosition! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
position: aPoint
	elementPosition := RWDiagramPosition new.
	elementPosition point: aPoint! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
removeAppearanceChangerGroup
	appearanceChangerGroup := nil! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressWithChildren
	^ suppresWithChildren ifNil: [ suppresWithChildren := false ]! !

!RWDiagramAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressWithChildren: aBoolean
	suppresWithChildren := aBoolean! !

RWDiagramAbstractAttributeList subclass: #RWDiagramGlobalAttributeList
	instanceVariableNames: 'globalComments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramGlobalAttributeList commentStamp: 'RainerWinkler 8/19/2016 21:40' prior: 0!
I have all attributes that are available globally.!

!RWDiagramGlobalAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
addComment: aRWDiagramGlobalComment
	self comments add: aRWDiagramGlobalComment! !

!RWDiagramGlobalAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributeIsSpecified
	^ true! !

!RWDiagramGlobalAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
comments
	globalComments ifNil: [ globalComments := OrderedCollection new ].
	^ globalComments! !

RWDiagramAbstractAttributeList subclass: #RWDiagramUndeterminedAttributeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramUndeterminedAttributeList commentStamp: 'RainerWinkler 8/8/2017 22:16' prior: 0!
I know what is, if no attributes are specified yet

!

!RWDiagramUndeterminedAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
appearance
	^ RWDiagramUndeterminedAppearance new! !

!RWDiagramUndeterminedAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
appearanceChangerGroup
	^ RWDiagramAppearanceChangerGroup new! !

!RWDiagramUndeterminedAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributeIsSpecified
	^ false! !

!RWDiagramUndeterminedAttributeList methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
comment
	^ RWDiagramNoComment new! !

!RWDiagramUndeterminedAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
comment: aComment
	| al |
	al := RWDiagramAttributeList new.
	al comment: aComment.
	^ al! !

!RWDiagramUndeterminedAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
position: aPoint 
		|al|
	al := RWDiagramAttributeList new.
	al position: aPoint. 
	^al! !

!RWDiagramUndeterminedAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressWithChildren
	^false! !

!RWDiagramUndeterminedAttributeList methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressWithChildren: aBoolean 
	|al|
	al := RWDiagramAttributeList new.
	al suppressWithChildren: aBoolean.
	^al! !

RWDiagram subclass: #RWDiagramAbstractComment
	instanceVariableNames: 'text uniqueKeyOfCommentedElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramAbstractComment commentStamp: 'RainerWinkler 8/8/2017 22:39' prior: 0!
I am the superclass for comments.
!

!RWDiagramAbstractComment class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
text: aString
	| co |
	co := super new.
	co text: aString.
	^ co! !

!RWDiagramAbstractComment methodsFor: 'public-toDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
exists
  self subclassResponsibility ! !

!RWDiagramAbstractComment methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
text
	"Returns text with CRLF for linebreaks"

	self subclassResponsibility ! !

!RWDiagramAbstractComment methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
text: aString
	"Accepts texts with CRLF, <br> and -Linebreak-"

	"Stores with <br>"

self subclassResponsibility ! !

!RWDiagramAbstractComment methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
textXML
  "Returns text with <br> for linebreaks"
	^ text ! !

!RWDiagramAbstractComment methodsFor: 'public-toDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
uniqueKey
"Tentatively because needed to draw edges in diagrams"
	^ uniqueKeyOfCommentedElement! !

!RWDiagramAbstractComment methodsFor: 'public-toDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
uniqueKeyOfCommentedElement
	^ uniqueKeyOfCommentedElement! !

!RWDiagramAbstractComment methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
uniqueKeyOfCommentedElement: aString 
	uniqueKeyOfCommentedElement := aString! !

RWDiagramAbstractComment subclass: #RWDiagramNoComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramNoComment commentStamp: 'RainerWinkler 6/23/2017 17:42' prior: 0!
Dummy Comment!

!RWDiagramNoComment methodsFor: 'public-toDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
exists
	^ false! !

!RWDiagramNoComment methodsFor: 'public-toDiagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
text
	^ ''! !

RWDiagramAbstractComment subclass: #RWDiagramPositionableComment
	instanceVariableNames: 'position positionSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramPositionableComment commentStamp: 'RainerWinkler 8/19/2016 18:21' prior: 0!
I am the superclass for all comments that can have a position. It depends on the context what is the meaning of a position.!

RWDiagramPositionableComment subclass: #RWDiagramGlobalComment
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramGlobalComment commentStamp: 'RainerWinkler 8/8/2017 22:40' prior: 0!
I am a global comment. I am stored globally for elements.
I have a unique ID, so that my positions can be remembered for a certain layout.
I am still under development.!

!RWDiagramGlobalComment class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
id: aString
"Generate instances of global comment when the comment is read. In that case the id is read also."
	| co |
	co := super new.
	co id: aString.
	^ co! !

!RWDiagramGlobalComment methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
exists
   self halt.
	^ true! !

!RWDiagramGlobalComment methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
id
	^id! !

!RWDiagramGlobalComment methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
id: aString 
	id := aString! !

!RWDiagramGlobalComment methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
  id := DateAndTime now asString, 999999 atRandom asString! !

RWDiagramPositionableComment subclass: #RWDiagramLocalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramLocalComment commentStamp: 'RainerWinkler 8/17/2016 21:19' prior: 0!
I am a local comment. I am stored together with a certain layout.!

!RWDiagramLocalComment methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
exists
	^ true! !

!RWDiagramPositionableComment methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
   positionSet := false! !

!RWDiagramPositionableComment methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
position
	^position! !

!RWDiagramPositionableComment methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
position: aPoint 
   positionSet := true.
	position := aPoint! !

!RWDiagramPositionableComment methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
positionSet
	^ positionSet! !

!RWDiagramPositionableComment methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
text
	"Returns text with CRLF for linebreaks"

	RWDiagramAnonymize anonymize
		ifTrue: [ ^ ( RWDiagramAnonymize getAnonymName: text withPrefix: 'Comment' ) copyReplaceAll: '<br>' with: String crlf ].
	^ text copyReplaceAll: '<br>' with: String crlf! !

!RWDiagramPositionableComment methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
text: aString
	"Accepts texts with CRLF, <br> and -Linebreak-"

	"Stores with <br>"

	| string |
	string := aString copyReplaceAll: '-Linebreak-' with: '<br>'.
	string := string copyReplaceAll: String crlf with: '<br>'.
	text := string! !

RWDiagram subclass: #RWDiagramAbstractFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramAbstractFile commentStamp: 'RainerWinkler 8/22/2016 22:02' prior: 0!
I have common methods to write and read XML files!

!RWDiagramAbstractFile methodsFor: 'writing' stamp: ''!
writeElement: aRWDiagramElement toXML: writer
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	writer tag: #type with: aRWDiagramElement famixElement class asString.
	aRWDiagramElement famixElement class asString = self aFAMIXPackage
		ifTrue: [ writer tag: #package with: aRWDiagramElement famixElement moose2ModelName asString ].
	aRWDiagramElement famixElement class asString = self aFAMIXClass
		ifTrue: [ writer tag: #class with: aRWDiagramElement famixElement moose2ModelName asString ].
	aRWDiagramElement famixElement class asString = self aFAMIXMethod
		ifTrue: [ writer
				tag: #class with: aRWDiagramElement famixElement parentType moose2ModelName asString;
				tag: #method with: aRWDiagramElement famixElement moose2ModelName asString.
				aRWDiagramElement famixElement hasClassScope ifTrue:[writer tag: #hasClassScope with: 'true'] ].
	aRWDiagramElement famixElement class asString = self aFAMIXAttribute
		ifTrue: [ writer
				tag: #class with: aRWDiagramElement famixElement parentType moose2ModelName asString;
				tag: #attribute with: aRWDiagramElement famixElement moose2ModelName asString.
				aRWDiagramElement famixElement hasClassScope ifTrue:[writer tag: #hasClassScope ]  ]! !

RWDiagramAbstractFile subclass: #RWDiagramGlobalFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramGlobalFile commentStamp: 'RainerWinkler 8/22/2016 22:05' prior: 0!
I know how to write and read global data to a file!

!RWDiagramGlobalFile methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
writeGlobalAttributeList: aAttrList toWriter: aWriter
	||
   self haltOnce.
	aAttrList attributeIsSpecified
		ifTrue: [  ]! !

RWDiagramAbstractFile subclass: #RWDiagramLayoutFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramLayoutFile commentStamp: 'RainerWinkler 8/22/2016 22:05' prior: 0!
I know how to write and read Layout specific data to a file!

!RWDiagramLayoutFile methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
writeAttributeList: aAttrList toWriter: aWriter
	| changeType changeDeterminer |
	aAttrList attributeIsSpecified
		ifTrue: [ aAttrList position positionIsDetermined
				ifTrue: [ aWriter
						tag: #x with: (aAttrList position point x asFloat round: 8) asString;
						tag: #y with: (aAttrList position point y asFloat round: 8) asString ].
			aAttrList suppressWithChildren
				ifTrue: [ aWriter tag: #supressWithChildren with: #true ].
			aAttrList comment exists
				ifTrue: [ aWriter tag: #comment with: [ aWriter cdata: aAttrList comment textXML ].
					aAttrList comment positionSet
						ifTrue: [ aWriter
								tag: #commentx with: (aAttrList comment position x asFloat round: 8) asString;
								tag: #commenty with: (aAttrList comment position y asFloat round: 8) asString ] ].
			aAttrList appearanceChangerGroup appearanceChangers
				do: [ :ac | 
					ac changeType isTemporary
						ifFalse: [ ac changeType class asString = 'RWDiagramACTSuppressOthers'
								ifTrue: [ changeType := #ACTSuppressOthers ].
							ac changeDeterminer class asString = 'RWDiagramACDStandard'
								ifTrue: [ changeDeterminer := #ACDStandard ].
							aWriter
								tag: changeType
								with: [ aWriter tag: #type with: changeDeterminer.
									changeDeterminer = #ACDStandard
										ifTrue: [ aWriter tag: #includeMe with: ac changeDeterminer includeMe asString;
											               tag: #usedByLayers with: ac changeDeterminer usedByLayers asString;
											               tag: #usingLayers with: ac changeDeterminer usingLayers asString  ] ] ] ] ]! !

RWDiagram subclass: #RWDiagramAbstractLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramAbstractLayout commentStamp: 'RainerWinkler 8/8/2017 22:40' prior: 0!
I define common methods for layouts. A Layout specifies how a specific diagram looks alike.
!

!RWDiagramAbstractLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isDefined
	self subclassResponsibility! !

RWDiagramAbstractLayout subclass: #RWDiagramLayout
	instanceVariableNames: 'elementGroup commentColor colorSchema processedRTView suppressOthersActive replaceMooseEntities readFileVersion scope lineStyle snapToGrid mooseID classBoxSuppressed packageBoxSuppressed displayDependencies moose2ModelName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramLayout commentStamp: 'RainerWinkler 8/8/2017 22:40' prior: 0!
Contains a informations on a specific layout.

elementGroup is an object of RWDiagramElementGroup and contains all informations that are specific for a certain layout.
!

!RWDiagramLayout class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
replaceMooseEntitiesUndefined
	^#undefined! !

!RWDiagramLayout methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
<= aRWDiagramLayout
"Needed to return a sorted lists of Layouts"
  ^self moose2ModelName asLowercase <= aRWDiagramLayout moose2ModelName asLowercase "Do not sort respecting lower and upper case"! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: ''!
actualizeTemporaryAppearacenceInView: aRTView
<duplicate_attr_color>
<duplicate_meth_color>
<duplicate_database_attr_color>
	aRTView elements
		do: [ :each | each model class = RWDiagramElement ifTrue:[
			each model famixElement class asString = self aFAMIXMethod
				ifTrue: [ (self highlight: each model)
						ifTrue: [ each color: self colorSchema methodHighLightedColor ]
						ifFalse: [ each color: self colorSchema methodColor ] ].
			each model famixElement class asString = self aFAMIXAttribute
				ifTrue: [ (each model famixElement parentType modifiers includes: 'DBTable')
						ifTrue: [ (self highlight: each model)
								ifTrue: [ each color: self colorSchema dataBaseAsAttributeHighLighteColor ]
								ifFalse: [ each color: self colorSchema dataBaseAsAttributeColor ] ]
						ifFalse: [ (self highlight: each model)
								ifTrue: [ each color: self colorSchema attributeHighLightedColor ]
								ifFalse: [ each color: self colorSchema attributeColor ] ] ] ] ]! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
addAppearanceChangeType: aRWDiagramAppearanceChangeType to: aRWDiagramElement
	self
		remember: [ :attributeList | 
			| a2 |
			attributeList attributeIsSpecified
				ifFalse: [ a2 := RWDiagramAttributeList new ]
				ifTrue: [ a2 := attributeList ].
			a2 appearance appearenceIsSpecified
				ifFalse: [ a2 appearance: RWDiagramAppearance new ].
			a2 appearance change: aRWDiagramAppearanceChangeType.
			a2 ]
		ofModel: aRWDiagramElement! !

!RWDiagramLayout methodsFor: 'appearance' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
addAppearanceChanger: aRWDiagramAppearanceChanger to: aModelElement
	self
		remember: [ :attributeList | 
			| a2 |
			attributeList attributeIsSpecified
				ifFalse: [ a2 := RWDiagramAttributeList new ]
				ifTrue: [ a2 := attributeList ].
			a2 appearanceChangerGroup addAppearentChanger: aRWDiagramAppearanceChanger.
			a2 ]
		ofModel: aModelElement! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
classBoxSuppressed
	classBoxSuppressed ifNil: [ classBoxSuppressed := false ].
	^classBoxSuppressed! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
classBoxSuppressed: aBoolean
	classBoxSuppressed := aBoolean! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
classNotToBeShown: aRWDiagramElementOrMooseEntity
	| aMooseEntity |
	aRWDiagramElementOrMooseEntity class = RWDiagramElement
		ifTrue: [ aMooseEntity := aRWDiagramElementOrMooseEntity famixElement ]
		ifFalse: [ aMooseEntity := aRWDiagramElementOrMooseEntity ].
	aMooseEntity methods
		do: [ :m | 
			(self othersAreSuppressed: m)
				ifTrue: [ ^ false ] ].
	aMooseEntity attributes
		do: [ :m | 
			(self othersAreSuppressed: m)
				ifTrue: [ ^ false ] ].
	^ true! !

!RWDiagramLayout methodsFor: 'scope' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
classScope
	^#classScope! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
cleanCDATA: aString
	"This solves a not yet analyzed problem after reading a CDATA from XML"

	| string |
	string := aString.

	[ ( string last = Character space or: string last = Character lf) and: string size > 2 ] whileTrue: [ string := string allButLast ].

	^ string! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
color: aColor FAMIXComponent: aRWDiagramElementOrMooseEntity view: aRTView
	| aRWDiagramElement |
	aRWDiagramElementOrMooseEntity class = RWDiagramElement
		ifTrue: [ aRWDiagramElement := aRWDiagramElementOrMooseEntity  ]
		ifFalse: [ aRWDiagramElement := RWDiagramElement famixElement: aRWDiagramElementOrMooseEntity ].
	aRTView elements
		do: [ :each | 
			aRWDiagramElement = each model
				ifTrue: [ each color: aColor ] ]! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
colorSchema
^ colorSchema! !

!RWDiagramLayout methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
comment: aString to: aRWDiagramElement
<RWDiaEdit_47>
	| string |
	string := aString
		copyReplaceAll: '<br>'
		with: Character cr asString , Character lf asString.
	self
		remember: [ :attributeList | attributeList comment: (RWDiagramLocalComment text: string )]
		ofModel: aRWDiagramElement! !

!RWDiagramLayout methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
commentColor
	commentColor ifNil:[commentColor := self defaultCommentColor]. ^commentColor! !

!RWDiagramLayout methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
commentColor: aColor 
	commentColor := aColor! !

!RWDiagramLayout methodsFor: 'commenting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
defaultCommentColor
	^Color transparent! !

!RWDiagramLayout methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
displayDependencies
	displayDependencies ifNil:[displayDependencies := true].
	^displayDependencies! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
displayDependencies: aBoolean
	displayDependencies := aBoolean! !

!RWDiagramLayout methodsFor: 'private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
elementGroup
	^ elementGroup! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
elementListLength
	^80! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
evaluateAppearance
	"Sets the appearance for all elements
Determines whether at least a single element has suppress others active"

	suppressOthersActive := false.
	elementGroup elementList
		do: [ :each | 
			each famixElement
				ifNotNil: [ each attributeList attributeIsSpecified
						ifTrue: [ each attributeList appearanceChangerGroup appearanceChangers
								do: [ :ac | 
									ac changeType suppressOthers
										ifTrue: [ suppressOthersActive := true ].
									ac changeDeterminer element: each.
									ac changeDeterminer collectedElements do: [ :ce | self addAppearanceChangeType: (ac changeTypeAdjustedFor: ce) to: ce ] ] ] ] ]! !

!RWDiagramLayout methodsFor: 'sourceAnchor' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
getLinkTo: aRWDiagramElement
	| string |
	(self hasFileInfos: aRWDiagramElement)
		ifTrue: [ string := aRWDiagramElement famixElement sourceAnchor fileName.
			Clipboard new clipboardText: string.
			self inform: string , ' copied to Clipboard' ]
		ifFalse: [ self inform: 'No Source information attached' ]! !

!RWDiagramLayout methodsFor: 'sourceAnchor' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
hasFileInfos: aRWDiagramElement
	^ aRWDiagramElement famixElement sourceAnchor class moose2ModelName
		= 'FAMIXFileAnchor'! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
highlight: aFAMIXElement
	| attributeList |
	self replaceMooseEntities: false.
	attributeList := self readAttributesFromFAMIXElement: aFAMIXElement.
	RWDiagramEditor uniqueInstance settings displayFormatter
		ifFalse: [ self replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined.
			^ attributeList appearance highlight ]
		ifTrue: [ "Highlight elements without permanent appearance changers"
			(attributeList appearanceChangerGroup appearanceChangers select: [ :each | each changeType isTemporary not ]) isEmpty
				ifTrue: [ ^ false ]
				ifFalse: [ ^ true ] ]! !

!RWDiagramLayout methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
super initialize.
	elementGroup ifNil: { elementGroup := RWDiagramElementGroup new }.
	replaceMooseEntities := RWDiagramLayout replaceMooseEntitiesUndefined.
	colorSchema := RWDiagramDefaultColorSchema new! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isDefined
	^ true! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: ''!
isModelElementNotShownWithChildren: aRWDiagramElement
	"Will contain all suppressing logic if developed
	Is called from diagrams"

	<RWDiaEdit_28>
	<RWDiaEdit_29>
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	(self isModelElementsuppressedWithChildren: aRWDiagramElement)
		ifTrue: [ ^ true ].
	self suppressOthersActive
		ifTrue: [ aRWDiagramElement famixElement class asString = self aFAMIXPackage
				ifTrue: [|classesOfPackage| classesOfPackage := aRWDiagramElement famixElement classes.
					   classesOfPackage size = 0 ifTrue:[^ false "Workaround for issue #31. In case of Java no classes are stored yet in the packages. So do not suppress packages"].
						classesOfPackage do: [ :cl | 
							(self classNotToBeShown: cl)
								ifFalse: [ ^ false ] ].
					^ true ].
			aRWDiagramElement famixElement class asString = self aFAMIXClass
				ifTrue: [ ^ self classNotToBeShown: aRWDiagramElement ].
			aRWDiagramElement famixElement class asString = self aFAMIXMethod
				ifTrue: [ ^ (self othersAreSuppressed: aRWDiagramElement) not ].
			aRWDiagramElement famixElement class asString = self aFAMIXAttribute
				ifTrue: [ ^ (self othersAreSuppressed: aRWDiagramElement) not ].
			^ false ]
		ifFalse: [ ^ false ]! !

!RWDiagramLayout methodsFor: 'elementGroupAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isModelElementsuppressedWithChildren: aRWDiagramElement
	| attributeList |
	self replaceMooseEntities: false.
	attributeList := self readAttributesFromFAMIXElement: aRWDiagramElement.
   self replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined.
   ^ attributeList suppressWithChildren ! !

!RWDiagramLayout methodsFor: 'linestyle' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lineStyle
   lineStyle ifNil: [ lineStyle := self straightLineStyle ].
	^ lineStyle! !

!RWDiagramLayout methodsFor: 'linestyle' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lineStyle: aLineStyle 
	lineStyle := aLineStyle! !

!RWDiagramLayout methodsFor: 'list' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
listWithComments: withComment
	"Write informations about the current diagram view to Transcript"

	<RWDiaEdit_56>
	<RWDiaEdit_57>
	<RWDiaEdit_58>
	| stream return streamElement streamInfos |
	stream := WriteStream on: String new.
	return := String crlf.
	stream
		nextPutAll: '--------------------------------------------------------------------';
		nextPutAll: return;
		nextPutAll: 'Diagram Layout View: ';
		nextPutAll: self moose2ModelName;
		nextPutAll: return;
		nextPutAll: return.
	elementGroup elementList asSortedCollection
		do: [ :each | 
			each attributeList attributeIsSpecified
				ifTrue: [ streamInfos := WriteStream on: String new.
					each attributeList suppressWithChildren
						ifTrue: [ streamInfos nextPutAll: ' Suppress with children ' ].
					each attributeList appearanceChangerGroup appearanceChangers
						do: [ :ac | 
							streamInfos nextPut: Character space.
							ac changeType class asString = 'RWDiagramACTSuppressOthers'
								ifTrue: [ ac changeDeterminer includeMe
										ifTrue: [ streamInfos nextPutAll: 'Display ' ]
										ifFalse: [ streamInfos nextPutAll: 'Neighbours displayed ' ].
									streamInfos nextPutAll: 'used ' , ac changeDeterminer usedByLayers asString , ' using ' , ac changeDeterminer usingLayers asString , ' ' ]
								ifFalse: [ ac changeType printOn: streamInfos.
									streamInfos nextPut: Character space.
									ac changeDeterminer printOn: streamInfos ] ].
					withComment
						ifTrue: [ each attributeList comment exists
								ifTrue: [ streamInfos nextPutAll: 'Comment:'.
									streamInfos nextPutAll: return.
									streamInfos nextPutAll: each attributeList comment text ] ].
					"Print element only if at least something is to be printed for it"
					streamInfos size = 0
						ifFalse: [ streamElement := WriteStream on: String new.
							streamElement nextPutAll: '- '.
							each famixElement printOn: streamElement.
							"Position infos below each other for better readability"
							streamElement size < self elementListLength
								ifTrue: [ | l |
									l := self elementListLength - streamElement size.
									l timesRepeat: [ streamElement nextPut: Character space ] ].
							each famixElement
								ifNil: [ stream
										nextPutAll: '- Element in xml but not in Model:';
										nextPutAll: each uniqueKey ]
								ifNotNil: [ stream nextPutAll: streamElement contents ].
							stream
								nextPutAll: streamInfos contents;
								nextPutAll: return ] ] ].
	stream size = 0
		ifTrue: [ Transcript
				cr;
				show: 'Nothing to display' ]
		ifFalse: [ Transcript
				cr;
				show: stream contents ]! !

!RWDiagramLayout methodsFor: 'scope' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
methodScope
	^#methodScope! !

!RWDiagramLayout methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
   moose2ModelName ifNil: [ "Only required when code changes. In that moose2Model will initiall by empty, so fill it with the current name" moose2ModelName := name ].
	RWDiagramAnonymize anonymize
		ifTrue: [ ^ RWDiagramAnonymize getAnonymName: moose2ModelName withPrefix: 'Layout' ].
	^moose2ModelName ! !

!RWDiagramLayout methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName: aString
	moose2ModelName := aString! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
mooseID
	^mooseID! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
mooseID: anInteger 
	mooseID := anInteger! !

!RWDiagramLayout methodsFor: 'linestyle' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
multiLineStyle
	^#multiLineStyle! !

!RWDiagramLayout methodsFor: 'linestyle' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
multiLineStyle2
	^#multiLineStyle2! !

!RWDiagramLayout methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
name: aString 
   
   self moose2ModelName: aString! !

!RWDiagramLayout methodsFor: 'sourceAnchor' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
openLinkTo: aRWDiagramElement
	| string |
	(self hasFileInfos: aRWDiagramElement)
		ifTrue: [ OSProcess isWindows
				ifTrue: [ string := aRWDiagramElement famixElement sourceAnchor fileName.
					OSProcess command: 'cmd /C start ' , string.
					self inform: 'URL ' , string , ' is opened. In case of SAP ADT links have to be activated.' ]
				ifFalse: [ self inform: 'Sorry, links are currently supported on Windows only. Please open an issue on www.Moose2Model.org.' ] ]
		ifFalse: [ self inform: 'No Source information attached' ]! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
othersAreSuppressed: aFAMIXElement
	| attributeList |
	self replaceMooseEntities: false.
	attributeList := self readAttributesFromFAMIXElement: aFAMIXElement.
   self replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined.
	^ attributeList appearance othersAreSuppressed! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
packageBoxSuppressed
	packageBoxSuppressed ifNil:[packageBoxSuppressed := false].
	^packageBoxSuppressed! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
packageBoxSuppressed: aBoolean
	packageBoxSuppressed := aBoolean! !

!RWDiagramLayout methodsFor: 'scope' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
packageScope
	^#packageScope! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
processedRTView
	^ processedRTView! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
processedRTView: aRTView 
	processedRTView := aRTView! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: 'RainerWinkler 8/31/2019 16:50'!
readAttributesFromFAMIXElement: aRWDiagramElementOrMooseEntity
	"From real view"

	"This is a private methods. If called for tests set
	layout replaceMooseEntities: true or false"

	| aRWDiagramElement |
	aRWDiagramElementOrMooseEntity class = RWDiagramElement
		ifTrue: [ aRWDiagramElement := aRWDiagramElementOrMooseEntity ]
		ifFalse: [ (aRWDiagramElementOrMooseEntity class inheritsFrom: MooseEntity)
				ifTrue: [ aRWDiagramElement := RWDiagramElement famixElement: aRWDiagramElementOrMooseEntity ] ].
	aRWDiagramElement class = RWDiagramElement
		ifTrue: [ ^ (elementGroup apply: [ :e | e ] toAttribute: aRWDiagramElement replace: self replaceMooseEntities) attributeList	"Check" ]
		ifFalse: [ ^ RWDiagramUndeterminedAttributeList new ]! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readFileVersion
	readFileVersion ifNil: [ ^'' ] ifNotNil: [ ^readFileVersion ]! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readFileVersion: aString 
	readFileVersion := aString! !

!RWDiagramLayout methodsFor: 'readFile' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readFromStream: aReadStream message: aBoolean
	self replaceMooseEntities: false.
	[ self readFromStreamXML: aReadStream ]
		on: XMLWellFormednessException
		do: [ aBoolean
				ifTrue: [ UIManager default
						alert:
							'XML not well formed. It may be corrupt. I may be in old format. See on project page on what to do in that case.' ] ].
	self replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayout methodsFor: 'readFile' stamp: 'RainerWinkler 8/31/2019 14:55'!
readFromStreamXML: aReadStream
	| famixType comp1 comp2 compClassScope anElementGroup parsed elements x y point supressWithChildren comment commentx commenty commentPoint actsos aAC versions scopeXML suppressedXML |
	aReadStream reset.
	anElementGroup := elementGroup.
	parsed := (XMLDOMParser on: aReadStream)
		removeLimits;
		optimizeForLargeDocuments;
		preservesCDataNodes: true;
		parseDocument.
	versions := parsed allElementsNamed: #version.
	"This appears not to work, why? There is no version extracted."
	versions do: [ :version | readFileVersion := version contentString ].
	scopeXML := parsed allElementsNamed: #scope.
	scopeXML
		do: [ :s | 
			| readScope |
			readScope := s contentString.
			readScope = 'package'
				ifTrue: [ self scope: self packageScope ]
				ifFalse: [ readScope = 'class'
						ifTrue: [ self scope: self classScope ]
						ifFalse: [ readScope = 'method'
								ifTrue: [ self scope: self methodScope ]
								ifFalse: [  ] ] ] ].
	suppressedXML := parsed allElementsNamed: #suppressed.
	suppressedXML
		do: [ :s | 
			| readScope |
			readScope := s contentString.
			readScope = 'packageBox'
				ifTrue: [ self packageBoxSuppressed: true ]
				ifFalse: [ self packageBoxSuppressed: false ] ].
	elements := parsed allElementsNamed: #element.
	elements
		do: [ :element | 
			famixType := element contentStringAt: #type.
			famixType = self aFAMIXPackage
				ifTrue: [ comp1 := element contentStringAt: #package.
					comp2 := ''.
					compClassScope := false ].
			famixType = self aFAMIXClass
				ifTrue: [ comp1 := element contentStringAt: #class.
					comp2 := ''.
					compClassScope := false ].
			famixType = self aFAMIXAttribute
				ifTrue: [ comp1 := element contentStringAt: #class.
					comp2 := element contentStringAt: #attribute.
					(element contentStringAt: #hasClassScope) = #true
						ifTrue: [ compClassScope := true ]
						ifFalse: [ compClassScope := false ] ].
			famixType = self aFAMIXMethod
				ifTrue: [ comp1 := element contentStringAt: #class.
					comp2 := element contentStringAt: #method.
					(element contentStringAt: #hasClassScope) = #true
						ifTrue: [ compClassScope := true ]
						ifFalse: [ compClassScope := false ] ].
			"Position"
			x := element contentStringAt: #x.
			x = ''
				ifFalse: [ y := element contentStringAt: #y.
					point := x asNumber @ y asNumber.
					self
						remember: [ :attributeList | 
							| a2 |
							a2 := attributeList position: point.
							a2 ]
						FAMIXType: famixType
						comp1: comp1
						comp2: comp2
						compClassScope: compClassScope
						to: anElementGroup ].
			"Suppress with children"
			supressWithChildren := element contentStringAt: #supressWithChildren.
			supressWithChildren = ''
				ifFalse: [ self
						remember: [ :attributeList | 
							| a2 |
							a2 := attributeList suppressWithChildren: supressWithChildren = 'true'.
							a2 ]
						FAMIXType: famixType
						comp1: comp1
						comp2: comp2
						compClassScope: compClassScope
						to: anElementGroup ].
			comment := element contentStringAt: #comment.
			comment = ''
				ifFalse: [ self
						remember: [ :attributeList | 
							| a2 text |
							text := self cleanCDATA: comment.
							a2 := attributeList.
							a2 attributeIsSpecified
								ifFalse: [ a2 := RWDiagramAttributeList new ].
							a2 comment exists
								ifFalse: [ a2 := a2 comment: (RWDiagramLocalComment text: text) ]
								ifTrue: [ a2 comment text: text ].
							a2 ]
						FAMIXType: famixType
						comp1: comp1
						comp2: comp2
						compClassScope: compClassScope
						to: anElementGroup.
					commentx := element contentStringAt: #commentx.
					commentx = ''
						ifFalse: [ commenty := element contentStringAt: #commenty.
							commentPoint := commentx asNumber @ commenty asNumber.
							self
								remember: [ :attributeList | 
									| at |
									at := attributeList.
									at attributeIsSpecified
										ifFalse: [ at := RWDiagramAttributeList new ].
									at comment exists
										ifFalse: [ at comment: RWDiagramLocalComment new ].
									at comment position: commentPoint.
									at ]
								FAMIXType: famixType
								comp1: comp1
								comp2: comp2
								compClassScope: compClassScope
								to: anElementGroup ] ].
			actsos := element allElementsNamed: #ACTSuppressOthers.
			actsos
				do: [ :actso | 
					aAC := RWDiagramAppearanceChanger
						changeDeterminer:
							(RWDiagramACDStandard new
								includeMe: (actso contentStringAt: #includeMe) = 'true'
									usedByLayers: (actso contentStringAt: #usedByLayers) asInteger
									usingLayers: (actso contentStringAt: #usingLayers) asInteger;
								yourself)
						changeType: RWDiagramACTSuppressOthers new.
					self
						remember: [ :attributeList | 
							| a2 |
							attributeList attributeIsSpecified
								ifFalse: [ a2 := RWDiagramAttributeList new ]
								ifTrue: [ a2 := attributeList ].
							a2 appearanceChangerGroup addAppearentChanger: aAC.
							a2 ]
						FAMIXType: famixType
						comp1: comp1
						comp2: comp2
						compClassScope: compClassScope
						to: anElementGroup ] ].
	self replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayout methodsFor: 'refreshing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refresh
   "Replaces all FAMIXElements with nil, to make sure that all used FAMIXElements are correctly read from actual data"
	elementGroup elementList do: [ :el | el refresh ]! !

!RWDiagramLayout methodsFor: 'elementGroupAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
remember: aBlock FAMIXType: aFAMIXTypeString comp1: aComp1 comp2: aComp2 compClassScope: aCompClassScope to: aRWDiagramLayout
	| newFAMIXElement newFAMIXParentElement newRWDiagramElement |
	aFAMIXTypeString = self aFAMIXClass
		ifTrue: [ newFAMIXElement := FAMIXClass new.
			newFAMIXElement name: aComp1 ].
	aFAMIXTypeString = self aFAMIXPackage
		ifTrue: [ newFAMIXElement := FAMIXPackage new.
			newFAMIXElement name: aComp1 ].
	aFAMIXTypeString = self aFAMIXMethod
		ifTrue: [ newFAMIXElement := FAMIXMethod new.
			newFAMIXElement name: aComp2.
			newFAMIXElement signature: newFAMIXElement moose2ModelName.
			newFAMIXElement hasClassScope: aCompClassScope.
			newFAMIXParentElement := FAMIXClass new.
			newFAMIXParentElement name: aComp1.
			newFAMIXElement parentType: newFAMIXParentElement ].
	aFAMIXTypeString = self aFAMIXAttribute
		ifTrue: [ newFAMIXElement := FAMIXAttribute new.
			newFAMIXElement name: aComp2.
			newFAMIXElement hasClassScope: aCompClassScope.
			newFAMIXParentElement := FAMIXClass new.
			newFAMIXParentElement name: aComp1.
			newFAMIXElement parentType: newFAMIXParentElement ].
	newFAMIXElement
		ifNotNil: [ newRWDiagramElement := RWDiagramElement famixElement: newFAMIXElement.
			elementGroup apply: aBlock toAttribute: newRWDiagramElement replace: self replaceMooseEntities "Check"  ]! !

!RWDiagramLayout methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
remember: aBlock fromRTElement: aRTElement
"aBlock has to return the attribute list. In many cases a method on a undefinde attribute list returns a defined attribute list."
	| currentModel |
	aRTElement
		ifNotNil: [ aRTElement model
				ifNotNil: [ 
					aRTElement
						ifNotNil: [ currentModel := aRTElement model.
							currentModel ifNotNil: [ 
								((currentModel class inheritsFrom: MooseEntity) or: currentModel class = RWDiagramElement ) ifTrue:[
								self remember: aBlock ofModel: (currentModel asRWDiagramElement: self)] ] ] ] ]! !

!RWDiagramLayout methodsFor: 'elementGroupAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
remember: aBlock ofModel: currentRWDiagramElement
   self replaceMooseEntities: true.
	currentRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
		"Element from View"
	elementGroup apply: aBlock toAttribute: currentRWDiagramElement replace: self replaceMooseEntities. "Check"
		self replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayout methodsFor: 'appearance' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
removeAppearanceChangersFrom: aModelElement
	"Remove all appearance changers"
	
	    | aRWDiagramElement |
(aModelElement class inheritsFrom: MooseEntity) ifTrue:[aRWDiagramElement := aModelElement asRWDiagramElement: self]ifFalse:[aRWDiagramElement := aModelElement].

	self
		remember: [ :attributeList | 
			| a2 |
			attributeList attributeIsSpecified
				ifFalse: [ a2 := RWDiagramAttributeList new ]
				ifTrue: [ a2 := attributeList ].
			a2 removeAppearanceChangerGroup.
			a2 ]
		ofModel: aRWDiagramElement! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
removeTemporary
	elementGroup elementList
		do: [ :each | 
			each attributeList attributeIsSpecified
				ifTrue:
					[ each attributeList appearanceChangerGroup removeTemporary ] ]! !

!RWDiagramLayout methodsFor: 'public-diagram' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
replaceElementsFromFAMIXGroup: aRWDiagramElementGroup
	"Replaces and sets the elements of RWDiagramElementGroup with the most actual FAMIX Elements. This is required to evaluate invocations and accesses correctly"
self replaceMooseEntities: true.
	aRWDiagramElementGroup dAllModelPackages do: [ :pack | elementGroup apply: [ :e | e ] toAttribute: pack replace: self replaceMooseEntities "Check" ].
	aRWDiagramElementGroup dAllClasses
		do: [ :cl | 
			elementGroup apply: [ :e | e ] toAttribute: cl replace: true "Check".
			cl famixElement attributes do: [ :attr | elementGroup apply: [ :e | e ] toAttribute: (attr asRWDiagramElement: self) replace: self replaceMooseEntities "Check" ].
			cl famixElement methods do: [ :meth | elementGroup apply: [ :e | e ] toAttribute: (meth asRWDiagramElement: self) replace: self replaceMooseEntities "Check"  ] ].
		self replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

!RWDiagramLayout methodsFor: 'replaceMooseEntities' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
replaceMooseEntities
	^replaceMooseEntities ! !

!RWDiagramLayout methodsFor: 'replaceMooseEntities' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
replaceMooseEntities: aBooleanOrStringUndefinded
	replaceMooseEntities := aBooleanOrStringUndefinded! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
resetAppearance
	elementGroup elementList do: [ :each | each attributeList attributeIsSpecified ifTrue: [ each attributeList appearance: RWDiagramUndeterminedAppearance new ] ]! !

!RWDiagramLayout methodsFor: 'scope' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
scope
   scope ifNil: [ scope := self methodScope ].
	^ scope! !

!RWDiagramLayout methodsFor: 'scope' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
scope: aString 
	scope := aString! !

!RWDiagramLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
snapToGrid
	snapToGrid ifNil:[snapToGrid := RWDiagramSnapToGrid new].
	^snapToGrid! !

!RWDiagramLayout methodsFor: 'linestyle' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
straightLineStyle
	^#straightLineStyle! !

!RWDiagramLayout methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressOthersActive
	suppressOthersActive ifNil: [ suppressOthersActive := false ].
	^ suppressOthersActive! !

!RWDiagramLayout methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressOthersActive: aBoolean
	suppressOthersActive := aBoolean! !

!RWDiagramLayout methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressWithChildren: aBoolean to: aModelElement

	self remember: [ :attributeList | |a2| a2 := attributeList suppressWithChildren: aBoolean. a2 ] ofModel: aModelElement! !

!RWDiagramLayout methodsFor: 'writeFile' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
writeToStream: aStream
	| writer layoutFile |
	layoutFile := RWDiagramLayoutFile new.
	(writer := XMLWriter on: aStream)
		enablePrettyPrinting;
		xml;
		lineBreak: String crlf;
		comment: 'Moose2Model Layout data, visit moose2model.org on how to use this file'.
	writer tag
		name: #elements;
		with: [ writer tag: #version with: self actualVersion.
			self packageBoxSuppressed
				ifTrue: [ writer tag: #suppressed with: #packageBox ].
			self scope = self packageScope
				ifTrue: [ writer tag: #scope with: #package ]
				ifFalse: [ self scope = self classScope
						ifTrue: [ writer tag: #scope with: #class ]
						ifFalse: [ self scope = self methodScope
								ifTrue: [ writer tag: #scope with: #method ] ] ].
			elementGroup elementList
				do: [ :element | 
					element elementIsStored
						ifTrue: [ element attributeList attributeIsSpecified
								ifTrue: [ writer tag
										name: #element;
										with: [ layoutFile writeElement: element toXML: writer.
											layoutFile writeAttributeList: element attributeList toWriter: writer ] ] ] ] ]! !

RWDiagramAbstractLayout subclass: #RWDiagramUndefinedLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramUndefinedLayout commentStamp: 'RainerWinkler 8/10/2016 11:05' prior: 0!
I am a not defined Layout.

See documentation of class RWDiagram on how to use this package.!

!RWDiagramUndefinedLayout methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isDefined
	^ false! !

RWDiagram subclass: #RWDiagramAbstractLayoutChanger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramAbstractLayoutChanger commentStamp: 'RainerWinkler 8/13/2016 19:18' prior: 0!
I adapt positions in an RTView as specified in the attributes of an Layout.!

RWDiagramAbstractLayoutChanger subclass: #RWDiagramAbstractAttributesLayoutChanger
	instanceVariableNames: 'currentLayout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramAbstractAttributesLayoutChanger commentStamp: 'RainerWinkler 8/13/2016 19:20' prior: 0!
My subclasses derive informations from attributes of an layout.!

!RWDiagramAbstractAttributesLayoutChanger methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
currentLayout2
	^ currentLayout! !

!RWDiagramAbstractAttributesLayoutChanger methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
currentLayout2: aRWDiagramLayout 
	currentLayout := aRWDiagramLayout! !

RWDiagramAbstractAttributesLayoutChanger subclass: #RWDiagramLCPLayers
	instanceVariableNames: 'offsetY'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramLCPLayers commentStamp: 'RainerWinkler 8/13/2016 19:51' prior: 0!
I group elements in layers depending on what elements depends on other elements.!

!RWDiagramLCPLayers methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
layerZeroY: aRTView
	| attributeList layerZeroY |
	layerZeroY := nil.
	aRTView elements
		do: [ :element1 | 
			(element1 model class inheritsFrom: RWDiagramAbstractComment)
				ifFalse: [ attributeList := self currentLayout
						readAttributesFromFAMIXElement: element1 model.
					attributeList attributeIsSpecified
						ifTrue: [ attributeList position positionIsDetermined
								ifTrue: [ attributeList appearance othersAreSuppressed
										ifTrue: [ attributeList appearance minimalLayer = 0
												ifTrue: [ layerZeroY ifNil: [ layerZeroY := attributeList position point y ] ] ] ] ] ] ].
	layerZeroY ifNil: [ layerZeroY := 0 ].
	layerZeroY := layerZeroY + self offsetY.
	^ layerZeroY! !

!RWDiagramLCPLayers methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
offsetY
	offsetY ifNil:[offsetY := 0].
	^offsetY! !

!RWDiagramLCPLayers methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
offsetY: anInteger 
	offsetY := anInteger! !

!RWDiagramLCPLayers methodsFor: 'as yet unclassified' stamp: ''!
readLayers: aRTView
	| attributeList |
	self currentLayout replaceMooseEntities: true.
	aRTView elements
		do: [ :element1 | 
			element1 model class = RWDiagramElement ifTrue:[
			(element1 model famixElement class asString = self aFAMIXMethod
				or: [ element1 model famixElement class asString = self aFAMIXAttribute ])
				ifTrue: [ Transcript
						show: element1 model famixElement parentType moose2ModelName;
						show: ' ';
						show: element1 model famixElement moose2ModelName;
						show: ' '.
					attributeList := self currentLayout
						readAttributesFromFAMIXElement: element1 model.
					attributeList attributeIsSpecified
						ifTrue: [ attributeList appearance othersAreSuppressed
								ifTrue: [ element1
										translateTo:
											element1 position x
												@ ((self layerZeroY: aRTView) + (-1 * 100 * attributeList appearance minimalLayer)).
									Transcript
										show: attributeList appearance minimalLayer asString;
										cr ]
								ifFalse: [ element1 translateTo: 0 @ 0 ] ]
						ifFalse: [ element1 translateTo: 0 @ 0 ] ] ] ].
	self currentLayout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

RWDiagramAbstractAttributesLayoutChanger subclass: #RWDiagramLCPositions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramLCPositions commentStamp: 'RainerWinkler 8/13/2016 19:19' prior: 0!
I adapt positions as specfied in the attributes of an Layout.!

!RWDiagramLCPositions methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readPositions: aRTView
	| attributeList aRWDiagramElement log |
	log := false.
	log ifTrue:[Transcript cr; show: 'Read positions'; cr.].
	self currentLayout2 replaceMooseEntities: true.
	self currentLayout2 snapToGrid reset.
	aRTView elements
		do: [ :element1 | 
			(element1 model class inheritsFrom: RWDiagramAbstractComment)
				ifTrue: [ (aRTView elements select: [ :element | element model class = RWDiagramElement and: [ element1 model uniqueKey = element model uniqueKey ] ])
						do: [ :each | 
							attributeList := self currentLayout2 readAttributesFromFAMIXElement: each model.
							attributeList
								ifNotNil: [ element1 model class = RWDiagramLocalComment
										ifTrue: [ attributeList comment positionSet
												ifTrue: [ element1 translateTo: attributeList comment position ] ] ] ] ].
			element1 model class = RWDiagramElement
				ifTrue: [ (element1 model famixElement class inheritsFrom: MooseEntity)
						ifTrue: [ aRWDiagramElement := RWDiagramElement famixElement: element1 model famixElement.
							attributeList := self currentLayout2 readAttributesFromFAMIXElement: aRWDiagramElement.
							attributeList attributeIsSpecified
								ifTrue: [ attributeList position positionIsDetermined
										ifTrue: [ element1 translateTo: ( ( self currentLayout2 snapToGrid) element: element1 model famixElement  snap: attributeList position point).
											log
												ifTrue: [ Transcript show: element1 model asString, ' to ',attributeList position point x asString, '@',attributeList position point y asString; cr  ] ] ] ] ] ].
	self currentLayout2 replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined! !

RWDiagramAbstractLayoutChanger subclass: #RWDiagramLCPreventOverlapping
	instanceVariableNames: 'currentLayout space repeat maxChecks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramLCPreventOverlapping commentStamp: 'RainerWinkler 8/13/2016 19:52' prior: 0!
I prevent overlapping of elements in diagrams.!

!RWDiagramLCPreventOverlapping methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
maxChecks
	maxChecks ifNil: [ maxChecks := 0 ].
	^maxChecks! !

!RWDiagramLCPreventOverlapping methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
maxChecks: anInteger 
	maxChecks := anInteger! !

!RWDiagramLCPreventOverlapping methodsFor: 'as yet unclassified' stamp: ''!
preventOverlappings: aRTView messages: aBoolean
	| es es2 somethingDone counter |
	es := Set new.
	es2 := Set new.
	counter := self maxChecks.
	aRTView elements
		do: [ :element | element model class = RWDiagramElement ifTrue:[
			(({self aFAMIXMethod.
			self aFAMIXAttribute} includes: element model famixElement class asString) or:[element model famixElement class inheritsFrom: RWDiagramAbstractComment])
				ifTrue: [ es add: element.
					es2 add: element ] ] ].
	self repeat
		timesRepeat: [ somethingDone := false.
			es
				do: [ :e | 
					es2
						do: [ :e2 | 
							e = e2
								ifFalse: [ | dx minDx |
									dx := e position x - e2 position x.
									minDx := e width / 2 + (e2 width / 2) + self space.
									dx abs < minDx
										ifTrue: [ | dy minDy |
											dy := e position y - e2 position y.
											minDy := e height / 2 + (e2 height / 2) + self space.
											dy abs < minDy
												ifTrue: [ e translateTo: e position x @ (e2 position y + minDy).
													somethingDone := true ] ] ].
							counter := counter - 1. counter < 0 ifTrue:[UIManager default alert: 'prevent Overlapping stoped after ', self maxChecks asString , ' steps. Call RWDiagram lCPOMaxChecks: x. where x is a higher number if needed. Runtime may be long!!'. ^ self] ] ].
			somethingDone
				ifFalse: [ aBoolean
						ifTrue: [ self inform: 'prevent Overlapping finished' ].
					^ self ] ].
	aBoolean
		ifTrue: [ UIManager default alert: 'Not all overlapping elements might be moved after ', self repeat asString , 'loops, you may call RWDiagram lCPORepeat: x where x is a higher number of loops.' ]! !

!RWDiagramLCPreventOverlapping methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
repeat
	repeat ifNil:[repeat := 1].
	^repeat! !

!RWDiagramLCPreventOverlapping methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
repeat: anInteger 
	repeat := anInteger! !

!RWDiagramLCPreventOverlapping methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
space
	space ifNil:[space := 0].
	^space! !

!RWDiagramLCPreventOverlapping methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
space: anInteger 
	space := anInteger! !

RWDiagram subclass: #RWDiagramAbstractPosition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramAbstractPosition commentStamp: 'RainerWinkler 8/8/2017 22:41' prior: 0!
Specfies common methods for positions.
!

!RWDiagramAbstractPosition methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
positionIsDetermined

  self subclassResponsibility! !

RWDiagramAbstractPosition subclass: #RWDiagramPosition
	instanceVariableNames: 'point'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramPosition commentStamp: 'RainerWinkler 8/8/2017 22:41' prior: 0!
I am a position. I know whether I am specified.
!

!RWDiagramPosition methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
point
	^point! !

!RWDiagramPosition methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
point: aPoint 
	point := aPoint! !

!RWDiagramPosition methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
positionIsDetermined
	^true! !

RWDiagramAbstractPosition subclass: #RWDiagramUndeterminedPosition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramUndeterminedPosition commentStamp: 'RainerWinkler 8/8/2017 22:41' prior: 0!
I am a not yet determined position.
!

!RWDiagramUndeterminedPosition methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
positionIsDetermined
	^false! !

RWDiagram subclass: #RWDiagramAnonymize
	instanceVariableNames: ''
	classVariableNames: 'anonymize number'
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramAnonymize commentStamp: 'RainerWinkler 8/8/2017 22:42' prior: 0!
I am used to create anonymized layouts.!

!RWDiagramAnonymize class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
anonymize
	anonymize ifNil: [ anonymize := false ].
	anonymize
		ifTrue: [ ^ true ].
	^ false! !

!RWDiagramAnonymize class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
anonymize: aBoolean
	aBoolean
		ifTrue: [ anonymize := true.
			        number := 1.
			^ self ]
		ifFalse: [ anonymize := false.
			^ self ].
	UIManager default alert: 'Only true or false are allowed'! !

!RWDiagramAnonymize class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
getAnonymName: aClearName withPrefix: aPrefix
	| numberString l numberLength numberOfZeros zeros newName prefixLength positionOfFirstLineBreak |
	l := aClearName size.
	positionOfFirstLineBreak := 0.
	positionOfFirstLineBreak := aClearName indexOfAnyOf: '<'.
	number ifNil: [ number := 1 ].
	numberString := number asString.
	numberLength := numberString size.
	prefixLength := aPrefix size.
	numberOfZeros := l - prefixLength - numberLength.
	zeros := ''.
	numberOfZeros > 0
		ifTrue: [ numberOfZeros timesRepeat: [ zeros := zeros , $0 asString ] ].
	newName := aPrefix , zeros , number asString.
	number := number + 1.
	positionOfFirstLineBreak > 0
		ifTrue: [ newName
				replaceFrom: positionOfFirstLineBreak
				to: positionOfFirstLineBreak + 1
				with: String crlf
				startingAt: 1 ].
	^ newName! !

RWDiagram subclass: #RWDiagramAppearanceChangeDeterminer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramAppearanceChangeDeterminer commentStamp: 'RainerWinkler 8/8/2017 22:43' prior: 0!
I determine which for which elements the appearance is to be changed.
!

RWDiagramAppearanceChangeDeterminer subclass: #RWDiagramACDStandard
	instanceVariableNames: 'collectedElements collectedElementsByLayer includeMe usedByLayers usingLayers ofElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramACDStandard commentStamp: 'RainerWinkler 8/8/2017 22:43' prior: 0!
I implement a standard logic to determine for what elements, the appearance is to be changed.
!

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
= anInstance
	self class moose2ModelName asLowercase = anInstance class moose2ModelName asLowercase 
		ifFalse: [ ^ false ].
	self includeMe = anInstance includeMe
		ifFalse: [ ^ false ].
	self usedByLayers = anInstance usedByLayers
		ifFalse: [ ^ false ].
	self usingLayers = anInstance usingLayers
		ifFalse: [ ^ false ].
		"Do not check for identy of elements. The following is used while generating diagrams:"
	"self ofElement = anInstance ofElement
		ifFalse: [ ^ false ]."
	^ true! !

!RWDiagramACDStandard methodsFor: 'private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
collectUsedByLayers: aUsedByLayers ofElement: aRWDiagramElement layer: currentLayer
	| TempUsedByLayers |
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	(self usedByElements: aRWDiagramElement)
		do: [ :each | 
			| bef aft |
			bef := collectedElements size.
			collectedElements add: each.
			aft := collectedElements size.
			bef = aft
				ifFalse: [ collectedElementsByLayer at: each uniqueKey put: currentLayer ].
			TempUsedByLayers := aUsedByLayers - 1.
			TempUsedByLayers > 0
				ifTrue: [ self collectUsedByLayers: TempUsedByLayers ofElement: each layer: currentLayer + 1 ] ]! !

!RWDiagramACDStandard methodsFor: 'private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
collectUsesLayers: aUsingLayers ofElement: aRWDiagramElement layer: currentLayer

	| tempUsingLayers |
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	(self usesElements: aRWDiagramElement)
		do: [ :each | 
			| bef aft |
			bef := collectedElements size.
			collectedElements add: each.
			aft := collectedElements size.
			bef = aft
				ifFalse: [ collectedElementsByLayer at: each uniqueKey put: currentLayer ].
			tempUsingLayers := aUsingLayers - 1.
			tempUsingLayers > 0
				ifTrue:
					[ self collectUsesLayers: tempUsingLayers ofElement: each layer: currentLayer - 1 ] ]! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
collectedElements
	self
		runIncludeMe: includeMe
		usedByLayers: usedByLayers
		usingLayers: usingLayers
		ofElement: ofElement.
	^ collectedElements! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
element: aRWDiagramElement
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	ofElement := aRWDiagramElement! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
includeMe
	^ includeMe! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
includeMe: aBoolean usedByLayers: aUsedByLayers usingLayers: aUsingLayers
	"Define my properties when this ChangeDeterminer is created by reading from file"

	includeMe := aBoolean.
	usedByLayers := aUsedByLayers.
	usingLayers := aUsingLayers! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
includeMe: aBoolean usedByLayers: aUsedByLayers usingLayers: aUsingLayers ofElement: aRWDiagramElement
	"Define me when this Change Determiners is applied directly on an element"

	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	includeMe := aBoolean.
	usedByLayers := aUsedByLayers.
	usingLayers := aUsingLayers.
	ofElement := aRWDiagramElement! !

!RWDiagramACDStandard methodsFor: 'initialize' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
	collectedElements := Set new.
	collectedElementsByLayer := Dictionary new! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
layerOfElement: aRWDiagramElement
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	^ collectedElementsByLayer at: aRWDiagramElement uniqueKey! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
ofElement
	^ ofElement! !

!RWDiagramACDStandard methodsFor: 'print' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
printOn: aStream
	super printOn: aStream.
	self includeMe
		ifTrue: [ aStream nextPutAll: ' includes this' ].
	self usedByLayers = 0
		ifFalse: [ aStream nextPutAll: ' usedByLayers: ' , self usedByLayers asString ].
	self usingLayers = 0
		ifFalse: [ aStream nextPutAll: ' usingLayers: ' , self usingLayers asString ]! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
runIncludeMe: aBoolean usedByLayers: aUsedByLayers usingLayers: aUsingLayers ofElement: aRWDiagramElement
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
   collectedElementsByLayer ifNil: [ collectedElementsByLayer := Dictionary new ].
	aBoolean
		ifTrue: [ collectedElements add: aRWDiagramElement.
			collectedElementsByLayer at: aRWDiagramElement uniqueKey put: 0 ].
	aUsedByLayers > 0
		ifTrue: [ self collectUsedByLayers: aUsedByLayers ofElement: aRWDiagramElement layer: 1 ].
	aUsingLayers > 0
		ifTrue: [ self collectUsesLayers: aUsingLayers ofElement: aRWDiagramElement layer: -1]! !

!RWDiagramACDStandard methodsFor: 'private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
usedByElements: aRWDiagramElement
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	^ aRWDiagramElement dDependOnMe! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
usedByLayers
	^ usedByLayers! !

!RWDiagramACDStandard methodsFor: 'private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
usesElements: aRWDiagramElement
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	^ aRWDiagramElement dIDependOn! !

!RWDiagramACDStandard methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
usingLayers
	^ usingLayers! !

!RWDiagramAppearanceChangeDeterminer methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
= aRWDiagramAppearanceChangeType
	self subclassResponsibility! !

!RWDiagramAppearanceChangeDeterminer methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
collectedElements
	self subclassResponsibility! !

!RWDiagramAppearanceChangeDeterminer methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
includeMe: aBoolean usedByLayers: aUsedByLayers usingLayers: aUsingLayers ofElement: aRWDiagramElement 
	self subclassResponsibility! !

!RWDiagramAppearanceChangeDeterminer methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
layerOfElement: aRWDiagramElement 
	self subclassResponsibility! !

RWDiagram subclass: #RWDiagramAppearanceChangeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramAppearanceChangeType commentStamp: 'RainerWinkler 8/8/2017 22:43' prior: 0!
I know what kind of changes shall be done to the appearance of an element.
!

RWDiagramAppearanceChangeType subclass: #RWDiagramACTHighlight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramACTHighlight commentStamp: 'RainerWinkler 8/8/2017 22:43' prior: 0!
I cause selected elements to be highlighted.
!

!RWDiagramACTHighlight methodsFor: 'comparing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
= anInstance
	self class moose2ModelName asLowercase  = anInstance class moose2ModelName asLowercase 
		ifFalse: [ ^ false ].
	^ true
	! !

!RWDiagramACTHighlight methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
adjustBy: aRWDiagramElement  forChangeDeterminer: aRWDiagramAppearanceChangeDeterminer
	! !

!RWDiagramACTHighlight methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
highlight
	^ true! !

!RWDiagramACTHighlight methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isTemporary
	^ true! !

!RWDiagramACTHighlight methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressOthers
	^ false! !

RWDiagramAppearanceChangeType subclass: #RWDiagramACTSuppressOthers
	instanceVariableNames: 'refersToLayer refersToElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramACTSuppressOthers commentStamp: 'RainerWinkler 8/8/2017 22:43' prior: 0!
I cause all elements to be suppressed that are not selected by me or related classes.
!

!RWDiagramACTSuppressOthers methodsFor: 'comparing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
= anInstance
	self class moose2ModelName asLowercase = anInstance class moose2ModelName asLowercase 
		ifFalse: [ ^ false ].
		"refersToLayer is used for processing, it is not specifying the type. So do not use it for comparison"
	"self refersToLayer = anInstance refersToLayer
		ifFalse: [ ^ false ]."
	^ true! !

!RWDiagramACTSuppressOthers methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
adjustBy: aRWDiagramElement forChangeDeterminer: aRWDiagramAppearanceChangeDeterminer
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	refersToElement := aRWDiagramAppearanceChangeDeterminer ofElement.
	refersToLayer := aRWDiagramAppearanceChangeDeterminer layerOfElement: aRWDiagramElement! !

!RWDiagramACTSuppressOthers methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
highlight
	^ false! !

!RWDiagramACTSuppressOthers methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isTemporary
	^ false! !

!RWDiagramACTSuppressOthers methodsFor: 'tentative' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refersToLayer
  ^ refersToLayer! !

!RWDiagramACTSuppressOthers methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressOthers
	^ true! !

!RWDiagramAppearanceChangeType methodsFor: 'comparing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
= aRWDiagramAppearanceChangeType
	self subclassResponsibility! !

!RWDiagramAppearanceChangeType methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
adjustBy: aRWDiagramElement  forChangeDeterminer: aRWDiagramAppearanceChangeDeterminer
	self subclassResponsibility! !

!RWDiagramAppearanceChangeType methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
highlight
	self subclassResponsibility! !

!RWDiagramAppearanceChangeType methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isTemporary
"Do not store this appearance on file. Allow easy deletion of this appearance"
	self subclassResponsibility! !

!RWDiagramAppearanceChangeType methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressOthers
"Do not store this appearance on file. Allow easy deletion of this appearance"
	self subclassResponsibility! !

RWDiagram subclass: #RWDiagramAppearanceChanger
	instanceVariableNames: 'changeType changeDeterminer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramAppearanceChanger commentStamp: 'RainerWinkler 8/8/2017 22:43' prior: 0!
I contain all informations to change the appearance of this and neighbour elements.
!

!RWDiagramAppearanceChanger class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
changeDeterminer: aRWDiagramAppearanceChangeDeterminer changeType: aRWDiagramAppearanceChangeType
	| changer |
	changer := RWDiagramAppearanceChanger new.
	changer changeDeterminer: aRWDiagramAppearanceChangeDeterminer.
	changer changeType: aRWDiagramAppearanceChangeType.
	^ changer! !

!RWDiagramAppearanceChanger methodsFor: 'comparing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
= aRWDiagramAppearanceChanger
	^ self changeType = aRWDiagramAppearanceChanger changeType and: self changeDeterminer = aRWDiagramAppearanceChanger changeDeterminer! !

!RWDiagramAppearanceChanger methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
changeDeterminer
	^ changeDeterminer! !

!RWDiagramAppearanceChanger methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
changeDeterminer: aRWDiagramAppearanceChangeDeterminer 
	changeDeterminer := aRWDiagramAppearanceChangeDeterminer! !

!RWDiagramAppearanceChanger methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
changeType
	^ changeType! !

!RWDiagramAppearanceChanger methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
changeType: aRWDiagramAppearanceChangeType 
	changeType := aRWDiagramAppearanceChangeType! !

!RWDiagramAppearanceChanger methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
changeTypeAdjustedFor: aRWDiagramElement
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
  changeType := changeType copy.
  changeType adjustBy: aRWDiagramElement forChangeDeterminer: changeDeterminer.
	^ changeType! !

RWDiagram subclass: #RWDiagramAppearanceChangerGroup
	instanceVariableNames: 'appearanceChangers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-appearance'!

!RWDiagramAppearanceChangerGroup commentStamp: 'RainerWinkler 8/8/2017 22:43' prior: 0!
I am a list of all appeacance changes of an element.
!

!RWDiagramAppearanceChangerGroup methodsFor: 'adding' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
addAppearentChanger: aRWDiagramAppearanceChanger 
   appearanceChangers ifNil: [ appearanceChangers := OrderedCollection new ].
   appearanceChangers do: [ :each | each = aRWDiagramAppearanceChanger ifTrue:[^self "Do not add a duplicate" ] ].
	appearanceChangers add: aRWDiagramAppearanceChanger  ! !

!RWDiagramAppearanceChangerGroup methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
appearanceChangers
    appearanceChangers ifNil: [ appearanceChangers := OrderedCollection new ].
	^ appearanceChangers! !

!RWDiagramAppearanceChangerGroup methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
removeTemporary
	self appearanceChangers removeAllSuchThat: [ :each | each changeType isTemporary ]! !

RWDiagram subclass: #RWDiagramDefaultColorSchema
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramDefaultColorSchema commentStamp: 'RainerWinkler 8/10/2016 11:06' prior: 0!
Overwrite me for specifc colors.

See documentation of class RWDiagram on how to use this package.!

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributeColor
	^ Color lightBlue! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributeHighLightedColor
	^ Color blue! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributeLineColor
  ^ Color blue trans! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
classColor
	^ Color lightGray alpha: 0.2! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
commentFontSize
	^ 6! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dataBaseAsAttributeColor
	^ Color lightGreen! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dataBaseAsAttributeHighLighteColor
	^ Color green! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dataBaseTableColor
	^ Color white! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
methodColor
	^ Color r:255/255 g: 235/255 b: 153/255! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
methodHighLightedColor
	^ Color orange! !

!RWDiagramDefaultColorSchema methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
methodLineColor
	^ Color gray trans! !

RWDiagram subclass: #RWDiagramEditor
	instanceVariableNames: 'globalElementGroup currentLayoutName currentLayout processedRTView layouts settings globalComments lastUsedView lastUsedClassGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

RWDiagramEditor class
	instanceVariableNames: 'uniqueInstance'!

!RWDiagramEditor commentStamp: 'RainerWinkler 8/8/2017 22:42' prior: 0!
Manage reading and modifying positions and other features in applications that use diagrams based on RTMondrian.

globalElementGroup contains all informations that are equal for each layout. This are currently global comments.
!

RWDiagramEditor class
	instanceVariableNames: 'uniqueInstance'!

!RWDiagramEditor class methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isDiagramElement: anElement 
	^(anElement class inheritsFrom: MooseEntity ) or: anElement class = RWDiagramNoPackage! !

!RWDiagramEditor class methodsFor: 'creation' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refresh
   "Refresh application. Create it by sending new to super, otherwise there will be an infinite loop"
	uniqueInstance := super new.
	^ uniqueInstance ! !

!RWDiagramEditor class methodsFor: 'creation' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
uniqueInstance
   "If instance is not yet created, create it by sending new to super, otherwise there will be an infinite loop"
	uniqueInstance ifNil: [ uniqueInstance := super new ].
	^ uniqueInstance ! !

!RWDiagramEditor methodsFor: 'globalComments' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
addGlobalComments: aRWDiagramGlobalComment to: aRWDiagramElement
	self
		remember: [ :attributeList | 
			| a2 |
			aRWDiagramElement class = RWDiagramElement
				ifFalse: [ RWDiagramElementWrongTypeError signal ].
			attributeList attributeIsSpecified
				ifFalse: [ a2 := RWDiagramGlobalAttributeList new ]
				ifTrue: [ a2 := attributeList ].
			a2 addComment: aRWDiagramGlobalComment.
			a2 ]
		ofModel: aRWDiagramElement! !

!RWDiagramEditor methodsFor: 'reading' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
commentsOf: aRWDiagramElementCollection forLayout: aRWDiagramLayout
	| col |
	"Returns a list of all local coments for a collections of FAMIX Elements. Sets moosesID in the Comment to be used in connecting both"
	aRWDiagramLayout replaceMooseEntities: true.
	col := OrderedCollection new.
	aRWDiagramElementCollection
		do: [ :each | 
			| attributeList |
			attributeList := aRWDiagramLayout readAttributesFromFAMIXElement: each.
			attributeList attributeIsSpecified
				ifTrue: [ attributeList comment exists
						ifTrue: [ attributeList comment uniqueKeyOfCommentedElement: each uniqueKey.
							col add: attributeList comment ] ] ].
	aRWDiagramLayout replaceMooseEntities: RWDiagramLayout replaceMooseEntitiesUndefined.
	^ col! !

!RWDiagramEditor methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
currentLayout
	"Creates a new view if not yet existing"

	| layout |
	layouts ifNil: [ layouts := Dictionary new ].
	layout := layouts at: currentLayoutName ifAbsentPut: [ RWDiagramLayout new moose2ModelName: currentLayoutName ].
	currentLayout := layout.
	^ layout! !

!RWDiagramEditor methodsFor: 'public' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
currentLayoutName
	^currentLayoutName! !

!RWDiagramEditor methodsFor: 'public' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
currentLayoutName: aString
	currentLayoutName := aString.
	"Workaround, make sure that current Layout is immediately set:"
	self currentLayout.
	RWDiagramSimpleGui getInstance redrawMe! !

!RWDiagramEditor methodsFor: 'globalComments' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
defaultGlobalCommentColor
	^ Color orange! !

!RWDiagramEditor methodsFor: 'reading' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
globalCommentsOf: aModelElementsCollection
	| col |
	"Returns a list of all global coments for a collections of FAMIX Elements. Sets moosesID in the Comment to be used in connecting both"
	col := OrderedCollection new.
	aModelElementsCollection
		do: [ :each | 
			| globalAttributeList |
			globalAttributeList := self readAttributesFromFAMIXElement: each.
			globalAttributeList attributeIsSpecified
				ifTrue: [ globalAttributeList comments
						do: [ :globComment | 
							globComment uniqueKeyOfCommentedElement: each uniqueKey.
							col add: globComment ] ] ].
	^ col! !

!RWDiagramEditor methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
globalElementGroup
	^ globalElementGroup! !

!RWDiagramEditor methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
	super initialize.
	globalElementGroup := RWDiagramElementGroup new.
	currentLayoutName := 'First'.
	currentLayout := RWDiagramLayout new.
	currentLayout moose2ModelName: currentLayoutName.
	layouts := Dictionary new.
	settings := RWDiagramSettings new! !

!RWDiagramEditor methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lastUsedClassGroup
	^lastUsedClassGroup ! !

!RWDiagramEditor methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lastUsedClassGroup: aFAMIXClassGroup 
	lastUsedClassGroup := aFAMIXClassGroup! !

!RWDiagramEditor methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lastUsedView
	^lastUsedView! !

!RWDiagramEditor methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lastUsedView: aRoassalView 
	lastUsedView := aRoassalView! !

!RWDiagramEditor methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
layoutForRTView: aRTView
	"Returns error message if no Layout found"

	layouts
		do: [ :l | 
			l processedRTView == aRTView
				ifTrue: [ ^ l ] ].
	UIManager default alert: 'No Layout found. You should use a RTView that is the last one that is generated using one of the layouts. You may generate the diagram again and repeat the activity'.
	^ RWDiagramUndefinedLayout new! !

!RWDiagramEditor methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
layoutForRTView: aRTView message: aBoolean
	"Returns error message if no Layout found"

	layouts
		do: [ :l | 
			l processedRTView == aRTView
				ifTrue: [ ^ l ] ].
	aBoolean ifTrue: [UIManager default alert: 'No Layout found. You should use a RTView that is the last one that is generated using one of the layouts. You may generate the diagram again and repeat the activity'].
	^ RWDiagramUndefinedLayout new! !

!RWDiagramEditor methodsFor: 'list' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
listLayouts
	| stream return |
	stream := WriteStream on: String new.
	return := String crlf.
	stream nextPutAll: 'Current layout: ';
	       nextPutAll: currentLayoutName;
	       nextPutAll: return.
	stream
		nextPutAll: 'A list with all available layouts:';
		nextPutAll: return.
	layouts asSortedCollection
		do: [ :each | 
			stream
				nextPutAll: each moose2ModelName;
				nextPutAll: return ].
	Transcript
		cr;
		show: stream contents! !

!RWDiagramEditor methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readAttributesFromFAMIXElement: aFAMIXElement
	^ (globalElementGroup apply: [ :e | e ] toAttribute: aFAMIXElement replace: true "Check" ) attributeList! !

!RWDiagramEditor methodsFor: 'file' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readFromFile: aFileName expliciteStream: aStream
	"When aStream is provided (not nil) use the stream instead. 
This is required for tests"

	aStream
		ifNil: [ FileStream readOnlyFileNamed: aFileName do: [ :stream | self currentLayout readFromStream: stream message: true ] ]
		ifNotNil: [ self currentLayout readFromStream: aStream message: true ].
	RWDiagramSimpleGui getInstance redrawMe! !

!RWDiagramEditor methodsFor: 'reading' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
readToRTView: aRTView layout: aRWDiagramLayout messages: aBoolean
	"Apply directy to an RTView
   apply selv view on a RTMondrian to get this view"

	<RWDiaEdit_14>
	<RWDiaEdit_49>
	self settings isReadingLayers
		ifTrue: [ | lcLayers |
			lcLayers := RWDiagramLCPLayers new.
			lcLayers
				currentLayout: aRWDiagramLayout;
				offsetY: self settings offsetY;
				readLayers: aRTView ]
		ifFalse: [ self settings isReadingPosition
				ifTrue: [ | lcp |
					lcp := RWDiagramLCPositions new.
					lcp
						currentLayout2: aRWDiagramLayout;
						readPositions: aRTView ] ].
	self settings preventOverlapping
		ifTrue: [ | lcPO |
			lcPO := RWDiagramLCPreventOverlapping new.
			lcPO
				space: self settings lCPOSpace;
				repeat: self settings lCPORepeat;
				maxChecks: self settings lCPOMaxChecks;
				preventOverlappings: aRTView messages: aBoolean ].
	aRWDiagramLayout processedRTView: aRTView! !

!RWDiagramEditor methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refreshLayout: aRWDiagramLayout
	"Creates a new instance for the current layout. This is needed if the reported MooseModel changes."

	| layout moose2ModelName |
	moose2ModelName := aRWDiagramLayout moose2ModelName.
	layouts ifNil: [ layouts := Dictionary new ].
	layouts at: moose2ModelName put: ( RWDiagramLayout new moose2ModelName: moose2ModelName ).
	layout := layouts at: moose2ModelName.
	^ layout! !

!RWDiagramEditor methodsFor: 'elementGroupAccess' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
remember: aBlock ofModel: currentRWDiagramElement
	currentRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	globalElementGroup apply: aBlock toAttribute: currentRWDiagramElement replace: true "Check"! !

!RWDiagramEditor methodsFor: 'remember' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
rememberRTView: aRTView to: aLayout
	<RWDiaEdit_35>
	aRTView elements
		do: [ :aRTElement | 
			(aRTElement model class = RWDiagramLocalComment)
				ifTrue: [ (aRTView elements
						select: [ :each | each model class = RWDiagramElement and: [ (each model famixElement class inheritsFrom: MooseEntity) and: [ each model uniqueKey = aRTElement model uniqueKeyOfCommentedElement ] ] ])
						do: [ :each | 
							aLayout
								remember: [ :attributeList | 
									attributeList comment position: aRTElement position.
									attributeList ]
								fromRTElement: each ] ]
				ifFalse: [ aLayout remember: [ :attributeList | attributeList position: aRTElement position ] fromRTElement: aRTElement ] ]! !

!RWDiagramEditor methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setCurrentLayout: aRTView message: aBoolean
	| layout moose2ModelName oldName |
	oldName := self currentLayoutName.
	layout := self layoutForRTView: aRTView message: aBoolean.
	layout isDefined
		ifTrue: [ moose2ModelName := layout moose2ModelName.
			oldName = moose2ModelName
				ifTrue: [ self inform: 'Layout not changed: ' , moose2ModelName ]
				ifFalse: [ self currentLayoutName: moose2ModelName.
					self inform: 'Old layout: ' , oldName , ' New layout: ' , moose2ModelName ] ]
		ifFalse: [ UIManager default alert: 'Current layout is not changed' ]! !

!RWDiagramEditor methodsFor: 'file' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setLayOutFromFilename: aFilename
	| fn |
	fn := (FileSystem disk pathFromString: aFilename) basenameWithoutExtension.
	fn = self currentLayoutName
		ifFalse: [ (self confirm: 'Change layout to filename' , fn , '?')
				ifTrue: [ self currentLayoutName: fn ] ]! !

!RWDiagramEditor methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
settings
	settings ifNil: [ settings := RWDiagramSettings new ].
	^settings! !

!RWDiagramEditor methodsFor: 'remember' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressWithChildren: aBoolean to: aModelElement
	self currentLayout suppressWithChildren: aBoolean to: aModelElement! !

!RWDiagramEditor methodsFor: 'remember' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
suppressWithChildren: aBoolean to: aModelElement ofLayout: aRWDiagramLayout
	aRWDiagramLayout suppressWithChildren: aBoolean to: aModelElement! !

!RWDiagramEditor methodsFor: 'file' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
write: aLayout toFile: aFileName
"Is obsolete?"
	FileStream forceNewFileNamed: aFileName do: [ :stream | aLayout writeToStream: stream ]! !

!RWDiagramEditor methodsFor: 'globalFile' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
writeGlobalToStream: aReadWriteStream
	| writer globalFile |
   self haltOnce.
	globalFile := RWDiagramGlobalFile new.
	(writer := XMLWriter on: aReadWriteStream)
		enablePrettyPrinting;
		xml;
		lineBreak: String crlf;
		comment: 'Global Comments'.
	writer tag
		name: #elements;
		with: [ globalElementGroup elementList
				do: [ :element | 
					writer tag
						name: #element;
						with: [ globalFile writeElement: element toXML: writer.
							globalFile writeGlobalAttributeList: element attributeList toWriter: writer ] ] ]! !

!RWDiagramEditor methodsFor: 'file' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
writeToFile: aFileName
	self currentLayout
		ifNil: [ Warning signal: 'Current view' , currentLayoutName , ' does not exist'.
			nil ]
		ifNotNil: [ FileStream forceNewFileNamed: aFileName do: [ :stream | self currentLayout writeToStream: stream ] ]! !

RWDiagram subclass: #RWDiagramElement
	instanceVariableNames: 'attributeList famixElement uniqueKey connectedTo accessedTo connectedFrom'
	classVariableNames: 'famixElementHash lastHash'
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramElement commentStamp: 'RainerWinkler 8/13/2017 07:49' prior: 0!
I store all information for a model element.
I am always part of a RWDiagramElementGroup, so that my attribute List is consistent for a RWDiagramElementGroup.
So create instances of me only using the methods of RWDiagramElementGroup.
I am indexed using my uniqueKey, when I am created I remember my uniqueKey in the instance variable uniqueKey.
When I am neither FAMIXPackage, FAMIXClass, FAMIXAttribute nor FAMIXMethod, my uniqueKey will be the MooseID.
I have a dictionary famixElementHash, this is needed to provide a unique hash value for method hash. This is required because I refefine = and in this case I have to redefine hash also.
I have a dictionary famixElementByUniqueKey. This is currently not used because a similar list in RWDiagramElementGroup is used.
I store in connectedTo all Elements I where invocations  exists on method level on package and class level.
I store in accessedTo all Elements where accesses exists on attribut level on package and class level.!

!RWDiagramElement class methodsFor: 'private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
famixElement: aFAMIXElement
	"Call me only from RWDiagramElementGroup"

	| el |
	el := super new.
	el famixElement: aFAMIXElement.
	^ el! !

!RWDiagramElement class methodsFor: 'private' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refresh
	famixElementHash := nil.
	lastHash := nil! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
<= aRWDiagramElement 
	|stream1 stream2 s1 s2|
	stream1 := WriteStream on: String new.
	stream2 := WriteStream on: String new.
	self famixElement printOn: stream1.
	aRWDiagramElement famixElement printOn: stream2.
	s1 := stream1 contents.
	s2 := stream2 contents.
	
^(s1 <= s2)! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: ''!
= aRWDiagramElement
	self class = aRWDiagramElement class
		ifFalse: [ ^ false ].
	^ self uniqueKey = aRWDiagramElement uniqueKey! !

!RWDiagramElement methodsFor: 'connections' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
accessedTo
	accessedTo ifNil: [ accessedTo := Set new ].
	^ accessedTo! !

!RWDiagramElement methodsFor: 'connections' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
accessedTo: aRWDiagramElement
	accessedTo ifNil: [ accessedTo := Set new ].
	accessedTo add: aRWDiagramElement! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
asRWDiagramElement
   self halt.
	^ self! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
asRWDiagramElement: any
	^ self! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
asRWDiagramElements: famixElements
	| out |
	out := Set new.
	famixElements
		do: [ :each | out add: (RWDiagramElement famixElement: each) ].
	^ out! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributeList
	attributeList ifNil: [ attributeList := RWDiagramUndeterminedAttributeList new ].
	^ attributeList! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
attributeList: aRWDiagramAttributeList 
	attributeList := aRWDiagramAttributeList! !

!RWDiagramElement methodsFor: 'connections' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
connectedFrom
	connectedFrom ifNil: [ connectedFrom := Set new ].
	^ connectedFrom! !

!RWDiagramElement methodsFor: 'connections' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
connectedFrom: aRWDiagramElement
	connectedFrom ifNil: [ connectedFrom := Set new ].
	connectedFrom add: aRWDiagramElement! !

!RWDiagramElement methodsFor: 'connections' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
connectedTo
	connectedTo ifNil: [ connectedTo := Set new ].
	^ connectedTo! !

!RWDiagramElement methodsFor: 'connections' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
connectedTo: aRWDiagramElement
	connectedTo ifNil: [ connectedTo := Set new ].
	connectedTo add: aRWDiagramElement! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dAttributes
	^famixElement attributes! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: ''!
dDependOnMe
	"Returns a set of RWDiagramElement that depend on this element"

	| famixElements out |
	self famixElement class asString = self aFAMIXMethod
		ifTrue: [ famixElements := self famixElement invokingMethods storage union: (self famixElement queryOutgoingAccesses opposites asSet select: #isAttribute).
			out := self asRWDiagramElements: famixElements. ].

	self famixElement class asString = self aFAMIXAttribute
		ifTrue: [ famixElements := self famixElement accessingMethods.
			out := self asRWDiagramElements: famixElements. ].
	out ifNil:[out := Set new].
	^ out! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dFrom
	^ (famixElement perform: #from) asRWDiagramElement! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: ''!
dIDependOn
	"Returns a set of RWDiagramElement an element depends on"

	| famixElements out |
	self famixElement class asString = self aFAMIXMethod
		ifTrue: [ famixElements := self famixElement invokedMethods storage union: (self famixElement queryOutgoingAccesses opposites asSet select: #isAttribute). out := self asRWDiagramElements: famixElements ].
	self famixElement class asString = self aFAMIXAttribute
		ifTrue: [ famixElements := self famixElement accessingMethods. out := self asRWDiagramElements: famixElements ].
	out ifNil:[out := Set new].
	^ out! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dMethods
	^famixElement methods! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dModifiers
	^famixElement modifiers! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dName
	RWDiagramAnonymize anonymize
		ifTrue: [ ^ RWDiagramAnonymize getAnonymName: famixElement moose2ModelName withPrefix: 'moose2ModelName' ].
	^ famixElement moose2ModelName! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dParentPackage
	^famixElement m2mParentPackage! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dVariable
	^ (famixElement perform: #variable) asRWDiagramElement! !

!RWDiagramElement methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
determineUniqueKey
	uniqueKey := self determineUniqueKey: famixElement! !

!RWDiagramElement methodsFor: 'accessing' stamp: ''!
determineUniqueKey: aFamixElement
	| classScopeString key |
	(aFamixElement class asString = self aFAMIXPackage or: [ aFamixElement class asString = self aFAMIXClass ])
		ifTrue: [ key := aFamixElement class asString , '>' , aFamixElement moose2ModelName asString asLowercase ]
		ifFalse: [ (aFamixElement class asString = self aFAMIXMethod or: [ aFamixElement class asString = self aFAMIXAttribute ])
				ifTrue: [ aFamixElement hasClassScope
						ifTrue: [ classScopeString := 'cl' ]
						ifFalse: [ classScopeString := 'in' ].
					key := aFamixElement class asString , '>' , aFamixElement parentType moose2ModelName asString asLowercase, '>' , aFamixElement moose2ModelName asString asLowercase  , '>' , classScopeString ]
				ifFalse: [ key := famixElement mooseID ] ].
	^ key! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: ''!
elementHandledWithParents
	^ self famixElement class asString = self aFAMIXMethod | (self famixElement class asString = self aFAMIXAttribute)! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
elementIsStored
	^ (self famixElement class asString = self aByteString | (self famixElement class asString = self aUndefinedObject)) not! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
famixElement
	^ famixElement! !

!RWDiagramElement methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
famixElement: aFAMIXElement
	"Set list with hash"
	"Set list with elements by key"
	(RWDiagramEditor isDiagramElement: aFAMIXElement)
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	famixElement := aFAMIXElement.
	self determineUniqueKey.
	self setlistWithHash! !

!RWDiagramElement methodsFor: 'comparing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
hash
	[ ^ famixElementHash at: uniqueKey ]
		on: KeyNotFound
		do: [ self setlistWithHash.
			^ famixElementHash at: uniqueKey ]! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isNoPackage
	famixElement class moose2ModelName = #RWDiagramNoPackage ifTrue: [ ^true ] ifFalse: [ ^false ]! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
printOn: aStream
	super printOn: aStream.
	famixElement
		ifNotNil: [ aStream nextPutAll: ' '.
			famixElement printOn: aStream ]! !

!RWDiagramElement methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refresh
	famixElement := nil! !

!RWDiagramElement methodsFor: 'connections' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refreshAccessedTo
	accessedTo := Set new! !

!RWDiagramElement methodsFor: 'connections' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
refreshConnectedTo
	connectedTo := Set new.
	connectedFrom := Set new! !

!RWDiagramElement methodsFor: 'connections' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
relatesTo: aRWDiagramElement
"This will be obsolete if only information flow is supported:"
	self connectedTo: aRWDiagramElement.
	"This is the information flow"
	aRWDiagramElement connectedFrom: self! !

!RWDiagramElement methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
setlistWithHash
	famixElementHash ifNil: [ famixElementHash := Dictionary new ].	"Set list with hash"
	lastHash ifNil: [ lastHash := 0 ].
	[ famixElementHash at: uniqueKey ]
		on: KeyNotFound
		do: [ lastHash := lastHash + 1.
			famixElementHash at: uniqueKey put: lastHash ]! !

!RWDiagramElement methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
uniqueKey
	^uniqueKey! !

RWDiagram subclass: #RWDiagramElementGroup
	instanceVariableNames: 'elementList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramElementGroup commentStamp: 'RainerWinkler 8/14/2017 07:40' prior: 0!
I have a list with all diagram elements that are stored. 
I have a list of all elements: elementList. This list has a uniqueKey
I am now optimized when elements are to be searched with method apply:toAttributeAndReplaceElement.
!

!RWDiagramElementGroup methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
add: aRWDiagramElement
	aRWDiagramElement class = RWDiagramElement
		ifFalse: [ RWDiagramElementWrongTypeError signal ].
	elementList at: aRWDiagramElement uniqueKey put: aRWDiagramElement! !

!RWDiagramElementGroup methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
apply: aBlock toAttribute: aRWDiagramElementOrMooseEntity replace: isToBeReplaced
	"Applys the given block to the attribute list of a found or inserted element.
	The block has to return the attributeList."

	"The search is done using names not using the Moose ID"

	"Replace is true: Replaces the Moose Entity in RWDiagramElement with the Moose Entity used for the search. This is used, when the search is done with a real model. For instance when diagram data is stored."

	"Replace is false: Returns the Moose Entity that is already existing if it is found. This is done when the search is done while reading attributes. The real model has to remain untouched. If no element is found, the element used for searching is added to the element list and a corresponding Diagram Element is returned."

	"Returns the RWDiagramElement found"

	| aElement foundElement aMooseEntity |
	"Checks"
	isToBeReplaced = RWDiagramLayout replaceMooseEntitiesUndefined
		ifTrue: [ RWDiagramReplaceUndefined signal ].
	aRWDiagramElementOrMooseEntity class = RWDiagramElement
		ifTrue: [ aMooseEntity := aRWDiagramElementOrMooseEntity famixElement ]
		ifFalse: [ (aRWDiagramElementOrMooseEntity class inheritsFrom: MooseEntity)
				ifTrue: [ aMooseEntity := aRWDiagramElementOrMooseEntity ]
				ifFalse: [ aRWDiagramElementOrMooseEntity class = RWDiagramNoPackage
						ifTrue: [ aMooseEntity := aRWDiagramElementOrMooseEntity ]
						ifFalse: [ RWDiagramElementWrongTypeError signal ] ] ].
	"Read value"
	aElement := RWDiagramElement new.
	aElement famixElement: aMooseEntity.
	[ foundElement := elementList at: aElement uniqueKey.
	foundElement attributeList: (aBlock value: foundElement attributeList).
	(foundElement attributeList class inheritsFrom: RWDiagramAbstractAttributeList)
		ifFalse: [ RWDiagramError signal ].	"The Block aBlock has at the end always to return the attribute list itself"
	foundElement famixElement
		ifNil: [ self replace: foundElement with: aMooseEntity ]
		ifNotNil: [ foundElement famixElement mooseID = aMooseEntity mooseID
				ifTrue: [  ]
				ifFalse: [ isToBeReplaced
						ifTrue: [ self replace: foundElement with: aMooseEntity ]
						ifFalse: [ elementList at: foundElement uniqueKey put: foundElement ] ] ].
	^ foundElement ]
		on: KeyNotFound
		do: [ "No existing RWDiagramElement is found, so insert a new one and apply the block"
			aElement := RWDiagramElement new.
			aElement famixElement: aMooseEntity.
			aElement elementIsStored
				ifTrue: [ aElement attributeList: (aBlock value: RWDiagramUndeterminedAttributeList new).
					elementList at: aElement uniqueKey put: aElement ].
			^ aElement ]! !

!RWDiagramElementGroup methodsFor: 'as yet unclassified' stamp: ''!
dAllClasses
	"Returns a collection of RWDiagramElement"

	| classes |
	classes := Set new.
	classes := elementList select: [ :each | each famixElement class asString = self aFAMIXClass ].
	^ classes! !

!RWDiagramElementGroup methodsFor: 'as yet unclassified' stamp: ''!
dAllClassesOfPackage: aRWDiagramElementTypePackage
	"Returns a collection of RWDiagramElement"

	| classes |
	classes := Set new.
	classes := elementList
		select: [ :each | 
			each famixElement class asString = self aFAMIXClass
				and: [ each dParentPackage moose2ModelName asLowercase = aRWDiagramElementTypePackage famixElement moose2ModelName asLowercase or: [ each dParentPackage isNil and: [ aRWDiagramElementTypePackage isNoPackage ] ] ] ].
	^ classes! !

!RWDiagramElementGroup methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
dAllMethods
"Returns a collection of RWDiagramElement"
	| classes methods |
	classes := self dAllClasses.
	methods := Set new.
	
	classes do: [ :each | each famixElement methods do: [:m| methods add: ( m asRWDiagramElement: self)]].
	^ methods! !

!RWDiagramElementGroup methodsFor: 'as yet unclassified' stamp: ''!
dAllModelPackages
	"Returns a collection of RWDiagramElement"

	| packages noPackage |
	packages := Set new.
	noPackage := RWDiagramNoPackage new.
	elementList
		do: [ :each | 
			each famixElement
				ifNotNil: [ each famixElement class asString = self aFAMIXClass
						ifTrue: [ each dParentPackage
								ifNotNil: [ packages add: (each dParentPackage asRWDiagramElement: self) ]
								ifNil: [ noPackage add: each.
									packages add: noPackage asRWDiagramElement ] ] ] ].
	^ packages! !

!RWDiagramElementGroup methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
elementList
	^ elementList! !

!RWDiagramElementGroup methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
getElementForFAMIXElement: fe
	^ self apply: [ :e | e ] toAttribute: fe replace: false! !

!RWDiagramElementGroup methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
"A list with all Moose Entities"
  elementList := Dictionary new."OrderedCollection new"
"A list with all Moose Entities that are generated by me"
"  generatedElementsList := Dictionary new."! !

!RWDiagramElementGroup methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
replace: foundElement with: aMooseEntity
	elementList removeKey: foundElement uniqueKey ifAbsent: [  ].
	foundElement famixElement: aMooseEntity.
	elementList at: foundElement uniqueKey put: foundElement! !

!RWDiagramElementGroup methodsFor: 'initialization' stamp: ''!
setAccesses
	| pe1 ce1 pe2 ce2 |
	self elementList
		do: [ :el | 
			el famixElement class asString = self aFAMIXClass
				ifTrue: [ el famixElement methods
						do: [ :me | 
							me accesses
								do: [ :a | 
									| accessed elParent aParent |
									elParent := el famixElement m2mParentPackage.
									accessed := a variable.
									accessed class asString = self aFAMIXAttribute
										ifTrue: [ aParent := accessed parentType m2mParentPackage.	"Ignore cases when there are no parent packages"
											elParent
												ifNotNil: [ aParent
														ifNotNil: [ pe1 := self getElementForFAMIXElement: elParent.
															pe2 := self getElementForFAMIXElement: aParent.
															pe1 = pe2
																ifFalse: [ pe1 accessedTo: pe2 ] ] ].
											ce1 := self getElementForFAMIXElement: el famixElement.
											ce2 := self getElementForFAMIXElement: accessed parentType.
											ce1 = ce2
												ifFalse: [ ce1 accessedTo: ce2 ] ] ] ] ] ]! !

!RWDiagramElementGroup methodsFor: 'initialization' stamp: ''!
setConnections
	| pe1 ce1 pe2 ce2 |
	"Refresh all connections before settings"
	self elementList
		do: [ :el | 
			el famixElement class asString = self aFAMIXClass
				ifTrue: [ el famixElement methods
						do: [ :me | 
							(me queryAllOutgoingInvocations atScope: FAMIXMethod) storage
								do: [ :m | 
									| elParent mParent |
									elParent := el famixElement m2mParentPackage.
									mParent := m parentType m2mParentPackage.
									"Ignore cases when there are no parent packages"
									elParent
										ifNotNil: [ mParent
												ifNotNil: [ pe1 := self getElementForFAMIXElement: elParent.
													pe2 := self getElementForFAMIXElement: mParent.
													pe1 = pe2
														ifFalse: [ pe1 relatesTo: pe2 ] ] ].
									ce1 := self getElementForFAMIXElement: el famixElement.
									ce2 := self getElementForFAMIXElement: m parentType.
									ce1 = ce2
										ifFalse:
											[ "Now determine the FAMIX Element of the class and the package of the found method m. This is the target of the invocation. Determine class and package of the processed element el, this is the source of the found invocation. A similar logic is also to be done for the found accesses." ce1 relatesTo: ce2 ] ] ] ] ]! !

RWDiagram subclass: #RWDiagramLayoutManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramLayoutManager commentStamp: 'RainerWinkler 1/5/2018 09:28' prior: 0!
I manage all Layouts that are to be processed.
!

!RWDiagramLayoutManager methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
layoutsOfCurrentPath
	"comment stating purpose of message"

	| working |
	working := RWDiagram path asFileReference.
	^ (working children select: [ :e | e extension = 'xml' ]) collect: [ :e | e base ]! !

RWDiagram subclass: #RWDiagramSettings
	instanceVariableNames: 'isReading isReadingPosition packageBoxSuppressed classBoxSuppressed isReadingLayers offsetY preventOverlapping lCPORepeat lCPOSpace lCPOMaxChecks displayFormatter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramSettings commentStamp: 'RainerWinkler 8/13/2016 22:15' prior: 0!
I know all settings and preferences.!

!RWDiagramSettings methodsFor: 'displayformatters' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
displayFormatter
	"Shall the diagram be generated with informations on the formatting settings. Especially about the active appearance changers."

	displayFormatter ifNil: [ displayFormatter := false ].
	^ displayFormatter! !

!RWDiagramSettings methodsFor: 'displayformatters' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
displayFormatter: aBoolean 
	displayFormatter := aBoolean! !

!RWDiagramSettings methodsFor: 'initialization' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
	isReading := true.
	isReadingPosition := true.
	isReadingLayers := false.
	packageBoxSuppressed := false.
	classBoxSuppressed := false.
	preventOverlapping := false.
	lCPOSpace := 1.
	lCPORepeat := 100.
	lCPOMaxChecks := 100000! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isReading
	^ isReading.! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isReading: aBoolean
	isReading := aBoolean! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isReadingLayers
	^ isReadingLayers! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isReadingLayers: aBoolean
	isReadingLayers := aBoolean! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isReadingPosition
	^ isReadingPosition! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
isReadingPosition: aBoolean
	isReadingPosition := aBoolean! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPOMaxChecks
	^ lCPOMaxChecks! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPOMaxChecks: anInteger 
	lCPOMaxChecks := anInteger! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPORepeat
	lCPORepeat ifNil:[lCPORepeat := 1].
	^lCPORepeat! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPORepeat: anInteger 
	lCPORepeat := anInteger! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPOSpace
	lCPOSpace ifNil:[lCPOSpace := 1].
	^lCPOSpace! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
lCPOSpace: anInteger 
	lCPOSpace := anInteger! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
offsetY
	offsetY ifNil:[offsetY := 0].
	^offsetY! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
offsetY: anInteger 
	offsetY := anInteger! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
preventOverlapping
	preventOverlapping ifNil: [ preventOverlapping := false ].
	^ preventOverlapping! !

!RWDiagramSettings methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
preventOverlapping: aBoolean
  preventOverlapping := aBoolean! !

RWDiagram subclass: #RWDiagramSnapToGrid
	instanceVariableNames: 'startX startY gridX gridY history active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramSnapToGrid commentStamp: 'RainerWinkler 12/30/2017 21:27' prior: 0!
I manage snapping to grid

Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State a one line summary. For example, "I represent a paragraph of text".

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!RWDiagramSnapToGrid methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
active
	^active! !

!RWDiagramSnapToGrid methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
active: aTrue 
	active := aTrue! !

!RWDiagramSnapToGrid methodsFor: 'as yet unclassified' stamp: ''!
element: aFAMIXElement snap: aPoint 
   aFAMIXElement class moose2ModelName = self aFAMIXMethod ifTrue:[
	^self snap: aPoint].
   aFAMIXElement class moose2ModelName = self aFAMIXAttribute ifTrue:[
	^self snap: aPoint].
   ^aPoint! !

!RWDiagramSnapToGrid methodsFor: 'Accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
gridX
	^ gridX! !

!RWDiagramSnapToGrid methodsFor: 'setting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
gridX: anInteger 
	gridX := anInteger! !

!RWDiagramSnapToGrid methodsFor: 'Accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
gridY
	^ gridY! !

!RWDiagramSnapToGrid methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
gridY: anInteger 
	gridY := anInteger! !

!RWDiagramSnapToGrid methodsFor: 'Accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
initialize
   active := false.
	gridX := 10.
	gridY := 10.
	startX := 0.
	startY := 0.! !

!RWDiagramSnapToGrid methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
reset
	history := Dictionary new.! !

!RWDiagramSnapToGrid methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
snap: aPoint
	| xRound yRound rounded |
	self active
		ifFalse: [ ^ aPoint ]
		ifTrue: [ history ifNil: [ history := Dictionary new ].
			xRound := startX + (aPoint x - startX roundTo: gridX).
			yRound := startY + (aPoint y - startY roundTo: gridY).
			rounded := xRound @ yRound
			"[ history at: rounded ifAbsent: false ] whileTrue: [ rounded := rounded + (1 @ 1) ].
			history at: rounded put: true" ].
	^ rounded! !

!RWDiagramSnapToGrid methodsFor: 'accessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
startX
	^ startX! !

!RWDiagramSnapToGrid methodsFor: 'settings' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
startX: anInteger 
	startX := anInteger! !

!RWDiagramSnapToGrid methodsFor: 'acccessing' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
startY
	^ startY! !

!RWDiagramSnapToGrid methodsFor: 'setting' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
startY: anInteger 
	startY := anInteger! !

Object subclass: #RWDiagramNoPackage
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RWMooseDiagram-editor'!

!RWDiagramNoPackage commentStamp: 'RainerWinkler 8/29/2016 22:20' prior: 0!
I am used to handle not existing parent packages.!

!RWDiagramNoPackage class methodsFor: 'naming' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self name! !

!RWDiagramNoPackage methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
add: aRWDiagramElement 
	classes ifNil:[classes := OrderedCollection new].
	classes add: aRWDiagramElement famixElement! !

!RWDiagramNoPackage methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
asRWDiagramElement
"Replace with asRWDiagramElement: aRWDiagramElementGroupOrLayoutOrEditor in most cases"
	^ RWDiagramElement famixElement: self! !

!RWDiagramNoPackage methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
classes
	^classes! !

!RWDiagramNoPackage methodsFor: 'naming' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
moose2ModelName
	^self asString! !

!RWDiagramNoPackage methodsFor: 'as yet unclassified' stamp: 'CompatibleUserName 8/30/2019 13:38:06'!
mooseID
"No comments or linking to no Package possible"
	^0! !
